/// <reference path="../../libs/js/action.js" />
/// <reference path="../../libs/js/stream-deck.js" />
/**
 * The first event fired when Stream Deck starts
 */


const clientId = Date.now()
var statemachineInfo = ''
var networkIsError = null
getStatemachine()

function getStatemachine() {
    if (baseURL) {
        request('/mwapi/statemachine', {
            body: {
                client: clientId
            }
        }).then(data => {
            if (data.status === 0) {
                switch (pluginAction) {
                    case 'com.magewell.magewell-director.show':
                        getStatemachineShowChange(data)
                        break;
                    case 'com.magewell.magewell-director.scene':
                        getStatemachineScene(data)
                        break;
                    case 'com.magewell.magewell-director.gfx':
                        getStatemachineGfxChange(data)
                        break;
                    case 'com.magewell.magewell-director.stream':
                        getStatemachineStreamChange(data)
                        break;
                    case 'com.magewell.magewell-director.audio-mixer':
                        getStatemachineAudioMixerChange(data);
                        break;

                    case 'com.magewell.magewell-director.bgm':
                        getStatemachineBgmChange(data);
                        break;
                    case 'com.magewell.magewell-director.volume':
                        getStatemachineVolumeChange(data);
                        break;
                    case 'com.magewell.magewell-director.ptz':
                        getStatemachinePtzDeviceChange(data);
                        break;
                    case 'com.magewell.magewell-director.replay':
                            getStatemachineReplayChange(data)
                        break;
                    case 'com.magewell.magewell-director.shortcuts':
                        getStatemachineShortcutChange(data)
                        break;
                    case 'com.magewell.magewell-director.other':
                        break;
                }

                // getStatemachineVolumeConfigChange(data)

                // getStatemachinePtzChange(data)

                // getAudioMixerChange(data)

            }
            this.delayGetStatemachine()
        }).catch(err => {
            this.delayGetStatemachine()
        });
    } else {
        this.delayGetStatemachine()
    }
}
function delayGetStatemachine() {
    setTimeout(() => {
        getStatemachine()
    }, 2000)
}

var pluginAction = null,
    uuid = '',
    oValueSelector = document.querySelector(".setvalueSelect"),
    setGlobalSettings = {},
    actionInfo = {},
    controller = 'Keypad'

if ($PI) {
    console.log('$PI', $PI)
    $PI.onConnected((jsonObj) => {
        uuid = jsonObj['uuid'];
        actionInfo = jsonObj.actionInfo
        if (jsonObj.hasOwnProperty('actionInfo')) {
            pluginAction = jsonObj.actionInfo['action'];
        }
        setGlobalSettings = actionInfo.payload.settings

        controller = actionInfo.payload.controller
        isBaseUrlHave()
        $PI.getGlobalSettings()

        $PI.getSettings();

    });

    // 全局的信息变更
    $PI.onDidReceiveGlobalSettings((e) => {
        const setting =  e.payload.settings
        console.log('onDidReceiveGlobalSettings', e)
        if (setting.hasOwnProperty('baseURL')) {
            baseURL = setting.baseURL
            networkIsError = setting?.networkIsError??null
            setGlobalSettings.baseURL = baseURL
            setGlobalSettings.networkIsError = networkIsError


            // 将部分列表信息存储到每个按键
            $PI.send(uuid,
                'setSettings', {
                    action: pluginAction,
                    payload: setGlobalSettings || {}
                }, false)

            // $PI.sendToPlugin(payload)
            $PI.setGlobalSettings(setGlobalSettings)

        }
        isShowBaseURL(setting)
    })
}

// 判断baseUrl是否有值
function isBaseUrlHave() {
    if (baseURL && networkIsError) {
        switch (pluginAction) {
            case 'com.magewell.magewell-director.show':
                getShowActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.scene':
                getSceneActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.gfx':
                getGfxActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.transition':
                getTransitionActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.stream':
                getStreamActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.record':
                getRecordActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.video':
                getVideoActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.bgm':
                getBgmActionInfo(actionInfo);
                break;

            case 'com.magewell.magewell-director.audio-mixer':
                getVolumeActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.scoreboard':
                getScoreboardActionInfo(actionInfo);
                break;

            case 'com.magewell.magewell-director.volume':
                getVolumeEncodeActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.timer':
                getTimerActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.stopwatch':
                getStopwatchActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.ptz':
                getPtzActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.replay':
                getReplayActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.webpage':
                getWebpageActionInfo(actionInfo);
                break;
            case 'com.magewell.magewell-director.shortcuts':
                getShortcutActionInfo(actionInfo);
                break;


            case 'com.magewell.magewell-director.other':
                getOtherActionInfo(actionInfo);
                break;
        }
    } else {
        setTimeout(() => {
            isBaseUrlHave()
        }, 1000)
    }
}

// 弹窗填写的ip
const channel = new BroadcastChannel('myChannel');
channel.addEventListener('message', (event) => {
    baseURL = event.data
    // const payload = {
    //     baseURL: baseURL
    // }
    let payload = setGlobalSettings
    setGlobalSettings.baseURL = baseURL
    isShowBaseURL()
    $PI.setGlobalSettings(payload)

});

// 数据存储在按键
function setSettingInKey2(params) {
    setGlobalSettings.baseURL = baseURL
    let payloadP = Object.assign(setGlobalSettings, params);

    $PI.send(uuid,
        'setSettings', {
            action: pluginAction,
            payload: payloadP || {}
        }, false)
}

// 打开输入ip的弹窗
let openIpWindow = document.getElementById('open-get-ip-window');

openIpWindow.addEventListener('click', () => {
    window.open(`../template/setup/index.html`);
})

// 是否展示ip地址
function isShowBaseURL(setting) {
    var openIpDoc = document.getElementById('open-get-ip-window')
    if (baseURL) {
        if (!(setting?.networkIsError??true)) {
            openIpDoc.innerHTML = `Please connect Magewell Director </br> IP: ${baseURL} Change`
            document.getElementById('content').innerHTML = ''
        } else {
            openIpDoc.innerHTML = `IP: ${baseURL} Change`
            isBaseUrlHave()
        }
    } else {
        openIpDoc.innerHTML = `Input IP Address`
    }
}
