var volumeInfo = {
  selFunction: null,
  selFuntionItem: null,
  title: '',
  iconPath: 'volumeProgramOption-0',
  ProgramType: 3,
  PreviewType: 4,
  MonitorType: 1,
  MicType: 512,
  HDMI1Type: 1792,
  HDMI2Type: 2048,
  BluetoothType: 768,
  selStateVolumeDb: 0,
  selMonitorDevice: null,
  monitorDeviceItem: null,
  selUsbAudioType: null,
  selUsbAudioItem: null,
  selScope: null,
  selScopeItem: null,
  selStateAlways: null,
  selStateAlwaysItem: null,
  selStream: null,
  selStreamItem: null,
  selVideo: null,
  selVideoItem: null,
  selWebpage: null,
  selWebpageItem: null,
  delayVolumeTime: 0,
  selInput: null,
  selInputItem: null,
  delayVolumeTimeTitle: '0ms',
  selGfx: null,
  selGfxItem: null,
  selAdjustVol: null,
  selAdjustItem: null,
  selStateMute: null,
  stateMuteItem: null,
  selSolo: null,
  selSoloItem: null,
  mixState: null,
  mixStateItem: null
} // 按键中需要存在的字段


var functionVolumeOption = [
  { name: 'volumeProgramOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute', paramsKey: { type: 'ProgramType', state: 'selStateMute' }, title: 'PROGRAM', path: 'volumeProgramOption' },
  { name: 'volumeProgramVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol', paramsKey: { type: 'ProgramType', volumeChange: 'selAdjustVol' }, title: 'PROGRAM', path: 'adjustVolume' },
  { name: 'volumePreviewOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute',paramsKey: { type: 'PreviewType', state: 'selStateMute' }, title: 'PREVIEW', path: 'volumeProgramOption' },
  { name: 'volumePreviewVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'PreviewType', volumeChange: 'selAdjustVol' }, title: 'PREVIEW', path: 'adjustVolume' },
  { name: 'volumeMonitorOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute', paramsKey: { type: 'MonitorType', state: 'selStateMute' }, title: 'MONITOR', path: 'volumeProgramOption' },
  { name: 'volumeMonitorVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'MonitorType', volumeChange: 'selAdjustVol' }, title: 'MONITOR', path: 'adjustVolume' },
  { name: 'volumeMonitorDevice', value: '/V1.0/volume/setMonitorDevice', isNext: 'monitorDeviceItem', paramsKey: { deviceId: 'monitorDeviceItem', deviceType: 'monitorDeviceItem', cardNo: 'monitorDeviceItem', devNo: 'monitorDeviceItem' }, title: 'volumeMonitorDevice', path: 'volumeMonitorDevice' },
  { name: 'volumeMicOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute', paramsKey: { type: 'MicType', state: 'selStateMute' },title: 'Mic', path: 'volumeProgramOption' },
  { name: 'volumeMicVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'MicType', volumeChange: 'selAdjustVol' }, title: 'Mic', path: 'adjustVolume' },
  { name: 'volumeBluetoothOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute', paramsKey: { type: 'BluetoothType', state: 'selStateMute' }, title: 'Bluetooth', path: 'volumeProgramOption' },
  { name: 'volumeBluetoothVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'BluetoothType', volumeChange: 'selAdjustVol' }, title: 'Bluetooth', path: 'adjustVolume' },
  { name: 'volumeUsbAudioOption', value: '/V1.0/volume/setState', isNext: 'selUsbAudioItem', pathParams: 'selStateMute', paramsKey: { type: 'selUsbAudioType', state: 'selStateMute' }, title: 'UsbAudio', path: 'volumeProgramOption' },
  { name: 'volumeUsbAudioVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selUsbAudioItem', pathParams: 'selAdjustVol',paramsKey: { type: 'selUsbAudioType', volumeChange: 'selAdjustVol' }, title: 'UsbAudio', path: 'adjustVolume' },
  { name: 'volumeHDMI1ActionScope', value: '/V1.0/volume/setScope', pathParams: 'selScope', paramsKey: { type: 'HDMI1Type', scope: 'selScope' }, title: 'hdmi1', path: 'actionScope' },
  { name: 'volumeHDMI1GlobalOption', value: '/V1.0/volume/setState', pathParams: 'selStateAlways', paramsKey: { type: 'HDMI1Type', state: 'selStateAlways' },title: 'hdmi1', path: 'globalOption' },
  { name: 'volumeHDMI1SceneOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute', paramsKey: { type: 'HDMI1Type', state: 'selStateMute' }, title: 'hdmi1', path: 'sceneOption' },
  { name: 'volumeHDMI1Volume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'HDMI1Type', volumeChange: 'selAdjustVol' }, title: 'hdmi1', path: 'adjustVolume' },
  { name: 'volumeHDMI2ActionScope', value: '/V1.0/volume/setScope', pathParams: 'selScope', paramsKey: { type: 'HDMI2Type', scope: 'selScope' },title: 'hdmi2', path: 'actionScope' },
  { name: 'volumeHDMI2GlobalOption', value: '/V1.0/volume/setState', pathParams: 'selStateAlways',paramsKey: { type: 'HDMI2Type', state: 'selStateAlways' }, title: 'hdmi2', path: 'globalOption' },
  { name: 'volumeHDMI2SceneOption', value: '/V1.0/volume/setState', pathParams: 'selStateMute', paramsKey: { type: 'HDMI2Type', state: 'selStateMute' }, title: 'hdmi2', path: 'sceneOption' },
  { name: 'volumeHDMI2Volume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'HDMI2Type', volumeChange: 'selAdjustVol' }, title: 'hdmi2', path: 'adjustVolume' },
  { name: 'volumeStreamActionScope', value: '/V1.0/volume/setScope', isNext: 'selStreamItem', pathParams: 'selScope', paramsKey: { type: 'selStream', scope: 'selScope' }, title: 'stream', path: 'actionScope' },
  { name: 'volumeStreamGlobalOption', value: '/V1.0/volume/setState', isNext: 'selStreamItem',pathParams: 'selStateAlways',paramsKey: { type: 'selStream', state: 'selStateAlways' }, title: 'stream', path: 'globalOption' },
  { name: 'volumeStreamSceneOption', value: '/V1.0/volume/setState', isNext: 'selStreamItem',pathParams: 'selStateMute', paramsKey: { type: 'selStream', state: 'selStateMute' }, title: 'stream', path: 'sceneOption' },
  { name: 'volumeStreamVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selStreamItem',pathParams: 'selAdjustVol',paramsKey: { type: 'selStream', volumeChange: 'selAdjustVol' }, title: 'stream', path: 'adjustVolume' },
  { name: 'volumeVideoActionScope', value: '/V1.0/volume/setScope', isNext: 'selVideoItem',pathParams: 'selScope', paramsKey: { type: 'selVideo', scope: 'selScope' }, title: 'video', path: 'actionScope' },
  { name: 'volumeVideoOption', value: '/V1.0/volume/setState', isNext: 'selVideoItem',pathParams: 'selStateMute', paramsKey: { type: 'selVideo', state: 'selStateMute' }, title: 'video', path: 'volumeProgramOption' },
  { name: 'volumeVideoVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selVideoItem',pathParams: 'selAdjustVol',paramsKey: { type: 'selVideo', volumeChange: 'selAdjustVol' }, title: 'video', path: 'adjustVolume' },
  // { name: 'volumeWebpageActionScope', value: '/V1.0/volume/setScope',isNext: 'selWebpageItem', pathParams: 'selScope', paramsKey: { type: 'selWebpage', scope: 'selScope' }, title: 'webpage', path: 'actionScope' },
  // { name: 'volumeWebpageGlobalOption', value: '/V1.0/volume/setState',isNext: 'selWebpageItem', pathParams: 'selStateAlways',paramsKey: { type: 'selWebpage', state: 'selStateAlways' }, title: 'webpage', path: 'globalOption' },
  { name: 'volumeWebpageOption', value: '/V1.0/volume/setState',isNext: 'selWebpageItem', pathParams: 'selStateMute', paramsKey: { type: 'selWebpage', state: 'selStateMute' }, title: 'webpage', path: 'sceneOption' },
  { name: 'volumeWebpageVolume', value: '/V1.0/volume/adjustVolume',isNext: 'selWebpageItem', pathParams: 'selAdjustVol', paramsKey: { type: 'selWebpage', volumeChange: 'selAdjustVol' }, title: 'webpage', path: 'adjustVolume' },
  { name: 'volumeGfxOption', value: '/V1.0/volume/setState', isNext: 'selGfxItem',pathParams: 'selStateMute', paramsKey: { type: 'selGfx', state: 'selStateMute' }, title: 'gfx', path: 'volumeProgramOption' },
  { name: 'volumeGfxVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selGfxItem',pathParams: 'selAdjustVol', paramsKey: { type: 'selGfx', volumeChange: 'selAdjustVol' }, title: 'gfx', path: 'adjustVolume' },
  { name: 'volumeAudioInputDelay', value: '/V1.0/volume/setInputDeviceDelay', isNext: 'delayVolumeTimeTitle', paramsKey: { device: 'selInput', delay: 'delayVolumeTime' }, title: '', path: '' },
  { name: 'OutputMicrophoneToMonitorDevice', pathParams: 'mixState', value: '/V1.0/volume/monitorMicInput', paramsKey: { on: 'mixState' }, title: 'mic-monitor', path: 'micOutput' },
  { name: 'OutputMicrophoneSoundUSBC', pathParams: 'mixState', value: '/V1.0/volume/outputMicToUsb', paramsKey: { on: 'mixState' }, title: 'mic-usb-c', path: 'micOutput' },
  { name: 'volumeSoloMonitor', pathParams: 'mixState', value: '/V1.0/volume/solo', isNext: 'selSoloItem', paramsKey: { type: 'selSolo', on: 'mixState' }, title: '', path: 'soloMonito' },
]

// 静音、不静音的option
var volumeSetStateOptList = [
  { value: 0,  name: 'audioOn' },
  { value: 1,  name: 'audioOff' }
]

// 是否有设置静音不静音的name集合
var hasVolumeMuteStateArr = ['volumeProgramOption', 'volumePreviewOption', 'volumeMonitorOption', 'volumeMicOption', 'volumeBluetoothOption', 'volumeUsbAudioOption', 'volumeHDMI1SceneOption', 'volumeHDMI2SceneOption',
  'volumeVideoOption', 'volumeStreamSceneOption', 'volumeWebpageOption', 'volumeGfxOption']

// 是否有设置音量功能的name集合
var hasVolumeDBStateArr = ['volumeProgramVolume', 'volumePreviewVolume', 'volumeMonitorVolume', 'volumeMicVolume', 'volumeBluetoothVolume', 'volumeUsbAudioVolume', 'volumeHDMI1Volume', 'volumeHDMI2Volume',
  'volumeVideoVolume', 'volumeStreamVolume', 'volumeWebpageVolume', 'volumeGfxVolume']

// 是否有scope 全局/私有
var hasScopeVolumeListArr = ['volumeHDMI1ActionScope', 'volumeHDMI2ActionScope', 'volumeVideoActionScope', 'volumeStreamActionScope', 'volumeWebpageActionScope']

// 是否有静音、不静音、AFV 
var hasAlwaysAfvStateArr = ['volumeHDMI1GlobalOption', 'volumeHDMI2GlobalOption', 'volumeStreamGlobalOption', 'volumeWebpageGlobalOption']

// 是否有设置音量功能的name集合
var hasUsbAudioListArr = ['volumeUsbAudioOption', 'volumeUsbAudioVolume']

// 是否有设置video的name集合
var hasVideoListArr = ['volumeVideoActionScope', 'volumeVideoOption', 'volumeVideoVolume']

// 是否有设置stream的name集合
var hasStreamListArr = ['volumeStreamActionScope', 'volumeStreamGlobalOption', 'volumeStreamSceneOption', 'volumeStreamVolume']

// 是否有设置webpage的name集合
var hasWebpageListArr = ['volumeWebpageActionScope', 'volumeWebpageGlobalOption', 'volumeWebpageOption', 'volumeWebpageVolume']

// 是否有设置gfx的name集合
var hasGfxListArr = ['volumeGfxOption', 'volumeGfxVolume']

// 是否有设置混音、不混音的name集合
var hasMixerVolumeListArr = ['OutputMicrophoneToMonitorDevice', 'OutputMicrophoneSoundUSBC', 'volumeSoloMonitor']

// 是否有设置solo mixer的name集合
var hasSoloVolumeListArr = ['volumeSoloMonitor']
// 是否有设置input device的name集合
var hasInputVolumeListArr = ['volumeAudioInputDelay']
// 是否有设置input device delay的name集合
var hasSetInputDelayVolumeArr = ['volumeAudioInputDelay']
// scope option
var scopeVolumeOption = [
  { value: 0,  name: 'global' },
  { value: 1,  name: 'scene' }
]
// volume option
var adjustVolumeOption = [
  { value: -1,  name: '-1dB' },
  { value: 1,  name: '+1dB' }
]

// 静音、不静音、AFV 的option
var volumeSetStateAfvOptList = [
  { value: 2,  name: 'afv' },
  { value: 0,  name: 'alwaysOn' },
  { value: 1,  name: 'alwaysOff' }
]

// 混音、不混音的option
var volumeMixerStateOptList = [
  { value: true,  name: 'on' },
  { value: false,  name: 'off' }
]
var monitorDeviceList = [] // monitor
var usbAudioVolumeList = [] // usbAudio
var streamVolumeList = [] // stream
var videoDeviceList = [] // Video
var webpageDeviceList = []  // webpage
var gfxDeviceList = [] // gfx
var mixerSoloDevice = [] // solo device
var inputDelayDevice = [] // input delay

async function getStatemachineAudioMixerChange (val) {
  console.log(val.showListChanged)
  if (val.monitorAudioDeviceListChanged) {
    await getMonitorDeviceList()
    isAddMonitorDeviceOption()
  }

  if (val.shortcutFunctionParamsChanged) {
    await getUsbAudioDeviceList()
    // 设置usb audio list
    const usbAudioList = usbAudioVolumeList
    let selUsbAudio = volumeInfo.selUsbAudioType
    if (usbAudioList.length > 0) {
      const isHav = usbAudioList.some(item => {
        return item.type == volumeInfo.selUsbAudioType
      })

      if (!isHav) {
        selUsbAudio = usbAudioList[0].type
        volumeInfo.selUsbAudioItem = usbAudioList[0]
        volumeInfo.selUsbAudioType = usbAudioList[0].type
        volumeInfo.title = usbAudioList[0].name
        setSettingVolume()
      }
    } else {
      selUsbAudio = ''
    }
    mlwTools.dropDown(false, 'usbAudioVolumeSel', usbAudioVolumeList, 'name', 'type', selUsbAudio);

    await getStreamDeviceList()
    const streamList = streamVolumeList
    let selStream = volumeInfo.selStream
    if (streamList.length > 0) {
      const isHav = streamList.some(item => {
        return item.type == volumeInfo.selStream
      })

      if (!isHav) {
        selStream = streamList[0].type
        volumeInfo.selStreamItem = streamList[0]
        volumeInfo.selStream = streamList[0].type
        volumeInfo.title = streamList[0].name
        setSettingVolume()
      }
    } else {
      selStream = ''
    }
    mlwTools.dropDown(false, 'streamVolumeSel', streamVolumeList, 'name', 'type', selStream);

    await getVideoDeviceList()
    const VideoList = videoDeviceList
    let selVideo = volumeInfo.selVideo
    if (VideoList.length > 0) {
      const isHav = VideoList.some(item => {
        return item.type == volumeInfo.selVideo
      })

      if (!isHav) {
        selVideo = VideoList[0].type
        volumeInfo.selVideoItem = VideoList[0]
        volumeInfo.selVideo = VideoList[0].type
        volumeInfo.title = VideoList[0].name
        setSettingVolume()
      }
    } else {
      selVideo = ''
    }
    mlwTools.dropDown(false, 'videoVolumeSel', videoDeviceList, 'name', 'type', selVideo);

    await getWebpageDeviceList()
    const WebpageList = webpageDeviceList
    let selWebpage = volumeInfo.selWebpage
    if (WebpageList.length > 0) {
      const isHav = WebpageList.some(item => {
        return item.type == volumeInfo.selWebpage
      })

      if (!isHav) {
        selWebpage = WebpageList[0].type
        volumeInfo.selWebpageItem = WebpageList[0]
        volumeInfo.selWebpage = WebpageList[0].type
        volumeInfo.title = WebpageList[0].name
        setSettingVolume()
      }
    } else {
      selWebpage = ''
    }
    mlwTools.dropDown(false, 'webpageVolumeSel', webpageDeviceList, 'name', 'type', selWebpage);

    await getGfxDeviceList()
    const gfxList = gfxDeviceList
    let selGfx = volumeInfo.selGfx
    if (gfxList.length > 0) {
      const isHav = gfxList.some(item => {
        return item.type == volumeInfo.selGfx
      })

      if (!isHav) {
        selGfx = gfxList[0].type
        volumeInfo.selGfxItem = gfxList[0]
        volumeInfo.selGfx = gfxList[0].type
        volumeInfo.title = gfxList[0].name
        setSettingVolume()
      }
    } else {
      selGfx = ''
    }
    mlwTools.dropDown(false, 'gfxVolumeSel', gfxDeviceList, 'name', 'type', selGfx);

    await getMixerSoloDeviceList()
    const mixerSoloList = mixerSoloDevice
    let selSolo = volumeInfo.selSolo
    if (mixerSoloList.length > 0) {
      const isHav = mixerSoloList.some(item => {
        return item.type == volumeInfo.selSolo
      })

      if (!isHav) {
        selSolo = mixerSoloList[0].type
        volumeInfo.selSoloItem = mixerSoloList[0]
        volumeInfo.selSolo = mixerSoloList[0].type
        volumeInfo.title = mixerSoloList[0].name
        setSettingVolume()
      }
    } else {
      selSolo = ''
    }
    mlwTools.dropDown(false, 'soloVolumeStateSel', mixerSoloDevice, 'name', 'type', selSolo);


    await getInputDelayDeviceList()
    const inputDelayList = inputDelayDevice
    let selInput = volumeInfo.selInput
    if (inputDelayList.length > 0) {
      const isHav = inputDelayList.some(item => {
        return item.type == volumeInfo.selInput
      })

      if (!isHav) {
        selInput = inputDelayList[0].type
        volumeInfo.selInputItem = inputDelayList[0]
        volumeInfo.selInput = inputDelayList[0].type
        volumeInfo.title = inputDelayList[0].name
        setSettingVolume()
      }
    } else {
      selInput = ''
    }
    mlwTools.dropDown(false, 'inputVolumeDelaySel', inputDelayDevice, 'name', 'type', selInput);
  }
}

// 获取 solo mixer 列表请求
async function getMixerSoloDeviceList() {
  try {
    const response = await request('/V1.0/volume/getInputMixersForSolo');
    if (response.status === 0) {
      const list = response.audioList

      mixerSoloDevice = [...list]
    }
  } catch (err) {
    console.error('Error fetching Mixer Solo Audio list:', err);
    throw err;
  }
}

// 获取 input delay 列表请求
async function getInputDelayDeviceList() {
  try {
    const response = await request('/V1.0/volume/getInputDeviceForDelay');
    if (response.status === 0) {
      const list = response.audioList
      list.forEach(item => {
        if (item.type == 512 || item.type == 513) {
          item.iconName = 'mic'
        } else if (item.type == '1792') {
          item.iconName = 'hdmi1'
        } else if (item.type == '2048') {
          item.iconName = 'hdmi2'
        } else {
          item.iconName = 'usb'
        }
      })
      inputDelayDevice = [...list]
      console.log('getInputDelayDeviceList', inputDelayDevice)
    }
  } catch (err) {
    console.error('Error fetching Input Delay Audio list:', err);
    throw err;
  }
}

// 数据存储在按键
function setSettingVolume () {
  const info = {
    volumeInfo: volumeInfo
  }
  setSettingInKey2(info)
}

async function getVolumeActionInfo (actionInfo) {
  await getMonitorDeviceList()
  await getUsbAudioDeviceList()
  await getVideoDeviceList()
  await getStreamDeviceList()
  await getWebpageDeviceList()
  await getGfxDeviceList()
  await getMixerSoloDeviceList()
  await getInputDelayDeviceList()
  
  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('volumeInfo')) {
    settingInfo = settings.volumeInfo
  }
  // 查找需要的字段
  const findKey = ['selFunction', 'selFuntionItem', 'title', 'iconPath', 'ProgramType', 'PreviewType', 'MonitorType', 'MicType',
  'HDMI1Type', 'HDMI2Type','BluetoothType', 'selStateMute', 'stateMuteItem', 'selStateVolumeDb', 'selMonitorDevice', 'monitorDeviceItem',
  'selUsbAudioType', 'selUsbAudioItem', 'selScope', 'selScopeItem', 'selStateAlways', 'selStateAlwaysItem', 'selStream', 'selStreamItem',
  'selVideo', 'selVideoItem', 'selWebpage', 'selWebpageItem', 'selGfx', 'selGfxItem', 'mixState', 'mixStateItem', 'selSolo', 'selSoloItem',
  'delayVolumeTime', 'selInput', 'selInputItem', 'delayVolumeTimeTitle', 'selAdjustVol', 'selAdjustItem']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      volumeInfo[item] = settingInfo[item]
    } else {
      volumeInfo[item] = volumeInfo[item] === null ? null : volumeInfo[item]
    }
  })

  getVolumeInfoFunctionDom()
}

/* <div type="range" class="sdpi-item" id="setVolumeDBOptionID">
<div class="sdpi-item-label"> ${$PI.localization.volume.volumedB}</div>
<div class="sdpi-item-value">
<span class="clickable" value=-40>-40</span>
<input class="floating-tooltip" data-suffix="" type="range" id="adjustVolumeDbSlider" min="-40" max="10" step="1" value="${volumeInfo.selStateVolumeDb}">
<span class="clickable" value="10">10</span>
</div>
</div> */
function getVolumeInfoFunctionDom () {
  
  // 初始值
  if (volumeInfo.selFunction === null) {
    volumeInfo.selFunction = functionVolumeOption[0].name
    volumeInfo.selFuntionItem = functionVolumeOption[0]
    volumeInfo.title = functionVolumeOption[0].title
    // volumeInfo.iconPath = functionVolumeOption[0].path
    setSettingVolume()
  }


  // 创建功能下拉菜单
  document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="volumeFunOptionSel"></select>
    </div>
    <div class="sdpi-item" id="usbAudioVolumeListId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.deviceName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="usbAudioVolumeSel"></select>
    </div>
    <div class="sdpi-item" id="streamVolumeListId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.streamName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="streamVolumeSel"></select>
    </div>
    <div class="sdpi-item" id="webpageVolumeListId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.webpageName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="webpageVolumeSel"></select>
    </div>
    <div class="sdpi-item" id="gfxVolumeListId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.gfxName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="gfxVolumeSel"></select>
    </div>
    <div class="sdpi-item" id="videoVolumeListId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.videoClipName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="videoVolumeSel"></select>
    </div>
    <div class="sdpi-item" id="soloVolumeOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.audioInput} </div>
      <select class="sdpi-item-value select setvalueSelect" id="soloVolumeStateSel"></select>
    </div>
    <div class="sdpi-item" id="setVolumeMuteOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.option} </div>
      <select class="sdpi-item-value select setvalueSelect" id="volumeMuteOptionSel"></select>
    </div>
    <div class="sdpi-item" id="setVolumeDBOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.volumedB} </div>
      <select class="sdpi-item-value select setvalueSelect" id="volumeDBOptionSel"></select>
    </div>

    <div class="sdpi-item" id="monitorListOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.deviceName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="monitorDeviceSel"></select>
    </div>
    <div class="sdpi-item" id="setVolumeScopeOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.actionScope} </div>
      <select class="sdpi-item-value select setvalueSelect" id="volumeScopeOptionSel"></select>
    </div>
    <div class="sdpi-item" id="alwaysAfvStateOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.option} </div>
      <select class="sdpi-item-value select setvalueSelect" id="alwaysAfvStateSel"></select>
    </div>
    <div class="sdpi-item" id="mixerVolumeOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.option} </div>
      <select class="sdpi-item-value select setvalueSelect" id="mixerVolumeStateSel"></select>
    </div>

    <div class="sdpi-item" id="inputVolumeOptionID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.audioInput} </div>
      <select class="sdpi-item-value select setvalueSelect" id="inputVolumeDelaySel"></select>
    </div>
    <div type="range" class="sdpi-item" id="inputVolumeDelayId">
      <div class="sdpi-item-label"> ${$PI.localization.volume.delayMs}</div>
      <div class="sdpi-item-value">
      <span class="clickable" value=0>0</span>
      <input class="floating-tooltip" data-suffix="" type="range" id="adjustDelayVolumeTime" min="0" max="400" step="1" value="${volumeInfo.delayVolumeTime}">
      <span class="clickable" value="400">400</span>
      </div>
    </div>
  `;

  initToolTips();

  const FunOptionDom = document.getElementById('volumeFunOptionSel');
  mlwTools.dropDown($PI.localization.volume, 'volumeFunOptionSel', functionVolumeOption, 'name', 'name', volumeInfo.selFunction);
  FunOptionDom.addEventListener('change', sendVolumeFuncionPlugin);

  // 设置静音、不静音的默认值
  setVolumeListOptionDefaultItem(volumeSetStateOptList[0], 'value', 'selStateMute', 'stateMuteItem')
  mlwTools.dropDown($PI.localization.volume, 'volumeMuteOptionSel', volumeSetStateOptList, 'name', 'value', volumeInfo.selStateMute);
  document.getElementById('volumeMuteOptionSel').addEventListener('change', changeVolMuteStateFun);


  // document.getElementById('adjustVolumeDbSlider').addEventListener('input', adjustVolumeDbChanged);
  // Adjust volume
  mlwTools.dropDown(false, 'volumeDBOptionSel', adjustVolumeOption, 'name', 'value', volumeInfo.selAdjustVol);
  document.getElementById('volumeDBOptionSel').addEventListener('change', adjustVolumeDbChanged);
  setVolumeListOptionDefaultItem(adjustVolumeOption[0], 'value', 'selAdjustVol', 'selAdjustItem')

  // 设置Stream Audio list
  mlwTools.dropDown(false, 'streamVolumeSel', streamVolumeList, 'name', 'type', volumeInfo.selStream);
  document.getElementById('streamVolumeSel').addEventListener('change', changeStreamVolumeDevice);
  setVolumeListOptionDefaultItem(streamVolumeList[0], 'type', 'selStream', 'selStreamItem')

  // 设置Webpage Audio list
  mlwTools.dropDown(false, 'webpageVolumeSel', webpageDeviceList, 'name', 'type', volumeInfo.selWebpage);
  document.getElementById('webpageVolumeSel').addEventListener('change', changeWebpageVolumeDevice);
  setVolumeListOptionDefaultItem(webpageDeviceList[0], 'type', 'selWebpage', 'selWebpageItem')

  // 设置gfx Audio list
  mlwTools.dropDown(false, 'gfxVolumeSel', gfxDeviceList, 'name', 'type', volumeInfo.selGfx);
  document.getElementById('gfxVolumeSel').addEventListener('change', changeGfxVolumeDevice);
  setVolumeListOptionDefaultItem(gfxDeviceList[0], 'type', 'selGfx', 'selGfxItem')

  // 设置usb audio list
  mlwTools.dropDown(false, 'usbAudioVolumeSel', usbAudioVolumeList, 'name', 'type', volumeInfo.selUsbAudioType);
  document.getElementById('usbAudioVolumeSel').addEventListener('change', changeUsbAudioVolumeDevice);
  setVolumeListOptionDefaultItem(usbAudioVolumeList[0], 'type', 'selUsbAudioType', 'selUsbAudioItem')

  // 设置video list
  mlwTools.dropDown(false, 'videoVolumeSel', videoDeviceList, 'name', 'type', volumeInfo.selVideo);
  document.getElementById('videoVolumeSel').addEventListener('change', changeVideoVolumeDevice);
  setVolumeListOptionDefaultItem(videoDeviceList[0], 'type', 'selVideo', 'selVideoItem')

  // 设置scope 全局/私有
  mlwTools.dropDown($PI.localization.volume, 'volumeScopeOptionSel', scopeVolumeOption, 'name', 'value', volumeInfo.selScope);
  document.getElementById('volumeScopeOptionSel').addEventListener('change', changeScopeVolumeDevice);
  setVolumeListOptionDefaultItem(scopeVolumeOption[0], 'value', 'selScope', 'selScopeItem')

  // 静音、不静音、AFV 的option
  mlwTools.dropDown($PI.localization.volume, 'alwaysAfvStateSel', volumeSetStateAfvOptList, 'name', 'value', volumeInfo.selStateAlways);
  document.getElementById('alwaysAfvStateSel').addEventListener('change', changeAlwaysAfvDevice);
  setVolumeListOptionDefaultItem(volumeSetStateAfvOptList[0], 'value', 'selStateAlways', 'selStateAlwaysItem')

  // 混音、混音 的option
  mlwTools.dropDown($PI.localization.volume, 'mixerVolumeStateSel', volumeMixerStateOptList, 'name', 'value', volumeInfo.mixState);
  document.getElementById('mixerVolumeStateSel').addEventListener('change', changeMixerVolumeDevice);
  setVolumeListOptionDefaultItem(volumeMixerStateOptList[0], 'value', 'mixState', 'mixStateItem')

  // solo 的option
  mlwTools.dropDown(false, 'soloVolumeStateSel', mixerSoloDevice, 'name', 'type', volumeInfo.selSolo);
  document.getElementById('soloVolumeStateSel').addEventListener('change', changeSelSoleVolumeDevice);
  setVolumeListOptionDefaultItem(mixerSoloDevice[0], 'type', 'selSolo', 'selSoloItem')

  // input audio 的option
  mlwTools.dropDown(false, 'inputVolumeDelaySel', inputDelayDevice, 'name', 'type', volumeInfo.selInput);
  document.getElementById('inputVolumeDelaySel').addEventListener('change', changeSelInputVolumeDevice);
  setVolumeListOptionDefaultItem(inputDelayDevice[0], 'type', 'selInput', 'selInputItem')

  document.getElementById('adjustDelayVolumeTime').addEventListener('input', adjustDelayVolumeTimeChanged);

  // 所有判断下拉菜单是否展示的集合判断
  allJudgeSetVolumeFunctionArr()
  isHasNextIconPath()
}

function isHasNextIconPath () {
  // hasNextIcon 是否要判断不同的Icon
  // 注icon等于selFunction+volumeInfo[hasNextIcon]
  const selFuntionItem = volumeInfo.selFuntionItem
  const selFun = volumeInfo.selFunction
  let path = selFuntionItem.path

  if (selFuntionItem.hasOwnProperty('pathParams')) {
    path = selFuntionItem.path + '-' + volumeInfo[selFuntionItem.pathParams]

  }

  if (selFun === 'volumeMonitorDevice') {
    path = 'monitor' + '-' + volumeInfo.monitorDeviceItem.iconName
  }

  if (selFun === 'volumeAudioInputDelay') {
    path = 'delay' + '-' + volumeInfo.selInputItem.iconName 
  }

  volumeInfo.iconPath = path
}


// 判断是否加Monitor Device Option
function isAddMonitorDeviceOption () {

  mlwTools.dropDown(false, 'monitorDeviceSel', monitorDeviceList, 'name', 'monitorName', volumeInfo.selMonitorDevice);
  document.getElementById('monitorDeviceSel').addEventListener('change', changeVolMonitorDeviceSel);
  setVolumeListOptionDefaultItem(monitorDeviceList[0], 'monitorName', 'selMonitorDevice', 'monitorDeviceItem')

  if (volumeInfo.selFunction === 'volumeMonitorDevice') {
    document.getElementById('monitorListOptionID').style.display = 'inline-flex'
  } else {
    document.getElementById('monitorListOptionID').style.display = 'none'
  }
}


// 设置默认值
function setVolumeListOptionDefaultItem (item, itemKey, key, selKey) {
  console.log('setVolumeListOptionDefaultItem', item, itemKey, key, selKey, !item)
  if (!item) return
  if (volumeInfo[key] === null) {
    volumeInfo[key] = item[itemKey]
    volumeInfo[selKey] = item
    setSettingVolume()
  }
}


// 选择功能
function sendVolumeFuncionPlugin (event) {
  const value = event.target.value
  volumeInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selFuntionItem = functionVolumeOption[selectedIndex]

  // volumeInfo.iconPath = mlwTools.findNextFunIconPath(volumeInfo, volumeInfo.selFuntionItem)

  volumeInfo.title = mlwTools.findNextFunTitle(volumeInfo, volumeInfo.selFuntionItem, 'name')
  allJudgeSetVolumeFunctionArr()

  isHasNextIconPath()

  setSettingVolume()
  
}

// 所有判断下拉菜单是否展示的集合判断
function allJudgeSetVolumeFunctionArr () {
  // 是否有Audio Volume功能的name集合
  isCurFunctionHasDom(hasUsbAudioListArr, 'usbAudioVolumeListId')
  // 是否有video Volume功能的name集合
  isCurFunctionHasDom(hasVideoListArr, 'videoVolumeListId')

  // 是否有设置stream的name集合
  isCurFunctionHasDom(hasStreamListArr, 'streamVolumeListId')
  // 是否有设置webpage的name集合
  isCurFunctionHasDom(hasWebpageListArr, 'webpageVolumeListId')
  // 是否有设置gfx的name集合
  isCurFunctionHasDom(hasGfxListArr, 'gfxVolumeListId')


  // 是否有静音、不静音的设置
  isCurFunctionHasDom(hasVolumeMuteStateArr, 'setVolumeMuteOptionID', 'stateMuteItem')
  // 是否有scope 全局/私有
  isCurFunctionHasDom(hasScopeVolumeListArr, 'setVolumeScopeOptionID')
  // 是否有设置音量功能的name集合
  isCurFunctionHasDom(hasVolumeDBStateArr, 'setVolumeDBOptionID')
  // 是否有静音、不静音、AFV 的option
  isCurFunctionHasDom(hasAlwaysAfvStateArr, 'alwaysAfvStateOptionID')
  // 是否有静音、不静音、AFV 的option
  isCurFunctionHasDom(hasMixerVolumeListArr, 'mixerVolumeOptionID')
  // 判断是否加Monitor Device
  isAddMonitorDeviceOption()
  // 判断是否加solo Device
  isCurFunctionHasDom(hasSoloVolumeListArr, 'soloVolumeOptionID')
  // 判断是否加input device
  isCurFunctionHasDom(hasInputVolumeListArr, 'inputVolumeOptionID')
  // 判断是否加set input device delay
  isCurFunctionHasDom(hasSetInputDelayVolumeArr, 'inputVolumeDelayId')
  // mlwTools.domArrFunctionDisplay(functionVolumeOption, 'name', volumeInfo.selFunction)

}


// 判断当前选择的function中是否有相关dom展示
function isCurFunctionHasDom (arr, domName, hasNextIcon) {
  const funItem = volumeInfo.selFunction
  const isInd = arr.indexOf(funItem)

  if (isInd >= 0) {
    document.getElementById(domName).style.display = 'inline-flex'


  } else {
    document.getElementById(domName).style.display = 'none'
  }
}

// 变更静音、不静音
function changeVolMuteStateFun (event) {
  const value = event.target.value
  volumeInfo.selStateMute = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.stateMuteItem = volumeSetStateOptList[selectedIndex]

  volumeInfo.iconPath = volumeInfo.selFuntionItem.path + '-' + value

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更volume DB
function adjustVolumeDbChanged (event) {
  const value = event.target.value
  volumeInfo.selAdjustVol = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selAdjustItem = adjustVolumeOption[selectedIndex]
  // volumeInfo.title = value > 0 ? '+' + value + 'dB' : value + 'dB'
  volumeInfo.iconPath = volumeInfo.selFuntionItem.path + '-' + value

  setSettingVolume()
}

// 选择 Monitor 设备
function changeVolMonitorDeviceSel (event) {
  const value = event.target.value
  volumeInfo.selMonitorDevice = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.monitorDeviceItem = monitorDeviceList[selectedIndex]
  volumeInfo.title = monitorDeviceList[selectedIndex].name

  volumeInfo.iconPath = 'monitor' + '-' + volumeInfo.monitorDeviceItem.iconName
  setSettingVolume()
}

// 变更Usb AudioDevice
function changeUsbAudioVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selUsbAudioType = value
  console.log('selUsbAudioType', value)
  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selUsbAudioItem = usbAudioVolumeList[selectedIndex]
  volumeInfo.title = usbAudioVolumeList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更Scope 全局/私有
function changeScopeVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selScope = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selScopeItem = scopeVolumeOption[selectedIndex]
  volumeInfo.iconPath = volumeInfo.selFuntionItem.path + '-' + value

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更Scope 全局/私有
function changeAlwaysAfvDevice (event) {
  const value = event.target.value
  volumeInfo.selStateAlways = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selStateAlwaysItem = volumeSetStateAfvOptList[selectedIndex]
  volumeInfo.iconPath = volumeInfo.selFuntionItem.path + '-' + value

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更Video Device
function changeVideoVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selVideo = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selVideoItem = videoDeviceList[selectedIndex]
  volumeInfo.title = videoDeviceList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolume()
}
// 变更stream Device
function changeStreamVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selStream = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selStreamItem = streamVolumeList[selectedIndex]
  volumeInfo.title = streamVolumeList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolume()
}
// 变更webpage Device
function changeWebpageVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selWebpage = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selWebpageItem = webpageDeviceList[selectedIndex]
  volumeInfo.title = webpageDeviceList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更gfx Device
function changeGfxVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selGfx = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selGfxItem = gfxDeviceList[selectedIndex]
  volumeInfo.title = gfxDeviceList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolume()
}
// 变更 mixer
function changeMixerVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.mixState = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.mixStateItem = volumeMixerStateOptList[selectedIndex]
  volumeInfo.iconPath = volumeInfo.selFuntionItem.path + '-' + value

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更 solo
function changeSelSoleVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selSolo = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selSoloItem = mixerSoloDevice[selectedIndex]
  volumeInfo.title = mixerSoloDevice[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolume()
}

// 变更 Input audio
function changeSelInputVolumeDevice (event) {
  const value = event.target.value
  volumeInfo.selInput = value

  const selectedIndex = event.target.options.selectedIndex
  volumeInfo.selInputItem = inputDelayDevice[selectedIndex]
  volumeInfo.iconPath = 'delay' + '-' + volumeInfo.selInputItem.iconName 

  // 注icon等于selFunction+value
  setSettingVolume()
}

function adjustDelayVolumeTimeChanged (event) {
  const value = event.target.value
  volumeInfo.delayVolumeTime = value
  volumeInfo.delayVolumeTimeTitle = value + 'ms'
  volumeInfo.title = value + 'ms'

  setSettingVolume()
}


