var bgmInfo = {
  selFunction: null,
  selFuntionItem: {},
  title: 'playBgm',
  iconPath: 'playBgm',
  selBgmPath: null,
  selBgmItem: {},
  progressValue: '0%',
  progress: 0
} // 按键中需要存在的字段
var bgmList = []

var functionBgmOption = [
  { name: 'playBgm', value: '/V1.0/bgm/play', title: 'playBgmTitle', path: 'playBgm' },
  { name: 'pauseBgm', value: '/V1.0/bgm/pause', title: 'pauseBgmTitle', path: 'pauseBgm' },
  { name: 'playPauseBgm', value: '/V1.0/bgm/playAction', title: 'playPauseBgmTitle', path: 'playPauseBgm' },
  { name: 'goToFirstSong', value: '/V1.0/bgm/first', title: 'goToFirstSongTitle', path: 'goToFirstSong' },
  { name: 'goToLastSong', value: '/V1.0/bgm/last', title: 'goToLastSongTitle', path: 'goToLastSong' },
  { name: 'goToNextSong', value: '/V1.0/bgm/next', title: 'goToNextSongTitle', path: 'goToNextSong' },
  { name: 'goToPreviousSong', value: '/V1.0/bgm/previous', title: 'goToPreviousSongTitle', path: 'goToPreviousSong' },
  { name: 'goToSong', value: '/V1.0/bgm/playByFile', paramsKey: { filePath: 'selBgmPath' }, isNext: 'selBgmItem', title: 'goToSong', path: 'goToSong' }
]

async function getStatemachineBgmChange (val) {
  if (val.shortcutFunctionParamsChanged) {
    await getBgmList()

    const list = bgmList
    let selBgmPath = bgmInfo.selBgmPath
    if (list.length > 0) {
      const isHav = list.some(item => {
        return item.filePath === bgmInfo.selBgmPath
      })

      if (!isHav) {
        selBgmPath = list[0].filePath
        bgmInfo.selBgmItem = list[0]
        bgmInfo.selBgmPath = list[0].filePath
        bgmInfo.title = list[0].title
        if (bgmInfo.selFuntionItem.name == 'goToSong') {
          setSettingBgm()
        }
      }
    } else {
      selBgmPath = ''
    }

    mlwTools.dropDown(false, 'bgmListOptionSel', bgmList, 'title', 'filePath', selBgmPath);
  }
}


// 获取bgm列表请求
async function getBgmList() {
  try {
    const response = await request('/V1.0/bgm/getPlayList');

    if (response.status === 0) {
      bgmList = response.bgmList
    }
  } catch (err) {
    console.error('Error fetching bgm list:', err);
    throw err;
  }
}

// 数据存储在按键
function setSettingBgm () {
  const info = {
    bgmInfo: bgmInfo
  }
  setSettingInKey2(info)
}

async function getBgmActionInfo (actionInfo) {
  await getBgmList()

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('bgmInfo')) {
    settingInfo = settings.bgmInfo
  }

  // 查找需要的字段
  const findKey = ['selFunction','selFuntionItem', 'title', 'iconPath', 'selBgmPath', 'selBgmItem']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      bgmInfo[item] = settingInfo[item]
    } else {
      bgmInfo[item] = bgmInfo[item] || null
    }
  })

  if (controller === 'Keypad') {
    getBgmFunctionDom()
  }
}
function getBgmFunctionDom () {
  // 初始值
  if (bgmInfo.selFunction === null) {
    bgmInfo.selFunction = functionBgmOption[0].name
    bgmInfo.selFuntionItem = functionBgmOption[0]
    bgmInfo.title = functionBgmOption[0].title
    bgmInfo.iconPath = functionBgmOption[0].path
    setSettingBgm()
  }


    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="bgmFunOptionSel"></select>
      </div>
      <div class="sdpi-item" id="goToSong" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.bgm.songName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="bgmListOptionSel"></select>
      </div>
    `;

    const FunOptionDom = document.getElementById('bgmFunOptionSel');
    FunOptionDom.addEventListener('change', sendBgmFuncionPlugin);

    mlwTools.dropDown($PI.localization.bgm, 'bgmFunOptionSel', functionBgmOption, 'name', 'value', bgmInfo.selFunction);

    mlwTools.dropDown(false, 'bgmListOptionSel', bgmList, 'title', 'filePath', bgmInfo.selBgmPath);

    mlwTools.controlFunctionDisplay(functionBgmOption, bgmInfo.selFunction)

    document.getElementById('bgmListOptionSel').addEventListener('change', sendBgmListPlugin);
    setBgmListOptionDefaultItem(bgmList[0], 'selBgmPath', 'selBgmItem')
}

function setBgmListOptionDefaultItem (item, key, itemKey) {
  if (bgmInfo[key] === null) {
    bgmInfo[key] = item.filePath
    bgmInfo[itemKey] = item
  }
}

function sendBgmFuncionPlugin (event) {
  const value = event.target.value
  bgmInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  bgmInfo.selFuntionItem = functionBgmOption[selectedIndex]

  bgmInfo.title =  bgmInfo.selFuntionItem.title
  bgmInfo.iconPath = bgmInfo.selFuntionItem.path


  if (bgmInfo.selFuntionItem.hasOwnProperty('isNext')) {
    let applyNextOptionItem = bgmInfo[bgmInfo.selFuntionItem.isNext]
    if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
      bgmInfo.title = applyNextOptionItem.title
    }
  }

  mlwTools.controlFunctionDisplay(functionBgmOption, bgmInfo.selFunction)

  setSettingBgm()
}

function sendBgmListPlugin (event) {
  const value = event.target.value
  bgmInfo.selBgmPath = value
  const selectedIndex = event.target.options.selectedIndex
  bgmInfo.title = bgmList[selectedIndex].title
  bgmInfo.selBgmItem = bgmList[selectedIndex]

  setSettingBgm()
}
