// 注要判断是否有ip地址

var gfxList = [] // 场景列表
var isGfxFirst = true // 是否是初次加载
var gfxNeedInfo = {
  selFunction: null,
  selGfxUuid: null,
  selGfxName: null,
  selFuntionItem: {}
} // 按键中需要存在的字段


// 场景相关操作
var functionGfxOption = [
  { name: 'turnOnGfx', value: 'turnOn', title: '' },
  { name: 'turnOffGfx', value: 'turnOff', title: '' },
  { name: 'TurnOnOffGfx', value: '/V1.0/gfx/actionByUUID', title: '' },
  { name: 'clearOverlay', value: '/V1.0/gfx/clear', title: 'clear' }
]
function choseOpGfx() {
  const list = gfxList
  let selGfx = gfxNeedInfo.selGfxUuid
  if (list.length > 0) {
    const isHav = list.some(item => {
      return item.uuid == gfxNeedInfo.selGfxUuid
    })
    if (!isHav) {
      selGfx = list[0].uuid
      gfxNeedInfo.selGfxUuid = list[0].uuid
      gfxNeedInfo.selGfxName = list[0].name
      if (gfxNeedInfo.selFuntionItem.name != 'clearOverlay') {
        setSettingGfx()
      }
    }
  }
}
// 轮询通知中有场景列表变更的通知,每次变更要重新获取列表
async function getStatemachineGfxChange(data) {
  if (data.gfxListChanged) {
   await getGfxList()
  //  getGfxFunctionDom()
    const list = gfxList
    let selGfx = gfxNeedInfo.selGfxUuid
    if (list.length > 0) {
      const isHav = list.some(item => {
        return item.uuid == gfxNeedInfo.selGfxUuid
      })
      console.log(list)
      if (!isHav) {
        selGfx = list[0].uuid
        gfxNeedInfo.selGfxUuid = list[0].uuid
        gfxNeedInfo.selGfxName = list[0].name

        if (gfxNeedInfo.selFuntionItem.name != 'clearOverlay') {
          setSettingGfx()
        }
      }
    } else {
      selGfx = ''
    }
    mlwTools.dropDown(false, 'gfxOptionSel', gfxList, 'name', 'uuid', selGfx)

    // setTimeout(()=>{
    //   getGfxFunctionDom()
    // },1000)

  }
}

// 获取场景列表请求
async function getGfxList() {
  try {
    const response = await request('/V1.0/gfx/getGFXList');
    if (response.status === 0) {
      isGfxFirst = false
      gfxList = response.gfxList
    }
  } catch (err) {
    console.error('Error fetching GFX list:', err);
    throw err;
  }
}


// 数据存储在按键
function setSettingGfx () {

  const info = {
    gfxList: gfxList,
    gfxInfo: gfxNeedInfo,
  }
  setSettingInKey2(info)
}

async function getGfxActionInfo (actionInfo) {
  // await getGfxList()

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings
  // alert(JSON.stringify(settings))

  var actionInfoContext = {}

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('gfxList')) {
    gfxList = settings.gfxList
  }

  if (settings.hasOwnProperty('gfxInfo')) {
    settingInfo = settings.gfxInfo
  }
  await getGfxList()

  
  // 查找需要的字段
  const sceneKey = ['selFunction', 'selGfxUuid', 'selFuntionItem', 'selGfxName']
  // 字段是否存在,存在赋值,不存在为null
  sceneKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      gfxNeedInfo[item] = settingInfo[item]
    } else {
      gfxNeedInfo[item] = null
    }
  })
  getGfxFunctionDom()


  choseOpGfx()
}
function getGfxFunctionDom () {

    if (gfxNeedInfo.selFunction === null) {
      gfxNeedInfo.selFunction = functionGfxOption[0].value
      gfxNeedInfo.selFuntionItem = functionGfxOption[0]

      setSettingGfx()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="gfxFunOptionSel"></select>
      </div>
      <div class="sdpi-item" id="select-gfx-list" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.gfx.gfxName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="gfxOptionSel"></select>
      </div>
    `;

    const FunOptionDom = document.getElementById('gfxFunOptionSel');
    FunOptionDom.addEventListener('change', sendFuncionGfxPlugin);
    mlwTools.dropDown($PI.localization.gfx, 'gfxFunOptionSel', functionGfxOption, 'name', 'value', gfxNeedInfo.selFunction);

    // 判断选择的功能是否是Switch to the specific scene
    if (gfxNeedInfo.selFunction !== '/V1.0/gfx/clear') {
      document.getElementById('select-gfx-list').style.display = 'inline-flex'
      addSwitchGfxOption()
    } else {
      document.getElementById('select-gfx-list').style.display = 'none'
    }
}
// 场景下拉列表,选择指定场景
function addSwitchGfxOption () {
  const element = document.getElementById('gfxOptionSel');
  element.addEventListener('change', sendValueToGfxPlugin);
  this.createdGfxOption()
}
function createdGfxOption() {
  if (gfxList.length === 0) {
    setTimeout(() => {
      createdGfxOption()
    }, 500)
    return
  }

  if (gfxNeedInfo.selGfxUuid === null) {
    gfxNeedInfo.selGfxUuid = gfxList[0].uuid
    gfxNeedInfo.selGfxName = gfxList[0].name
    setSettingGfx()
  }

  mlwTools.dropDown(false, 'gfxOptionSel', gfxList, 'name', 'uuid', gfxNeedInfo.selGfxUuid )
}

function sendFuncionGfxPlugin (event) {
  const value = event.target.value
  gfxNeedInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  gfxNeedInfo.selFuntionItem = functionGfxOption[selectedIndex]

  setSettingGfx()
  // 判断选择的功能是否是Switch to the specific scene
  if (value !== '/V1.0/gfx/clear') {
    document.getElementById('select-gfx-list').style.display = 'inline-flex'
    addSwitchGfxOption()
  } else {
    document.getElementById('select-gfx-list').style.display = 'none'
  }
}

function sendValueToGfxPlugin (event) {
  const value = event.target.value
  gfxNeedInfo.selGfxUuid = value
  const selectedIndex = event.target.options.selectedIndex

  gfxNeedInfo.selGfxName = gfxList[selectedIndex].name
  setSettingGfx()
}
