var otherInfo = {
    selFunction: null,
    selFunctionItem: {},
    wait: null,
    usbCOutput: null,
} // 按键中需要存在的字段

var functionOtherOption = [
    {name: 'reboot', value: '/V1.0/system/reboot'},
    {name: 'powerOff', value: '/V1.0/system/shutdown'},
    {name: 'screenshot', value: '/V1.0/system/screenshot'},
    {name: 'freeze', value: '/V1.0/scene/freeze'},
    {name: 'unfreeze', value: '/V1.0/scene/unfreeze'},
    {name: 'freezeOrUnfreeze', value: '/V1.0/scene/toggleFreeze'},
    {name: 'tunOnFtb', value: '/V1.0/scene/toggleOnFTB'},
    {name: 'tunOffFtb', value: '/V1.0/scene/toggleOffFTB'},
    {name: 'tunOnOrOffFtb', value: '/V1.0/scene/toggleFTB'},
    {name: 'setUsbCDpOutput', value: '/V1.0/system/setUSBCMode', paramsKey: {mode: '1'}},
    // {name: 'wait', value: '/V1.0/scene/setTransitionDuration', paramsKey: {name: 'cut'}},
]

function getOtherActionInfo(actionInfo) {
    // 存储在按键中的信息
    var settings = actionInfo.payload.settings
    if (settings.hasOwnProperty('baseURL')) {
        baseURL = settings.baseURL
    }

    var actCtxSetting = {}
    if (settings.hasOwnProperty('otherInfo')) {
        actCtxSetting = settings.otherInfo
    }

    // 查找需要的字段
    const actionKey = ['selFunction', 'selFunctionItem', 'wait', 'usbCOutput']
    // 字段是否存在,存在赋值,不存在为null
    actionKey.forEach(item => {
        if (actCtxSetting.hasOwnProperty(item)) {
            otherInfo[item] = actCtxSetting[item]
        } else {
            otherInfo[item] = null
        }
    })

    getOtherFunctionDom()
}

function setSettingOther(value, key) {
    // 判断是否有默认值
    if (otherInfo.selFunctionItem.hasOwnProperty('paramsKey')) {
        // 如果value有设置值
        value = value || otherInfo.selFunctionItem.paramsKey[key]
        otherInfo.selFunctionItem.paramsKey[key] = value
    }

    setSettingInKey2({
        otherInfo: otherInfo
    })
}

function getOtherFunctionDom() {
    // 初始值
    if (otherInfo.selFunction === null) {
        otherInfo.selFunction = functionOtherOption[0].value
        otherInfo.selFunctionItem = functionOtherOption[0];
        setSettingOther()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="otherFunOptionSel"></select>
    </div>
    <div class="sdpi-item" id="setUsbCDpOutput" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.other.itemLabelUsbCDpOutput} </div>
      <select class="sdpi-item-value select setvalueSelect" id="setUsbCDpOutputEle"></select>
    </div>
    <div type="range" class="sdpi-item" id="setWait" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.other.itemLabelWait}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=50>50</span>
          <input class="floating-tooltip" data-suffix="ms" type="range" id="setWaitEle" min="200" max="1000" step="100" value="${otherInfo.wait}">
          <span class="clickable" value="10000">10000</span>
      </div>
    </div>
  `;
    initToolTips();

    const FunOptionDom = document.getElementById('otherFunOptionSel');
    FunOptionDom.addEventListener('change', otherFunOptionSelChange);

    mlwTools.dropDown($PI.localization.other, 'otherFunOptionSel', functionOtherOption, 'name', 'value', otherInfo.selFunction);

    document.getElementById('setWaitEle').addEventListener('input', setWaitChange);

    // 判断选择的功能展示对应dom
    console.log('mlwTools', functionOtherOption, otherInfo.selFunction)
    mlwTools.controlFunctionDisplay(functionOtherOption, otherInfo.selFunction)

   const element = document.getElementById('setUsbCDpOutputEle');
    element.addEventListener('change', setUsbCDpOutputChange);

    setUsbCDpOutputEleOpt();
}

function setUsbCDpOutputEleOpt() {
    var usbCMode = [
        {"value": "1", "label": "usb_c_mode_label1"},
        {"value": "5", "label": "usb_c_mode_label5"},
        {"value": "4", "label": "usb_c_mode_label4"},
        {"value": "0", "label": "usb_c_mode_label0"},
        {"value": "2", "label": "usb_c_mode_label2"},
        {"value": "3", "label": "usb_c_mode_label3"},
    ];

    // 初始值
    if (otherInfo.usbCOutput === null) {
        otherInfo.usbCOutput = "1";
        setSettingOther(otherInfo.usbCOutput)
    }

    mlwTools.dropDown($PI.localization.other, 'setUsbCDpOutputEle', usbCMode, 'label', 'value', otherInfo.usbCOutput);
}

function otherFunOptionSelChange(event) {
    const value = event.target.value
    const selectedIndex = event.target.options.selectedIndex
    otherInfo.selFunctionItem = functionOtherOption[selectedIndex]
    otherInfo.selFunction = value
    // 判断选择的功能展示对应dom
    console.log('mlwTools', functionOtherOption, otherInfo.selFunction)
    mlwTools.controlFunctionDisplay(functionOtherOption, otherInfo.selFunction)
    setSettingOther()
}

function setWaitChange(event) {
    const value = event.target.value
    otherInfo.wait = value

    setSettingOther(value, 'wait')
}

function setUsbCDpOutputChange(event) {
    const value = event.target.value
    otherInfo.usbCOutput = value

    setSettingOther(value, 'mode')
}
