var ptzDeviceList = []
var ptzInfo = {
    selFunction: null,
    selFunctionItem: {},
    selPtzId: null,
    selPtzName: null,
    selPreset: "1", // 选择的预设点位
    selPresetIcon: {
        path: "preset1"
    }, // 选择的预设点位
    selSpeed: "1",
    selNearSpeed: "10",
    selFarSpeed: "0",
    selZoomSpeed: "1",
    selTrackingMode: "normalTrack",
    selTrackingModeName: "",
    selTrackingSpeed: "slow",
    selTrackingSpeedName: "",
    selTrackingType: "1",
    selTrackingTypeName: "",
    title: 'ptzSelectDevice',
    iconPath: 'ptzSelectDevice',
    clickTime: 0
} // 按键中需要存在的字段


$PI.onDidReceiveSettings("com.magewell.magewell-director.ptz", (e) => {
    console.log(e);
    // 设置 setScale 的值.
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("ptzInfo")) {
        const settingPtzInfo = settings.ptzInfo
        ptzInfo.selNearSpeed = settingPtzInfo.selNearSpeed;
        ptzInfo.selFarSpeed = settingPtzInfo.selFarSpeed;
        getPtzActionInfo(e);
    }
})


async function getStatemachinePtzDeviceChange (val) {
    if (val.shortcutFunctionParamsChanged || val.showListChanged) {
        console.log('ptz getStatemachinePtzDeviceChange')
        await getPtzDeviceList()

        const list = ptzDeviceList;
        let selPtzId = ptzInfo.selPtzId;
        if(list.length > 0) {
            const isHav = list.some(item => {
                return item.id === ptzInfo.selPtzId
            })

            if (!isHav) {
                let item = list[0];
                selPtzId = item["id"];
                ptzInfo.selPtzId = item["id"];
                ptzInfo.selPtzName = item['layerName'];
                ptzInfo.title = ptzInfo.selPtzName

                if (ptzInfo.selFunctionItem.name == 'ptzSelectDevice') {
                    setSettingPtz()
                }
            }
        } else {
            selPtzId = ''
        }

        mlwTools.dropDown(false, 'ptzDeviceEle', ptzDeviceList, 'layerName', 'id', selPtzId);
    }
}


var parsePositionArr = []
for (let i = 1; i <= 9; i++) {
    parsePositionArr.push({
        name: "" + i,
        value: "" + i
    })
}

var ptzTrackingModeArr = [
    {name: 'trackingModeNormalTrack', value: 'normalTrack'},
    {name: 'trackingModeUpperBody', value: 'upperBody'},
    {name: 'trackingModeCloseUp', value: 'closeUp'},
];

var ptzTrackingSpeedArr = [
    {name: 'trackingSpeedSlow', value: 'slow'},
    {name: 'trackingSpeedFast', value: 'fast'},
    {name: 'trackingSpeedStandard', value: 'standard'}
];

var ptzTrackingTypeArr = [
    {name: 'trackingTypeStandard', value: '0'},
    {name: 'trackingTypeMotion', value: '1'}
];

// 配置显示规则
var ptzDivIdArr = ["ptzDeviceItem", "ptzPresetItem", "ptzSpeedItem", "ptzNearSpeedItem", "ptzFarSpeedItem", "ptzZoomSpeedItem", "ptzTrackingModeItem", "ptzTrackingSpeedItem", "ptzTrackingTypeItem"];
var ptzDivRuleArr = {
    "ptzSelectDevice": ['ptzDeviceItem'],
    "ptzCallPreset": ['ptzPresetItem'],
    "ptzStorePreset": ['ptzPresetItem'],
    "ptzZoomIn": ['ptzZoomSpeedItem'],
    "ptzZoomOut": ['ptzZoomSpeedItem'],
    // "ptzFocusFar": ['ptzFarSpeedItem'],
    // "ptzFocusNear": ['ptzNearSpeedItem'],
    "ptzMoveUp": ['ptzSpeedItem'],
    "ptzMoveUpLeft": ['ptzSpeedItem'],
    "ptzMoveLeft": ['ptzSpeedItem'],
    "ptzMoveDown": ['ptzSpeedItem'],
    "ptzMoveDownLeft": ['ptzSpeedItem'],
    "ptzMoveDownRight": ['ptzSpeedItem'],
    "ptzMoveRight": ['ptzSpeedItem'],
    "ptzMoveUpRight": ['ptzSpeedItem'],
    "ptzSetAiHumanTrackingMode": ["ptzTrackingModeItem"],
    "ptzSetAiHumanTrackingSpeed": ['ptzTrackingSpeedItem'],
    "ptzSetAiHumanTrackingType": ['ptzTrackingTypeItem'],
}

var ptzFunctionOption = [
    {
        name: 'ptzSelectDevice',
        value: '/V1.0/ptz/selectedControl',
        title: "ptzSelectDevice",
        path: "ptzSelectDevice",
        isNext: "selPtzName",
        paramsKey: {id: ""}
    },
    {
        name: 'ptzCallPreset',
        value: '/V1.0/ptz/goToPreset',
        title: "ptzCallPresetTitle",
        path: "ptzCallPreset",
        pathNext: "selPresetIcon",
        paramsKey: {position: "1"}
    },
    {
        name: 'ptzStorePreset',
        value: '/V1.0/ptz/storePreset',
        title: "ptzStorePresetTitle",
        path: "ptzStorePreset",
        pathNext: "selPresetIcon",
        paramsKey: {position: "1"}
    },
    {
        name: 'ptzZoomIn',
        value: '/V1.0/ptz/zoomIn',
        title: "",
        path: "ptzZoomIn",
        isNext: "selZoomSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzZoomOut',
        value: '/V1.0/ptz/zoomOut',
        title: "",
        path: "ptzZoomOut",
        isNext: "selZoomSpeed",
        paramsKey: {speed: "1"}
    },
    {name: 'ptzStopZooming', value: '/V1.0/ptz/zoomStop', title: "", path: "ptzStopZooming"},
    {name: 'ptzAutoFocus', value: '/V1.0/ptz/autoFocus',  title: "ptzAutoFocusTitle", path: "ptzAutoFocus"},
    {
        name: 'ptzFocusFar',
        value: 'ptzFocusFar',
        title: "",
        path: "ptzFocusFar",
        isNext: "selFarSpeed",
        paramsKey: {focusValue: "10"}
    },
    {
        name: 'ptzFocusNear',
        value: 'ptzFocusNear',
        title: "",
        path: "ptzFocusNear",
        isNext: "selNearSpeed",
        paramsKey: {focusValue: "0"}
    },
    // {name: 'ptzStopFocus', value: '/V1.0/ptz/focusStop', title: "", path: "ptzStopFocus"},
    {name: 'ptzHome', value: '/V1.0/ptz/moveHome', title: "ptzHomeTitle", path: "ptzHome"},
    {
        name: 'ptzMoveUp',
        value: '/V1.0/ptz/moveUp',
        title: "",
        path: "ptzMoveUp",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveUpLeft',
        value: '/V1.0/ptz/moveUpLeft',
        title: "",
        path: "ptzMoveUpLeft",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveLeft',
        value: '/V1.0/ptz/moveLeft',
        title: "",
        path: "ptzMoveLeft",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveDown',
        value: '/V1.0/ptz/moveDown',
        title: "",
        path: "ptzMoveDown",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveDownLeft',
        value: '/V1.0/ptz/moveDownLeft',
        title: "",
        path: "ptzMoveDownLeft",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveDownRight',
        value: '/V1.0/ptz/moveDownRight',
        title: "",
        path: "ptzMoveDownRight",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveRight',
        value: '/V1.0/ptz/moveRight',
        title: "",
        path: "ptzMoveRight",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {
        name: 'ptzMoveUpRight',
        value: '/V1.0/ptz/moveUpRight',
        title: "",
        path: "ptzMoveUpRight",
        isNext: "selSpeed",
        paramsKey: {speed: "1"}
    },
    {name: 'ptzStopMoving', value: '/V1.0/ptz/moveStop', title: "ptzStopMovingTitle", path: "ptzStopMoving"},
    {name: 'ptzStartRecording', value: '/V1.0/ptz/startRecording', title: "ptzStartRecordingTitle", path: "ptzStartRecording"},
    {name: 'ptzStopRecording', value: '/V1.0/ptz/stopRecording', title: "ptzStopRecordingTitle", path: "ptzStopRecording"},
    {name: 'ptzStartOrStopRecording', value: '/V1.0/ptz/recordAction', title: "ptzStartOrStopRecordingTitle", path: "ptzStartOrStopRecording"},
    {
        name: 'ptzStartAiHumanTracking',
        value: '/V1.0/ptz/startAIHumanTracking',
        title: "ptzStartAiHumanTrackingTitle",
        path: "ptzStartAiHumanTracking"
    },
    {name: 'ptzStopAiHumanTracking', value: '/V1.0/ptz/stopAIHumanTracking', title: "ptzStopAiHumanTrackingTitle", path: "ptzStopAiHumanTracking"},
    {
        name: 'ptzStartOrStopAiHumanTracking',
        value: '/V1.0/ptz/AIHumanTrackingAction',
        title: "ptzStartOrStopAiHumanTrackingTitle",
        path: "ptzStartOrStopAiHumanTracking"
    },
    {
        name: 'ptzSetAiHumanTrackingMode',
        path: "ptzSetAiHumanTrackingMode",
        title: "",
        isNext: "selTrackingModeName",
        value: '/V1.0/ptz/setHumanTrackingMode',
        paramsKey: {mode: "normalTrack"}
    },
    {
        name: 'ptzSetAiHumanTrackingSpeed',
        path: "ptzSetAiHumanTrackingSpeed",
        title: "",
        isNext: "selTrackingSpeedName",
        value: '/V1.0/ptz/setHumanTrackingSpeed',
        paramsKey: {speed: "slow"}
    },
    {
        name: 'ptzSetAiHumanTrackingType',
        path: "ptzSetAiHumanTrackingType",
        title: "",
        isNext: "selTrackingTypeName",
        value: '/V1.0/ptz/setHumanTrackingType',
        paramsKey: {type: "1"}
    },
    {name: 'ptzWakeUpCamera', value: '/V1.0/ptz/wakeUp', title: "ptzWakeUpCameraTitle", path: "ptzWakeUpCamera"},
    {name: 'ptzReset', value: '/V1.0/ptz/reset', title: "ptzResetTitle", path: "ptzReset"}
]

async function getPtzDeviceList() {
    try {
        const response = await request('/V1.0/ptz/getDeviceList');
        console.log('ptz event', response);
        const {status, deviceList} = response;
        if (status === 0) {
            ptzDeviceList = deviceList;
            // if (!ptzDeviceList.length) return;
            //
            // if (ptzInfo.selPtzId === null || !ptzDeviceList.some(item => item.id === ptzInfo.selPtzId)) {
            //     ptzInfo.selPtzId = ptzDeviceList[0]["id"];
            //     ptzInfo.selPtzName = ptzDeviceList[0]["layerName"];
            // }
        }
    } catch (err) {
        console.error('Error fetching ptz list:', err);
        throw err;
    }
}


async function getPtzActionInfo(actionInfo) {
    console.log('ptzInfo', actionInfo);
    await getPtzDeviceList();

    // 存储在按键中的信息
    var settings = actionInfo.payload.settings
    var actCtxSetting = {}
    if (settings.hasOwnProperty('baseURL')) {
        baseURL = settings.baseURL
    }

    if (settings.hasOwnProperty('ptzInfo')) {
        actCtxSetting = settings.ptzInfo
    }

    // 查找需要的字段
    const actionKey = ["clickTime", 'selFunction', 'selFunctionItem', 'selPtzId', "selPtzName", 'selPreset', "selPresetIcon", 'selSpeed', "selNearSpeed", "selFarSpeed", 'selZoomSpeed', 'selTrackingMode', 'selTrackingModeName', 'selTrackingSpeed', 'selTrackingSpeedName', 'selTrackingType', 'selTrackingTypeName', 'title', 'iconPath'];
    actionKey.forEach(item => {
        if (actCtxSetting.hasOwnProperty(item)) {
            ptzInfo[item] = actCtxSetting[item]
        } else {
            ptzInfo[item] = ptzInfo[item] ? ptzInfo[item] : null;
        }
    })

    gePtzFunctionDom()
}

function gePtzFunctionDom() {
    // 初始值
    if (ptzInfo.selFunction === null) {
        ptzInfo.selFunction = ptzFunctionOption[0].value
        ptzInfo.selFunctionItem = ptzFunctionOption[0];
        ptzInfo.selTrackingModeName = $PI.localization.ptz['trackingModeNormalTrack'];
        ptzInfo.selTrackingSpeedName = $PI.localization.ptz['trackingSpeedSlow'];
        ptzInfo.selTrackingTypeName = $PI.localization.ptz['trackingTypeMotion'];
        if(ptzDeviceList.length) {
            ptzInfo.title = ptzDeviceList[0]['layerName'];
        } else {
            ptzInfo.title = '';
        }
        setSettingPtz()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="ptzFunOptionSel"></select>
    </div>
    
    <div class="sdpi-item" id="ptzDeviceItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelDevice} </div>
        <select class="sdpi-item-value select setvalueSelect" id="ptzDeviceEle"></select>
    </div>
      
    <div type="range"  class="sdpi-item" id="ptzPresetItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelPreset} </div>
        <select class="sdpi-item-value select setvalueSelect" id="ptzPresetEle"></select>
    </div>
    
    <div type="range"  class="sdpi-item" id="ptzSpeedItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelSpeed} </div>
        <div class="sdpi-item-value">
          <span class="clickable" value=1>1</span>
          <input class="floating-tooltip" type="range" id="ptzSpeedEle" min="1" max="10" step="1" value="${ptzInfo.selSpeed}" />
          <span class="clickable" value="10">10</span>
        </div>
    </div>
    
    <div type="range"  class="sdpi-item" id="ptzZoomSpeedItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelSpeed} </div>
        <div class="sdpi-item-value">
          <span class="clickable" value=1>1</span>
          <input class="floating-tooltip" type="range" id="ptzZoomSpeedEle" min="1" max="10" step="1" value="${ptzInfo.selZoomSpeed}" />
          <span class="clickable" value="10">10</span>
        </div>
    </div>
    
    <div type="range"  class="sdpi-item" id="ptzNearSpeedItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelSpeed} </div>
        <div class="sdpi-item-value">
          <span class="clickable" value=0>0</span>
          <input class="floating-tooltip" type="range" id="ptzNearSpeedEle" min="0" max="10" step="1" value="${ptzInfo.selNearSpeed}" />
          <span class="clickable" value="10">10</span>
        </div>
    </div>
    
     <div type="range"  class="sdpi-item" id="ptzFarSpeedItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelSpeed} </div>
        <div class="sdpi-item-value">
          <span class="clickable" value=0>0</span>
          <input class="floating-tooltip" type="range" id="ptzFarSpeedEle" min="0" max="10" step="1" value="${ptzInfo.selFarSpeed}" />
          <span class="clickable" value="10">10</span>
        </div>
    </div>
      
    <div class="sdpi-item" id="ptzTrackingModeItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelTrackingMode} </div>
        <select class="sdpi-item-value select setvalueSelect" id="ptzTrackingModeEle"></select>
    </div>
    
    <div class="sdpi-item" id="ptzTrackingSpeedItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelTrackingSpeed} </div>
        <select class="sdpi-item-value select setvalueSelect" id="ptzTrackingSpeedEle"></select>
    </div>
    
     <div class="sdpi-item" id="ptzTrackingTypeItem">
        <div class="sdpi-item-label"> ${$PI.localization.ptz.labelTrackingType} </div>
        <select class="sdpi-item-value select setvalueSelect" id="ptzTrackingTypeEle"></select>
    </div>
  `;
    initToolTips();

    const FunOptionDom = document.getElementById('ptzFunOptionSel');
    FunOptionDom.addEventListener('change', ptzFunOptionSelChange);
    mlwTools.dropDown($PI.localization.ptz, 'ptzFunOptionSel', ptzFunctionOption, 'name', 'value', ptzInfo.selFunction);

    // ptz Device
    document.getElementById('ptzDeviceEle').addEventListener('change', ptzDeviceEleChange);
    mlwTools.dropDown(false, 'ptzDeviceEle', ptzDeviceList, 'layerName', 'id', ptzInfo.selPtzId);
    setPtzDeviceListOptionDefaultItem();

    // 预设点位
    document.getElementById('ptzPresetEle').addEventListener('change', ptzPresetEleChange);
    mlwTools.dropDown(false, 'ptzPresetEle', parsePositionArr, 'name', 'value', ptzInfo.selPreset);

    // speed
    document.getElementById('ptzSpeedEle').addEventListener('input', ptzSpeedEleChange);
    document.getElementById('ptzNearSpeedEle').addEventListener('input', ptzNearSpeedEleChange);
    document.getElementById('ptzFarSpeedEle').addEventListener('input', ptzFarSpeedEleChange);

    // zoom Speed
    document.getElementById('ptzZoomSpeedEle').addEventListener('input', ptzZoomSpeedEleChange);

    // TrackingMode
    document.getElementById('ptzTrackingModeEle').addEventListener('change', ptzTrackingModeEleChange);
    mlwTools.dropDown($PI.localization.ptz, 'ptzTrackingModeEle', ptzTrackingModeArr, 'name', 'value', ptzInfo.selTrackingMode);

    // TrackingSpeed
    document.getElementById('ptzTrackingSpeedEle').addEventListener('change', ptzTrackingSpeedEleChange);
    mlwTools.dropDown($PI.localization.ptz, 'ptzTrackingSpeedEle', ptzTrackingSpeedArr, 'name', 'value', ptzInfo.selTrackingSpeed);

    // TrackingType
    document.getElementById('ptzTrackingTypeEle').addEventListener('change', ptzTrackingTypeEleChange);
    mlwTools.dropDown($PI.localization.ptz, 'ptzTrackingTypeEle', ptzTrackingTypeArr, 'name', 'value', ptzInfo.selTrackingType);

    // 判断选择的功能展示对应dom
    mlwTools.divSwitchShowOrHideRule(ptzDivIdArr, ptzDivRuleArr, ptzInfo.selFunctionItem.name)
}

function setPtzDeviceListOptionDefaultItem () {
    if(ptzDeviceList.length <= 0) return ;

    if (ptzInfo.selPtzId === null) {
        let item = ptzDeviceList[0];
        ptzInfo.selPtzId = item["id"];
        ptzInfo.selPtzName = item["layerName"];
    } else {
        const isHav = ptzDeviceList.some(item => {
            return item.id === ptzInfo.selPtzId
        })

        if (!isHav) {
            let item = ptzDeviceList[0];
            ptzInfo.selPtzId = item["id"];
            ptzInfo.selPtzName = item['layerName'];
            if(ptzInfo.selFunctionItem.name ==='ptzSelectDevice'){
                ptzInfo.title = ptzInfo.selPtzName

            }
        }
    }
  
        setSettingPtz()

   
}

function ptzFunOptionSelChange(event) {
    const value = event.target.value
    const selectedIndex = event.target.options.selectedIndex
    ptzInfo.selFunctionItem = ptzFunctionOption[selectedIndex]
    ptzInfo.selFunction = value;
    ptzInfo.iconPath = mlwTools.findNextFunIconPath(ptzInfo, ptzInfo.selFunctionItem)
    ptzInfo.title = mlwTools.findNextFunTitle(ptzInfo, ptzInfo.selFunctionItem)


    mlwTools.divSwitchShowOrHideRule(ptzDivIdArr, ptzDivRuleArr, ptzInfo.selFunctionItem.name);

    setSettingPtz()
}

function ptzDeviceEleChange(event) {
    const selectedIndex = event.target.options.selectedIndex
    ptzInfo.selPtzId = event.target.value;
    ptzInfo.selPtzName = ptzDeviceList[selectedIndex]['layerName'];
    ptzInfo.title = ptzInfo.selPtzName;
    setSettingPtz()
}

function ptzPresetEleChange(event) {
    ptzInfo.selPreset = event.target.value;
    ptzInfo.selPresetIcon.path = "preset" + event.target.value;
    ptzInfo.iconPath = ptzInfo.selPresetIcon.path;
    setSettingPtz()
}

function ptzSpeedEleChange(event) {
    ptzInfo.selSpeed = event.target.value;
    ptzInfo.title = event.target.value;
    setSettingPtz()
}

function ptzNearSpeedEleChange(event) {
    ptzInfo.selNearSpeed = event.target.value;
    ptzInfo.title = event.target.value;
    setSettingPtz()
}

function ptzFarSpeedEleChange(event) {
    ptzInfo.selFarSpeed = event.target.value;
    ptzInfo.title = event.target.value;
    setSettingPtz()
}

function ptzZoomSpeedEleChange(event) {
    ptzInfo.selZoomSpeed = event.target.value;
    ptzInfo.title = event.target.value;
    setSettingPtz()
}


function ptzTrackingModeEleChange(event) {
    const selectedIndex = event.target.options.selectedIndex
    ptzInfo.selTrackingMode = event.target.value;
    ptzInfo.selTrackingModeName = $PI.localization.ptz[ptzTrackingModeArr[selectedIndex]['name']];
    ptzInfo.title = ptzInfo.selTrackingModeName;
    setSettingPtz()
}

function ptzTrackingSpeedEleChange(event) {
    const selectedIndex = event.target.options.selectedIndex
    ptzInfo.selTrackingSpeed = event.target.value;
    ptzInfo.selTrackingSpeedName = $PI.localization.ptz[ptzTrackingSpeedArr[selectedIndex]['name']];
    ptzInfo.title = ptzInfo.selTrackingSpeedName;
    setSettingPtz()
}

function ptzTrackingTypeEleChange(event) {
    const selectedIndex = event.target.options.selectedIndex
    ptzInfo.selTrackingType = event.target.value;
    ptzInfo.selTrackingTypeName = $PI.localization.ptz[ptzTrackingTypeArr[selectedIndex]['name']];
    ptzInfo.title = ptzInfo.selTrackingTypeName;
    setSettingPtz()
}

function setSettingPtz(value, key) {
    // 判断是否有默认值
    if (ptzInfo.selFunctionItem.hasOwnProperty('paramsKey')) {
        // 如果value有设置值
        value = value || ptzInfo.selFunctionItem.paramsKey[key]
        ptzInfo.selFunctionItem.paramsKey[key] = value
    }

    const info = {
        ptzDeviceList: ptzDeviceList,
        ptzInfo: ptzInfo
    }
    console.log("save Info", info);
    setSettingInKey2(info)
}

