var recordInfo = {
  selFunction: null,
  selFuntionItem: {},
  title: 'startRecording',
  iconPath: 'startRecording'
} // 按键中需要存在的字段


var functionRecordOption = [
  { name: 'startRecording', value: '/V1.0/record/start', title: 'startRecordingTitle', path: 'startRecording' },
  { name: 'stopRecording', value: '/V1.0/record/stop', title: 'stopRecordingTitle', path: 'stopRecording' },
  { name: 'startStopRecording', value: '/V1.0/record/action', title: 'startStopRecordingTitle', path: 'startStopRecording' },
  { name: 'screenshot', value: '/V1.0/record/screenshot', title: 'screenshotTitle', path: 'screenshot' }
]

// 数据存储在按键
function setSettingRecord () {
  const info = {
    recordInfo: recordInfo
  }
  setSettingInKey2(info)
}

async function getRecordActionInfo (actionInfo) {

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings
  var actionInfoContext = {}

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('recordInfo')) {
    settingInfo = settings.recordInfo
  }

  // 查找需要的字段
  const findKey = ['selFunction','selFuntionItem', 'title', 'iconPath']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      recordInfo[item] = settingInfo[item]
    } else {
      recordInfo[item] = null
    }
  })

  getRecordFunctionDom()

}
function getRecordFunctionDom () {
  // 初始值
  if (recordInfo.selFunction === null) {
    recordInfo.selFunction = functionRecordOption[0].name
    recordInfo.selFuntionItem = functionRecordOption[0]
    recordInfo.title = functionRecordOption[0].title
    recordInfo.iconPath = functionRecordOption[0].path
    setSettingRecord()
  }


    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="recordFunOptionSel"></select>
      </div>
    `;

    const FunOptionDom = document.getElementById('recordFunOptionSel');
    FunOptionDom.addEventListener('change', sendRecordFuncionPlugin);

    mlwTools.dropDown($PI.localization.record, 'recordFunOptionSel', functionRecordOption, 'name', 'value', recordInfo.selFunction);
}

function sendRecordFuncionPlugin (event) {
  const value = event.target.value
  recordInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  recordInfo.selFuntionItem = functionRecordOption[selectedIndex]

  recordInfo.title =  recordInfo.selFuntionItem.title
  recordInfo.iconPath = recordInfo.selFuntionItem.path

  setSettingRecord()
}
