var eventList = []
var replayInfo = {
    selFunction: null,
    selFunctionItem: {},
    selReplayLens: "-1",
    lensReplayIcon:{
        path: "replayLens0",
    },
    lensEventIcon:{
        path: "eventLens0",
    },
    cameraLensIcon: {
        path: "camera0"
    },
    selCameraLens: "0",
    selCameraTitle: "replayCameraLensOneTitle",
    selReplayOptSecond: "5",
    selReplayOptSecondName: "5 secs",
    selReplaySecondsAgo: "5",
    selReplaySecondsAgoName: "-5 secs",
    selReplaySpeed: "1.0",
    selReplaySpeedIcon:{
        path:  "replaySpeed5"
    },
    selReplayRecordId: null,
    selReplayRecordName: null,
    selSpecificPosition: "0",
    selSpecificPositionName: "0 secs",
    title: "replayOfBufferTitle",
    iconPath: "replayLens0",
    progressValue: '0%',
    progress: 0
} // 按键中需要存在的字段

var replayLensArr = [
    {value: '-1', name: 'replayLensDefault'},
    {value: '0', name: 'replayLensOne'},
    {value: '1', name: 'replayLensTwo'}
];


var lensReplayLensIconArr = {
    "-1": { path: "replayLens0" },
    "0": { path: "replayLens1" },
    "1": { path: "replayLens2" }
};

var lensEventLensIconArr = {
    "-1": { path: "eventLens0" },
    "0": { path: "eventLens1" },
    "1": { path: "eventLens2" }
};

var cameraLensArr = [
    {value: '0', name: 'replayCameraLensOne'},
    {value: '1', name: 'replayCameraLensTwo'},
    {value: '2', name: 'replayCameraLensThree'}
];
var cameraLensIconArr = {
    "0": { path: "camera0" },
    "1": { path: "camera1" },
    "2": { path: "camera2" }
};

var replaySetReplaySpeedArr = [];
var tempReplaySetReplaySpeedArr = ['0.1', '0.25', '0.33', '0.5', '0.75', '1.0'];
tempReplaySetReplaySpeedArr.forEach(item => {
    replaySetReplaySpeedArr.push({
        name: item + "x",
        value: item
    });
})

var replayOptSecondArr = [];
for (let i = 1; i <= 8; i++) {
    replayOptSecondArr.push({
        name: i + " secs",
        value: i + ''
    });
}

var replaySecondsArr = [];
for (let i = 3; i <= 60; i++) {
    replaySecondsArr.push({
        name: i + " secs",
        value: i + ''
    });
}

// 配置显示规则
var divIdArr = ['replayLens', 'replayCameraLens', 'replaySecondsAgo', 'replayEvent', 'replaySpeed', "replaySpecificPosition", "replayOptSecond"];
var divRuleArr = {
    "replayOfBuffer": ['replayLens'],
    "replaySecondsAgo": ['replaySecondsAgo', 'replayLens'],
    "replayLastEvent": ['replayLens'],
    "replaySelEvent": ['replayLens', 'replayEvent'],
    "replayToSpecificPosition": ['replaySpecificPosition'],
    "replayAddEvent": ['replaySecondsAgo'],
    "replaySetReplaySpeed": ['replaySpeed'],
    "replaySwitchCamera": ['replayCameraLens'],
    "replayFastForward": ['replayOptSecond'],
    "replayFastBackward": ['replayOptSecond']

}

var replayFunctionOption = [
    {name: 'replayOfBuffer', value: '/V1.0/replay/enterReplayMode', title:"replayOfBufferTitle", path:"replayLens0", pathNext: "lensReplayIcon", paramsKey: {lensIndex: "-1"}},
    {name: 'replaySecondsAgo', value: '/V1.0/replay/replayFromSecondsAgo', title:"replaySecondsAgo",  path:"replayLens0", isNext: "selReplaySecondsAgoName", pathNext: "lensEventIcon", paramsKey: {seconds: "5", lensIndex: "-1"}},
    {name: 'replayLastEvent', value: '/V1.0/replay/replayEvent', title:"replayLastEventTitle", path:"eventLens0", pathNext: "lensEventIcon",  paramsKey: { lensIndex: "-1"}},
    {name: 'replaySelEvent', value: '/V1.0/replay/replayEvent', title:"replaySelEvent", path:"eventLens0",  isNext: "selReplayRecordName", pathNext: "lensEventIcon", paramsKey: {replayRecordId: "", lensIndex: "-1"}},
    {name: 'replayExitReplay', value: '/V1.0/replay/exitReplayMode' , title:"replayExitReplayTitle", path:"replayExitReplay" },
    {name: 'replayPause', value: '/V1.0/replay/pause', title:"replayPauseTitle", path:"replayPause"},
    {name: 'replayPlayOrResume', value: '/V1.0/replay/play', title:"replayPlayOrResumeTitle", path:"replayPlayOrResume"},
    {name: 'replayPlayOrPause', value: '/V1.0/replay/playAction', title:"replayPlayOrPauseTitle", path:"replayPlayOrPause"},
    {name: 'replayFastForward', value: '/V1.0/replay/forward', title:"replayFastForward", isNext:"selReplayOptSecondName", path:"replayFastForward", paramsKey: { offset: "5000"}},
    {name: 'replayFastBackward', value: '/V1.0/replay/backward', title:"replayFastBackward", isNext:"selReplayOptSecondName", path:"replayFastBackward", paramsKey: { offset: "5000"}},
    {name: 'replayToSpecificPosition', value: '/V1.0/replay/seek', title:"", path:"replayToSpecificPosition", isNext:"selSpecificPositionName", paramsKey: {progress: "0"}},
    {name: 'replayRewindToStart', value: '/V1.0/replay/rewindToStart', title:"replayRewindToStartTitle", path:"replayRewindToStart"},
    {name: 'replayToNextFrame', value: '/V1.0/replay/nextFrame', title:"", path:"replayToNextFrame"},
    {name: 'replayToPreviousFrame', value: '/V1.0/replay/previousFrame', title:"", path:"replayToPreviousFrame"},
    {name: 'replayAddEvent', value: '/V1.0/replay/addEvent', title:"replayAddEvent", path:"replayAddEvent", isNext: "selReplaySecondsAgoName", paramsKey: {duration: "5"}},
    {name: 'deleteAllEvents', value: '/V1.0/replay/removeAllEvents', title:"all", path:"deleteAllEvents" },
    {name: 'deleteLastEvents', value: '/V1.0/replay/removeEvents', title:"last", path:"deleteLastEvents" },

    {name: 'replaySetReplaySpeed', value: '/V1.0/replay/setSpeed', title:"", path:"replaySetReplaySpeed", pathNext: "selReplaySpeedIcon",  paramsKey: {speed: "1"}},
    {name: 'replayUnmuteSound', value: '/V1.0/replay/muteAudio', title:"replayUnmuteSoundTitle", path:"replayUnmuteSound", paramsKey: {mute: "false"}},
    {name: 'replayMuteSound', value: '/V1.0/replay/muteAudio', title:"replayMuteSoundTitle", path:"replayMuteSound", paramsKey: {mute: "true"}},
    {name: 'replayMuteOrUnmuteSound', value: '/V1.0/replay/muteAudio', title:"replayMuteOrUnmuteSoundTitle", path:"replayMuteOrUnmuteSound"},
    {name: 'replayUnmuteMicSound', value: '/V1.0/replay/muteMic', title:"replayUnmuteMicSoundTitle", path:"replayUnmuteMicSound", paramsKey: {mute: "false"}},
    {name: 'replayMuteMicSound', value: '/V1.0/replay/muteMic', title:"replayMuteMicSoundTitle", path:"replayMuteMicSound", paramsKey: {mute: "true"}},
    {name: 'replayMuteOrUnmuteMicSound', value: '/V1.0/replay/muteMic', title:"replayMuteOrUnmuteMicSoundTitle", path:"replayMuteOrUnmuteMicSound"},
    {name: 'replaySwitchCamera', value: '/V1.0/replay/selectLens', title:"", isNext: "selCameraTitle", path:"camera0",  pathNext: "cameraLensIcon",  paramsKey: {lensIndex: "-1"}}
]

async function choseOpReplay() {
    if (replayInfo.selFunctionItem.name !== 'replaySelEvent') return
    await getEventList();
    getReplayFunctionDom()
    const selectedIndex = 0
    replayInfo.selReplayRecordId = eventList[selectedIndex]['replayRecordId'];
    replayInfo.selReplayRecordName = eventList[selectedIndex]['name'];
    replayInfo.title = replayInfo.selReplayRecordName;
    setSettingReplay()
  }
async function getStatemachineReplayChange(data) {
    if(data.showListChanged){
        choseOpReplay()
    }
    if (data.instantHighlightMomentsChanged) {
        
        await getEventList()
        getReplayFunctionDom()
        
    }
}

async function getEventList() {
    try {
        const response = await request('/V1.0/replay/getEventList');
        console.log('replay event', response);
        if (response.status === 0) {
            response.eventList.forEach(item => {
                item.name = (item.customName ? item.customName : ("Event " + item.number)) + (item.clipSuffixName ? item.clipSuffixName : '');
            })

            eventList = response.eventList;
            if (!eventList.length) return;

            if(replayInfo.selReplayRecordId === null || !eventList.some(item => item.replayRecordId === replayInfo.selReplayRecordId)) {
                replayInfo.selReplayRecordId = eventList[0]["replayRecordId"];
                replayInfo.selReplayRecordName = eventList[0]["name"];
            }

            if (replayInfo.selFunctionItem.name == 'replaySelEvent') {
                setSettingReplay()
            }

        }
    } catch (err) {
        console.error('Error fetching replay list:', err);
        throw err;
    }
}

async function getReplayActionInfo(actionInfo) {
        // 存储在按键中的信息
    var settings = actionInfo.payload.settings
    var actCtxSetting = {}
    if (settings.hasOwnProperty('baseURL')) {
        baseURL = settings.baseURL
    }

    if (settings.hasOwnProperty('replayInfo')) {
        actCtxSetting = settings.replayInfo
    }

    // 查找需要的字段
    const actionKey = ['selFunction', "selCameraLens", 'selFunctionItem', 'selReplayLens', "lensReplayIcon", "lensEventIcon",  "selReplaySecondsAgo", "selReplaySecondsAgoName", "selReplaySpeed",
        "selReplayRecordId", "selReplayRecordName", "cameraIcon", "selSpecificPosition", "selSpecificPositionName", 'title', 'iconPath',
        "selReplayOptSecond", "selReplayOptSecondName", "progressValue", "progress",
        "selCameraTitle"
    ];
    // 字段是否存在,存在赋值,不存在为null
    actionKey.forEach(item => {
        if (actCtxSetting.hasOwnProperty(item)) {
            replayInfo[item] = actCtxSetting[item]
        } else {
            replayInfo[item] = replayInfo[item] ? replayInfo[item] : null;
        }
    })
    if (controller === 'Keypad') {
        await getEventList();
        getReplayFunctionDom()
    }
    replayInfo.title =  replayInfo.selReplayRecordName;


    
    
}

function getReplayFunctionDom() {
    // 初始值
    if (replayInfo.selFunction === null) {
        replayInfo.selFunction = replayFunctionOption[0].value
        replayInfo.selFunctionItem = replayFunctionOption[0];
        setSettingReplay()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="replayFunOptionSel"></select>
    </div>
     <div class="sdpi-item" id="replaySecondsAgo">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replaySecondsAgoLabel} </div>
        <select class="sdpi-item-value select setvalueSelect" id="replaySecondsAgoEle"></select>
     </div>
     <div class="sdpi-item" id="replayOptSecond">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replaySecondsAgoLabel} </div>
        <select class="sdpi-item-value select setvalueSelect" id="replayOptSecondEle"></select>
     </div>
     
     <div class="sdpi-item" id="replayEvent">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replayEventLabel} </div>
        <select class="sdpi-item-value select setvalueSelect" id="replayEventEle"></select>
     </div>
     <div type="range"  class="sdpi-item" id="replaySpecificPosition">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replaySpecificPositionLabel} </div>
        <div class="sdpi-item-value">
          <span class="clickable" value=0>0</span>
          <input class="floating-tooltip" data-suffix=" secs" type="range" id="replaySpecificPositionEle" min="0" max="60" step="1" value="${replayInfo.selSpecificPosition}">
          <span class="clickable" value="60">60</span>
      </div>
        
      
     </div>
     <div class="sdpi-item" id="replaySpeed">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replaySpeedLabel} </div>
        <select class="sdpi-item-value select setvalueSelect" id="replaySpeedEle"></select>
     </div>
     <div class="sdpi-item" id="replayLens">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replayLensLabel} </div>
        <select class="sdpi-item-value select setvalueSelect" id="replayLensEle"></select>
     </div>
     
     <div class="sdpi-item" id="replayCameraLens">
        <div class="sdpi-item-label"> ${$PI.localization.replay.replayLensLabel} </div>
        <select class="sdpi-item-value select setvalueSelect" id="replayCameraLensEle"></select>
     </div>
  `;
    initToolTips();

    const FunOptionDom = document.getElementById('replayFunOptionSel');
    FunOptionDom.addEventListener('change', replayFunOptionSelChange);
    let select = document.getElementById('replayFunOptionSel');
    select.innerHTML = '';
    let frag = document.createDocumentFragment();
    for (var i = 0; i < replayFunctionOption.length; i++) {
        let item = replayFunctionOption[i];
        let option = document.createElement("option");

        option.innerHTML = $PI.localization.replay[item['name']];
        option.value = item['value'];
        if (replayInfo.selFunction !== null && item.name === replayInfo.selFunctionItem.name && replayInfo.selFunction == item['value']) {
            option.selected = true
        }
        frag.appendChild(option);
    }
    select.appendChild(frag);

    // 回放镜头的改变
    document.getElementById('replayLensEle').addEventListener('change', replayLensEleChange);
    mlwTools.dropDown($PI.localization.replay, 'replayLensEle', replayLensArr, 'name', 'value', replayInfo.selReplayLens);

    // 切换镜头
    document.getElementById('replayCameraLens').addEventListener('change', cameraLensEleChange);
    mlwTools.dropDown($PI.localization.replay, 'replayCameraLensEle', cameraLensArr, 'name', 'value', replayInfo.selCameraLens);

    // 时间改变
    document.getElementById('replaySecondsAgoEle').addEventListener('change', replaySecondsAgoEleChange);
    mlwTools.dropDown(false, 'replaySecondsAgoEle', replaySecondsArr, 'name', 'value', replayInfo.selReplaySecondsAgo);

    // 快进快退时间改变
    document.getElementById('replayOptSecond').addEventListener('change', replayOptSecondEleChange);
    mlwTools.dropDown(false, 'replayOptSecondEle', replayOptSecondArr, 'name', 'value', replayInfo.selReplayOptSecond);

    // 进度条
    document.getElementById('replaySpecificPositionEle').addEventListener('input', replaySpecificPositionEleChange);

    // Event change
    document.getElementById('replayEventEle').addEventListener('change', replayEventEleChange);
    mlwTools.dropDown(false, 'replayEventEle', eventList, 'name', 'replayRecordId', replayInfo.selReplayRecordId);

    // 设置速度
    document.getElementById('replaySpeedEle').addEventListener('change', replaySpeedChange);
    mlwTools.dropDown(false, 'replaySpeedEle', replaySetReplaySpeedArr, 'name', 'value', replayInfo.selReplaySpeed);

    // 判断选择的功能展示对应dom
    mlwTools.divSwitchShowOrHideRule(divIdArr, divRuleArr, replayInfo.selFunctionItem.name)
}

function replayFunOptionSelChange(event) {
    const value = event.target.value
    const selectedIndex = event.target.options.selectedIndex
    replayInfo.selFunctionItem = replayFunctionOption[selectedIndex]
    replayInfo.selFunction = value

    console.log('replay replayFunOptionSelChange', replayInfo);

    replayInfo.iconPath = mlwTools.findNextFunIconPath(replayInfo, replayInfo.selFunctionItem)
    replayInfo.title = mlwTools.findNextFunTitle(replayInfo, replayInfo.selFunctionItem);
    // 判断选择的功能展示对应dom
    console.log('mlwTools', replayFunctionOption, replayInfo.selFunction)
    mlwTools.divSwitchShowOrHideRule(divIdArr, divRuleArr, replayInfo.selFunctionItem.name);

    setSettingReplay()
}

function replayLensEleChange(event) {
    let selValue = event.target.value;
    replayInfo.selReplayLens = selValue;
    let { name } = replayInfo.selFunctionItem;
    console.log("replay", replayInfo);
    // 根据当前是什么方法, 来设置对应的操作
    replayInfo.lensReplayIcon.path = lensReplayLensIconArr[selValue].path;
    replayInfo.lensEventIcon.path = lensEventLensIconArr[selValue].path;
    console.log('replay change', name);
    switch (name) {
        case "replayOfBuffer":
            replayInfo.iconPath = replayInfo.lensReplayIcon.path ;
            break;
        case "replaySecondsAgo":
        case "replayLastEvent":
        case "replaySelEvent":
            replayInfo.iconPath = replayInfo.lensEventIcon.path ;
            break;
    }

    console.log('replay change', replayInfo);

    setSettingReplay()
}


function cameraLensEleChange(event) {
    let selValue = event.target.value;
    replayInfo.selCameraLens = selValue;
    // 根据当前是什么方法, 来设置对应的操作
    replayInfo.cameraLensIcon.path = cameraLensIconArr[selValue].path;
    replayInfo.iconPath = replayInfo.cameraLensIcon.path ;
    if(selValue ==="0") {
        replayInfo.selCameraTitle = "replayCameraLensOneTitle";
    } else if(selValue ==="1") {
        replayInfo.selCameraTitle = "replayCameraLensTwoTitle";
    } else if(selValue ==="2") {
        replayInfo.selCameraTitle = "replayCameraLensThreeTitle";
    }
    replayInfo.title =  replayInfo.selCameraTitle;

    setSettingReplay()
}


function replaySecondsAgoEleChange(event) {
    replayInfo.selReplaySecondsAgo = event.target.value;
    replayInfo.selReplaySecondsAgoName = "-"+event.target.value+" secs";
    replayInfo.title =  replayInfo.selReplaySecondsAgoName;
    console.log(replayInfo);
    setSettingReplay()
}

function replayOptSecondEleChange(event) {
    replayInfo.selReplayOptSecond = event.target.value;
    replayInfo.selReplayOptSecondName = event.target.value+" secs";
    replayInfo.title =  replayInfo.selReplayOptSecondName;
    setSettingReplay()
}

function replaySpecificPositionEleChange(event) {
    replayInfo.selSpecificPosition = event.target.value;
    replayInfo.selSpecificPositionName = event.target.value + ' secs';
    replayInfo.title =   replayInfo.selSpecificPositionName;
    console.log(replayInfo);
    setSettingReplay()
}

function replayEventEleChange(event) {
    const selectedIndex = event.target.options.selectedIndex
    replayInfo.selReplayRecordId = event.target.value;
    replayInfo.selReplayRecordName = eventList[selectedIndex]['name'];
    replayInfo.title = replayInfo.selReplayRecordName;
    // console.log(eventList[selectedIndex])
    setSettingReplay()
}

function replaySpeedChange(event) {
    const selectedIndex = event.target.options.selectedIndex
    replayInfo.selReplaySpeed = event.target.value;
    replayInfo.selReplaySpeedIcon.path = "replaySpeed"+selectedIndex;
    replayInfo.iconPath = replayInfo.selReplaySpeedIcon.path;
    setSettingReplay()
}

function setSettingReplay(value, key) {
    // 判断是否有默认值
    if (replayInfo.selFunctionItem.hasOwnProperty('paramsKey')) {
        // 如果value有设置值
        value = value || replayInfo.selFunctionItem.paramsKey[key]
        replayInfo.selFunctionItem.paramsKey[key] = value
    }

    const info = {
        eventList: eventList,
        replayInfo: replayInfo
    }
    setSettingInKey2(info)
}
