// 注要判断是否有ip地址

var sceneList = [] // 场景列表
var isFirst = true // 是否是初次加载

var sceneNeedInfo = {
  selFunction: null,
  selSceneUuid: null,
  selSceneName: null,
  selFuntionItem: {}
} // 按键中需要存在的字段

// 场景相关操作
var functionSceneOption = [
  { name: 'switchSpecificScene', value: '/V1.0/scene/switchByUUID', title: 'specific' },
  { name: 'switchFirstScene', value: '/V1.0/scene/first', title: 'first' },
  { name: 'switchLastScene', value: '/V1.0/scene/last', title: 'last' },
  { name: 'SwitchNextScene', value: '/V1.0/scene/next', title: 'next' },
  { name: 'SwitchPreviousScene', value: '/V1.0/scene/previous', title: 'previous' },
  { name: 'switchPreviewPgm', value: '/V1.0/scene/previewToPGM', title: 'toPgm' }
]

function choseOpScene() {
  const list = sceneList
  let selScene = sceneNeedInfo.selSceneUuid
  if (list.length > 0) {
    const isHav = list.some(item => {
      return item.uuid == sceneNeedInfo.selSceneUuid
    })
    if (!isHav) {
      selScene = list[0].uuid
      sceneNeedInfo.selSceneUuid = list[0].uuid
      sceneNeedInfo.selSceneName = list[0].sceneName
      setSettingScene()
    }
  } 
}
// 轮询通知中有场景列表变更的通知,每次变更要重新获取列表
async function getStatemachineScene(data) {
  if (data.sceneListChanged) {
    await getSceneList()
    const list = sceneList
    let selScene = sceneNeedInfo.selSceneUuid

    if (list.length > 0) {
      const isHav = list.some(item => {
        return item.uuid == sceneNeedInfo.selSceneUuid
      })

      if (!isHav) {
        selScene = list[0].uuid
        sceneNeedInfo.selSceneUuid = list[0].uuid
        sceneNeedInfo.selSceneName = list[0].sceneName

        if (sceneNeedInfo.selFuntionItem.name === 'switchSpecificScene') {
          setSettingScene()
        }
      }
    } else {
      selScene = ''
    }
    mlwTools.dropDown(false, 'sceneOptionSel', sceneList, 'sceneName', 'uuid', selScene)
  }
}

// 获取场景列表请求
async function getSceneList() {
  try {
    const response = await request('/mwapi/scene/get-scenes-list');

    if (response.status === 0) {
      isFirst = false
      sceneList = response.sceneList
    }
  } catch (err) {
    console.error('Error fetching Scene list:', err);
    throw err;
  }
}

// 数据存储在按键
function setSettingScene () {
  const info = {
    sceneList: sceneList,
    sceneInfo: sceneNeedInfo
  }
  setSettingInKey2(info)
}

async function getSceneActionInfo (actionInfo) {
  await getSceneList()

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings
  var sceneSetting = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('sceneInfo')) {
    sceneSetting = settings.sceneInfo
  }

  // 查找需要的字段
  const sceneKey = ['selFunction', 'selSceneUuid', 'selFuntionItem', 'selSceneName']
  // 字段是否存在,存在赋值,不存在为null
  sceneKey.forEach(item => {
    if (sceneSetting.hasOwnProperty(item)) {
      sceneNeedInfo[item] = sceneSetting[item]
    } else {
      sceneNeedInfo[item] = null
    }
  })

  getSceneFunctionDom()
  choseOpScene()
}
function getSceneFunctionDom () {
    // 初始值
    if (sceneNeedInfo.selFunction === null) {
      sceneNeedInfo.selFunction = functionSceneOption[0].value
      sceneNeedInfo.selFuntionItem = functionSceneOption[0]
      setSettingScene()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="sceneFunOptionSel"></select>
      </div>
      <div class="sdpi-item" id="select-scene-list" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.scene.sceneName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="sceneOptionSel"></select>
      </div>
    `;

    const FunOptionDom = document.getElementById('sceneFunOptionSel');
    FunOptionDom.addEventListener('change', sendFuncionPlugin);

    mlwTools.dropDown($PI.localization.scene, 'sceneFunOptionSel', functionSceneOption, 'name', 'value', sceneNeedInfo.selFunction);

    // 判断选择的功能是否是Switch to the specific scene
    if (sceneNeedInfo.selFunction === '/V1.0/scene/switchByUUID') {
      document.getElementById('select-scene-list').style.display = 'inline-flex'
      addSwitchSceneOption()
    } else {
      document.getElementById('select-scene-list').style.display = 'none'
    }
}
// 场景下拉列表,选择指定场景
function addSwitchSceneOption () {
  const element = document.getElementById('sceneOptionSel');
  element.addEventListener('change', sendValueToPlugin);
  createdSceneOption()
}
function createdSceneOption() {
  if (sceneList.length === 0) {
    setTimeout(() => {
      createdSceneOption()
    }, 500)
    return
  }

  // 初始值
  if (sceneNeedInfo.selSceneUuid === null) {
    sceneNeedInfo.selSceneUuid = sceneList[0].uuid
    sceneNeedInfo.selSceneName = sceneList[0].sceneName
    setSettingScene()
  }

  mlwTools.dropDown(false, 'sceneOptionSel', sceneList, 'sceneName', 'uuid', sceneNeedInfo.selSceneUuid)
}

function sendFuncionPlugin (event) {
  const value = event.target.value
  sceneNeedInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  sceneNeedInfo.selFuntionItem = functionSceneOption[selectedIndex]

  // 判断选择的功能是否是Switch to the specific scene
  if (value === '/V1.0/scene/switchByUUID') {
    document.getElementById('select-scene-list').style.display = 'inline-flex'
    addSwitchSceneOption()
  } else {
    document.getElementById('select-scene-list').style.display = 'none'
  }
  setSettingScene()
}

function sendValueToPlugin (event) {
  const value = event.target.value
  sceneNeedInfo.selSceneUuid = value
  const selectedIndex = event.target.options.selectedIndex

  sceneNeedInfo.selSceneName = sceneList[selectedIndex].sceneName

  setSettingScene()
}
