var scoreboardInfo = {
  selFunction: null,
  selFuntionItem: {},
  title: 'resetScoreboard',
  iconPath: 'resetScoreboard',
  adjustTeamScore: 0,
  adjustGameTime: '0',
  adjustGameTimeSeconds: '0s',
  adjustOutBaseball: null,
  ballChange: null,
  strikeChange: null,
  basePosition: 1,
  touchBase: true,
  stoppageSecond: 0,
  selTeamHomeItem: {},
  selTeamValue: null,
  selOutBaseballItem: {},
  ballStrikeChange: 0,
  strikeBallChange: 0,
  ballChangeItem: {},
  ballStrikeItem: {},
  stoppageMin: 0,
  setRunnersArr: [0, 0, 0],
  runnerPosition1: 0,
  runnerPosition2: 0,
  runnerPosition3: 0,
  stoppageMinAdd: '+0'
} // 按键中需要存在的字段


var functionScoreboardOption = [
  { name: 'resetScoreboard', value: '/V1.0/gfx/scoreboard/reset', title: 'scoreboard', path: 'resetScoreboard' },
  { name: 'adjustTeamScore', domId: ['selTeamNameId', 'selTeamScoreId'], value: 'scoreboardTeamHomeList', isRequest: 'selTeamHomeItem', isNext: 'adjustTeamScore', pathNext: 'selTeamHomeItem', title: '', path: 'adjustTeamHomeScore' },
  { name: 'goToFirstPeriodInning', value: '/V1.0/gfx/scoreboard/firstPeriod', title: 'first', path: 'goToFirstPeriodInning' },
  { name: 'goToLastPeriodInning', value: '/V1.0/gfx/scoreboard/lastPeriod', title: 'last', path: 'goToLastPeriodInning' },
  { name: 'goToNextPeriodInning', value: '/V1.0/gfx/scoreboard/nextPeriod', title: 'next', path: 'goToNextPeriodInning' },
  { name: 'goToPreviousPeriodInning', value: '/V1.0/gfx/scoreboard/previousPeriod', title: 'previous', path: 'goToPreviousPeriodInning' },
  { name: 'playGameTime', value: '/V1.0/gfx/scoreboard/playGameTime', title: 'play', path: 'playGameTime' },
  { name: 'pauseGameTime', value: '/V1.0/gfx/scoreboard/pauseGameTime', title: 'pause', path: 'pauseGameTime' },
  { name: 'playPauseGameTime', value: '/V1.0/gfx/scoreboard/gameTimeAction', title: 'playOrPause', path: 'playPauseGameTime' },
  { name: 'adjustGameTime', domId: ['adjustGameTimeId'],value: '/V1.0/gfx/scoreboard/adjustGameTime', paramsKey: { seconds: 'adjustGameTime' }, isNext: 'adjustGameTimeSeconds', title: 'adjustGameTimeSeconds', path: 'adjustGameTime' },
  { name: 'resetGameTime', value: '/V1.0/gfx/scoreboard/resetGameTime', title: 'gameTime', path: 'resetScoreboardTime' },
  { name: 'adjustOutBaseball', domId: ['adjustOutBaseballId'], value: '/V1.0/gfx/scoreboard/adjustOut', pathNext: 'selOutBaseballItem', paramsKey: { change: 'adjustOutBaseball' }, title: 'out', path: 'adjustBallStrike1' },
  { name: 'adjustBallBaseball', domId: ['adjustBallBaseball'], value: '/V1.0/gfx/scoreboard/adjustBallStrike', pathNext: 'ballChangeItem',  paramsKey: { ballChange: 'ballChange', strikeChange: 'ballStrikeChange' }, title: 'ball', path: 'adjustBallStrike1' },
  { name: 'adjustStrikeBaseball', domId: ['adjustStrikeBaseball'], value: '/V1.0/gfx/scoreboard/adjustBallStrike', pathNext: 'ballStrikeItem', paramsKey: { ballChange: 'strikeBallChange', strikeChange: 'strikeChange' }, title: 'Strike', path: 'adjustBallStrike1' },
  { name: 'setBaseRunnersBaseball', domId: ['setBaseRunnersBaseball'], value: '/V1.0/gfx/scoreboard/updateOnBaseRunners', paramsKey: { position1: 'runnerPosition1', position2: 'runnerPosition2', position3: 'runnerPosition3' }, title: 'runners', path: 'runnerBaseBall1' },
  { name: 'clearPitchCount', value: '/V1.0/gfx/scoreboard/clearPitchCount', title: 'clearPitch', path: 'clearPitchCount' },
  { name: 'setStoppageTime', domId: ['setStoppageTimeId'],value: '/V1.0/gfx/scoreboard/setFootballStoppageTime', paramsKey: { seconds: 'stoppageSecond' }, isNext: 'stoppageMinAdd',title: '', path: 'setStoppageTime' },
  { name: 'resetStoppageTime', value: '/V1.0/gfx/scoreboard/setFootballStoppageTime?seconds=0', title: 'stoppageTime', path: 'resetScoreboardTime' },
  { name: 'showStoppageTime', value: '/V1.0/gfx/scoreboard/showFootballStoppageTime?show=true', title: 'showStoppageTimeTitle', path: 'showStoppageTime' },
  { name: 'hideStoppageTime', value: '/V1.0/gfx/scoreboard/showFootballStoppageTime?show=false', title: 'hideStoppageTimeTitle', path: 'hideStoppageTime' },
  { name: 'showOrHideStoppageTime', value: '/V1.0/gfx/scoreboard/showFootballStoppageTime', title: 'showOrHideStoppageTimeTitle', path: 'showOrHideStoppageTime' },
  { name: 'showSubstitution', value: '/V1.0/gfx/scoreboard/showFootballStagePlayer?show=true', title: 'showSubstitutionTitle', path: 'showStoppageTime' },
  { name: 'hideSubstitution', value: '/V1.0/gfx/scoreboard/showFootballStagePlayer?show=false', title: 'hideSubstitutionTitle', path: 'hideStoppageTime' },
  { name: 'showOrHideSubstitution', value: '/V1.0/gfx/scoreboard/showFootballStagePlayer', title: 'showOrHideSubstitutionTitle', path: 'showOrHideStoppageTime' }
]

var scoreboardTeamHomeList = [
  { name: 'home', value: '/V1.0/gfx/scoreboard/updateScoreOfHome', title: 'home', paramsKey: { changeScore: 'adjustTeamScore' }, path: 'adjustTeamHomeScore' },
  { name: 'guest', value: '/V1.0/gfx/scoreboard/updateScoreOfGuest', title: 'guest', paramsKey: { changeScore: 'adjustTeamScore' }, path: 'adjustTeamGuestScore'  }
]

var outBaseballOption = [
  { name: -2, value: -2, title: 'out', path: 'adjustBallStrikeMinus2' },
  { name: -1, value: -1, title: 'out', path: 'adjustBallStrikeMinus1' },
  // { name: 0, value: 0, title: 'out', path: 'adjustBallStrike0' },
  { name: 1, value: 1, title: 'out', path: 'adjustBallStrike1' },
  { name: 2, value: 2, title: 'out', path: 'adjustBallStrike2' }
]

var baseballBallOption = [
  { name: -3, value: -3, title: 'ball', path: 'adjustBallStrikeMinus3' },
  { name: -2, value: -2, title: 'ball', path: 'adjustBallStrikeMinus2' },
  { name: -1, value: -1, title: 'ball', path: 'adjustBallStrikeMinus1' },
  // { name: 0, value: 0, title: 'ball', path: 'adjustBallStrike0' },
  { name: 1, value: 1, title: 'ball', path: 'adjustBallStrike1' },
  { name: 2, value: 2, title: 'ball', path: 'adjustBallStrike2' },
  { name: 3, value: 3, title: 'ball', path: 'adjustBallStrike3' }
]

var strikeBaseOption = [
  { name: -2, value: -2, title: 'strike', path: 'adjustBallStrikeMinus2' },
  { name: -1, value: -1, title: 'strike', path: 'adjustBallStrikeMinus1' },
  // { name: 0, value: 0, title: 'strike', path: 'adjustBallStrike0' },
  { name: 1, value: 1, title: 'strike', path: 'adjustBallStrike1' },
  { name: 2, value: 2, title: 'strike', path: 'adjustBallStrike2' }
]

var runnerBaseBallIconArr = {
  '000': 'runnerBaseBall1',
  '001': 'runnerBaseBall2',
  '010': 'runnerBaseBall3',
  '100': 'runnerBaseBall4',
  '101': 'runnerBaseBall5',
  '011': 'runnerBaseBall6',
  '111': 'runnerBaseBall7',
  '110': 'runnerBaseBall8'
}
// 数据存储在按键
function setSettingScoreboard () {
  const info = {
    scoreboardInfo: scoreboardInfo
  }
  setSettingInKey2(info)
}

async function getScoreboardActionInfo (actionInfo) {

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('scoreboardInfo')) {
    settingInfo = settings.scoreboardInfo
  }
  // 查找需要的字段
  const findKey = ['selFunction', 'selFuntionItem', 'title', 'iconPath', 'adjustTeamScore', 'adjustGameTime', 'adjustGameTimeSeconds', 'adjustOutBaseball',
  'ballChange', 'strikeChange', 'basePosition', 'touchBase', 'stoppageSecond', 'selTeamHomeItem', 'selTeamValue', 'selOutBaseballItem', 'ballStrikeChange',
  'strikeBallChange', 'ballChangeItem', 'ballStrikeItem', 'stoppageMin', 'setRunnersArr', 'runnerPosition1', 'runnerPosition2', 'runnerPosition3', 'stoppageMinAdd']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      scoreboardInfo[item] = settingInfo[item]
    } else {
      scoreboardInfo[item] = scoreboardInfo[item] === null ? null : scoreboardInfo[item]
    }
  })

  getScoreboardFunctionDom()

}
/* <div class="sdpi-item" id="adjustGameTimeId">
<div class="sdpi-item-label"> ${$PI.localization.scoreboard.time}</div>
<input class="sdpi-item-value" id="adjustGameTimeSlider" type="time" step="2" value="${scoreboardInfo.adjustGameTime}">
</div> */
function getScoreboardFunctionDom () {
  // 初始值
  if (scoreboardInfo.selFunction === null) {
    scoreboardInfo.selFunction = functionScoreboardOption[0].name
    scoreboardInfo.selFuntionItem = functionScoreboardOption[0]
    scoreboardInfo.title = functionScoreboardOption[0].title
    scoreboardInfo.iconPath = functionScoreboardOption[0].path
    setSettingScoreboard()
  }


    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="scoreboardFunOptionSel"></select>
      </div>
      <div class="sdpi-item" id="selTeamNameId">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.teamName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="setTeamNameId">
        </select>
      </div>
      <div type="range" class="sdpi-item" id="selTeamScoreId">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.score} </div>
        <div class="sdpi-item-value">
            <span class="clickable" value=-100>-100</span>
            <input class="floating-tooltip" data-suffix="" type="range" id="scoreboardTeamScore" min="-100" max="100" step="1" value="${scoreboardInfo.adjustTeamScore}">
            <span class="clickable" value="100">100</span>
        </div>
      </div>
      <div type="range" class="sdpi-item" id="adjustGameTimeId">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.timeLengths}</div>
        <div class="sdpi-item-value">
        <span class="clickable" value=-100>-100s</span>
        <input class="floating-tooltip" data-suffix="s" type="range" id="adjustGameTimeSlider" min="-100" max="100" step="1" value="${scoreboardInfo.adjustGameTime}">
        <span class="clickable" value="100">100s</span>
        </div>
      </div>
      <div class="sdpi-item" id="adjustOutBaseballId">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.out} </div>
        <select class="sdpi-item-value select setvalueSelect" id="setOutBaseballId">
        </select>
      </div>
      <div class="sdpi-item" id="adjustBallBaseball">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.ball} </div>
        <select class="sdpi-item-value select setvalueSelect" id="setBallBaseballId">
        </select>
      </div>
      <div class="sdpi-item" id="adjustStrikeBaseball">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.strike} </div>
        <select class="sdpi-item-value select setvalueSelect" id="setStrikeBaseballlId">
        </select>
      </div>
      <div type="checkbox" class="sdpi-item" id="setBaseRunnersBaseball">
        <div class="sdpi-item-label">${$PI.localization.scoreboard.basePosition}</div>
        <div class="sdpi-item-value min50">
          <div class="sdpi-item-child">
            <input id="runnerOne" type="checkbox" name="runnerBaseBall" value="0">
            <label for="runnerOne" class="sdpi-item-label"><span></span>1</label>
          </div>
          <div class="sdpi-item-child">
              <input id="runnerTwo" type="checkbox" name="runnerBaseBall" value="1">
              <label for="runnerTwo" class="sdpi-item-label"><span></span>2</label>
          </div>
          <div class="sdpi-item-child">
            <input id="runnerThree" type="checkbox" name="runnerBaseBall" value="2">
            <label for="runnerThree" class="sdpi-item-label"><span></span>3</label>
          </div>
        </div>
      </div>
      <div type="range" class="sdpi-item" id="setStoppageTimeId">
        <div class="sdpi-item-label"> ${$PI.localization.scoreboard.min}</div>
        <div class="sdpi-item-value">
        <span class="clickable" value=0>0</span>
        <input class="floating-tooltip" data-suffix="" type="range" id="adjustStoppageTimeSlider" min="0" max="59" step="1" value="${scoreboardInfo.stoppageMin}">
        <span class="clickable" value="59">59</span>
        </div>
      </div>
    `;
    initToolTips();

    // 功能相关下拉选项
    mlwTools.dropDown($PI.localization.scoreboard, 'scoreboardFunOptionSel', functionScoreboardOption, 'name', 'name', scoreboardInfo.selFunction);
    const FunOptionDom = document.getElementById('scoreboardFunOptionSel');
    FunOptionDom.addEventListener('change', sendScoreboardFuncionPlugin);

    // 选择主队客队
    mlwTools.dropDown($PI.localization.scoreboard, 'setTeamNameId', scoreboardTeamHomeList, 'name', 'value', scoreboardInfo.selTeamValue);
    document.getElementById('setTeamNameId').addEventListener('change', teamNameChange);
    setScoreboardListOptionDefaultItem(scoreboardTeamHomeList[0], 'value', 'selTeamValue', 'selTeamHomeItem')

    document.getElementById('scoreboardTeamScore').addEventListener('input', scoreboardTeamScoreChanged);

    document.getElementById('adjustGameTimeSlider').addEventListener('input', scoreboardAdjustGameTimeChanged);

    setScoreboardListOptionDefaultItem(outBaseballOption[2], 'value', 'adjustOutBaseball', 'selOutBaseballItem')
    mlwTools.dropDown(false, 'setOutBaseballId', outBaseballOption, 'name', 'value', scoreboardInfo.adjustOutBaseball);
    document.getElementById('setOutBaseballId').addEventListener('input', scoreboardAdjustOutChanged);

    setScoreboardListOptionDefaultItem(baseballBallOption[3], 'value', 'ballChange', 'ballChangeItem')
    mlwTools.dropDown(false, 'setBallBaseballId', baseballBallOption, 'name', 'value', scoreboardInfo.ballChange);
    document.getElementById('setBallBaseballId').addEventListener('input', setBallBaseballChanged);

    setScoreboardListOptionDefaultItem(strikeBaseOption[2], 'value', 'strikeChange', 'ballStrikeItem')
    mlwTools.dropDown(false, 'setStrikeBaseballlId', strikeBaseOption, 'name', 'value', scoreboardInfo.strikeChange);
    document.getElementById('setStrikeBaseballlId').addEventListener('input', setStrikeBaseballChanged);


    document.getElementById('adjustStoppageTimeSlider').addEventListener('input', adjustStoppageTimeChanged);

    document.getElementById('runnerOne').addEventListener('click', changeRunnerBaseBall);
    document.getElementById('runnerTwo').addEventListener('click', changeRunnerBaseBall);
    document.getElementById('runnerThree').addEventListener('click', changeRunnerBaseBall);
    setRunnersBaseBallDefault()

    mlwTools.domArrFunctionDisplay(functionScoreboardOption, 'name', scoreboardInfo.selFunction)

}

// 设置棒球记分牌跑垒默认值
function setRunnersBaseBallDefault () {
  var arr = document.getElementsByName("runnerBaseBall")
	var checkList = scoreboardInfo.setRunnersArr
	for(i = 0; i < arr.length; i++){
    if (checkList[i] == 1) {
      arr[i].checked = true
    } else {
      arr[i].checked = false
    }
  }

  if (scoreboardInfo.selFunction == 'setBaseRunnersBaseball') {
    scoreboardInfo.runnerPosition1 = checkList[0] === 1
    scoreboardInfo.runnerPosition2 = checkList[1] === 1
    scoreboardInfo.runnerPosition3 = checkList[2] === 1

    const runerArr = checkList.reverse()
    var number = runerArr.join('')

    scoreboardInfo.iconPath = runnerBaseBallIconArr[number]
  }
}

// 设置默认值
function setScoreboardListOptionDefaultItem (item, itemKey, key, selKey) {
  if (scoreboardInfo[key] === null) {
    scoreboardInfo[key] = item[itemKey]
    scoreboardInfo[selKey] = item
  }
}
// 选择功能
function sendScoreboardFuncionPlugin (event) {
  const value = event.target.value
  scoreboardInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  scoreboardInfo.selFuntionItem = functionScoreboardOption[selectedIndex]

  scoreboardInfo.iconPath = mlwTools.findNextFunIconPath(scoreboardInfo, scoreboardInfo.selFuntionItem)

  scoreboardInfo.title = mlwTools.findNextFunTitle(scoreboardInfo, scoreboardInfo.selFuntionItem)

  mlwTools.domArrFunctionDisplay(functionScoreboardOption, 'name', scoreboardInfo.selFunction)

  if (scoreboardInfo.selFunction == 'setBaseRunnersBaseball') {
    setRunnersBaseBallDefault()
  }


  setSettingScoreboard()
}

// 选择记分牌主队客队
function teamNameChange (event) {
  const value = event.target.value
  scoreboardInfo.selTeamValue = value

  const selectedIndex = event.target.options.selectedIndex
  scoreboardInfo.selTeamHomeItem = scoreboardTeamHomeList[selectedIndex]

  scoreboardInfo.iconPath = scoreboardTeamHomeList[selectedIndex].path

  setSettingScoreboard()
}
// 设置主队客队分数
function scoreboardTeamScoreChanged (event) {
  const value = event.target.value
  scoreboardInfo.adjustTeamScore = value
  scoreboardInfo.title = value > 0 ? '+' + value : value

  setSettingScoreboard()
}
// 设置比赛时间
function scoreboardAdjustGameTimeChanged (event) {
  const value = event.target.value
  scoreboardInfo.adjustGameTime = value
  scoreboardInfo.adjustGameTimeSeconds = value + 's'
  scoreboardInfo.title = value > 0 ? '+' + value + 's' : value + 's'

  setSettingScoreboard()
}

// 棒球记分牌设置出局数
function scoreboardAdjustOutChanged (event) {
  const value = event.target.value
  scoreboardInfo.adjustOutBaseball = value
  // scoreboardInfo.title = value

  const index = event.target.options.selectedIndex

  scoreboardInfo.selOutBaseballItem = outBaseballOption[index]
  scoreboardInfo.iconPath = outBaseballOption[index].path

  setSettingScoreboard()
}

// 棒球记分牌设置坏球数
function setBallBaseballChanged (event) {
  const value = event.target.value
  scoreboardInfo.ballChange = value
  // scoreboardInfo.title = value

  const index = event.target.options.selectedIndex

  scoreboardInfo.ballChangeItem = baseballBallOption[index]
  scoreboardInfo.iconPath = baseballBallOption[index].path

  setSettingScoreboard()
}

// 棒球记分牌设置Strike
function setStrikeBaseballChanged (event) {
  const value = event.target.value
  scoreboardInfo.strikeChange = value
  // scoreboardInfo.title = value

  const index = event.target.options.selectedIndex

  ballStrikeItem = strikeBaseOption[index]
  scoreboardInfo.iconPath = strikeBaseOption[index].path

  setSettingScoreboard()
}

// 足球记分牌补时时时间
function adjustStoppageTimeChanged (event) {
  const value = event.target.value
  scoreboardInfo.stoppageMin = value
  scoreboardInfo.stoppageMinAdd = '+' + value
  scoreboardInfo.stoppageSecond = value * 60
  scoreboardInfo.title = '+' + value

  setSettingScoreboard()
}

function changeRunnerBaseBall () {
  var arr = document.getElementsByName("runnerBaseBall")
	var checkList = [0, 0, 0]
	for(i = 0; i < arr.length; i++){
		if(arr[i].checked){

			checkList[i] = 1
		} else {
      checkList[i] = 0
    }
  }

  scoreboardInfo.runnerPosition1 = checkList[0] === 1
  scoreboardInfo.runnerPosition2 = checkList[1] === 1
  scoreboardInfo.runnerPosition3 = checkList[2] === 1

  scoreboardInfo.setRunnersArr = [...checkList]

  const runerArr = checkList.reverse()
  var number = runerArr.join('')

  scoreboardInfo.iconPath = runnerBaseBallIconArr[number]

  setSettingScoreboard()
}
