
var shortcutList = [] // 场景列表

var shortcutsInfo = {
  selShortcut: null,
  selShortcutItem: null,
  title: 'shortcuts'
} // 按键中需要存在的字段

// 轮询通知中有快捷键列表变更的通知
async function getStatemachineShortcutChange(data) {
  if (data.shortcutsListChanged) {
    getShortcutActionInfo(getShortcutActionInfoObj)
  }
}
// 获取 shortcut 列表
async function getShortcutList() {
  try {
    const response = await request('/V1.0/shortcuts/getConfig');

    if (response.status === 0) {
      shortcutList = response.list
    }
  } catch (err) {
    console.error('Error fetching Shortcut list:', err);
    throw err;
  }
}

// 数据存储在按键
function setSettingShortcuts () {
  const info = {
    shortcutsInfo: shortcutsInfo
  }
  setSettingInKey2(info)
}
let getShortcutActionInfoObj ={}
async function getShortcutActionInfo (actionInfo) {
  // await getShortcutList()
  getShortcutActionInfoObj = actionInfo
  // 存储在按键中的信息
  var settings = actionInfo.payload.settings
  var shortSet = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('Info')) {
    shortSet = settings.shortcutsInfo
  }
  await getShortcutList()
  // 查找需要的字段
  const Key = ['selShortcut', 'selShortcutItem']
  // 字段是否存在,存在赋值,不存在为null
  Key.forEach(item => {
    if (shortSet.hasOwnProperty(item)) {
      shortcutsInfo[item] = shortSet[item]
    } else {
      shortcutsInfo[item] = null
    }
  })

  getShortcutFunctionDom()

}
function getShortcutFunctionDom () {
  // 初始值
  if (shortcutsInfo.selShortcut === null) {
    if(shortcutList.length!==0){
      shortcutsInfo.selShortcut = shortcutList[0].id 
      shortcutsInfo.selShortcutItem = shortcutList[0] 
    }
    shortcutsInfo.title = shortcutList.length > 0 ? shortcutList[0].name : shortcutsInfo.title
    setSettingShortcuts()
  }

  // 创建功能下拉菜单
  document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.shortcut.name} </div>
      <select class="sdpi-item-value select setvalueSelect" id="shortcutFunOptionSel"></select>
    </div>
  `;

  const FunOptionDom = document.getElementById('shortcutFunOptionSel');
  FunOptionDom.addEventListener('change', changeUseShortcutPlugin);

  mlwTools.dropDown(false, 'shortcutFunOptionSel', shortcutList, 'name', 'id', shortcutsInfo.selShortcut);
}

function changeUseShortcutPlugin (event) {
  const value = event.target.value
  shortcutsInfo.selShortcut = value

  const selectedIndex = event.target.options.selectedIndex
  shortcutsInfo.selShortcutItem = shortcutList[selectedIndex]
  shortcutsInfo.title = shortcutsInfo.selShortcutItem.name
  setSettingShortcuts()
}