var showInfo = {
  selFunction: null,
  selFuntionItem: {},
  title: 'specificShow',
  iconPath: 'specificShow',
  selShow: null,
  selItem: {},
} // 按键中需要存在的字段
var showList = []

var functionShowOption = [
  { name: 'switchSpecificShow', value: '/V1.0/show/switchById', paramsKey: { id: 'selShow' }, isNext: 'selItem',title: 'specific', path: 'switchSpecificShow' },
  { name: 'switchFirstShow', value: '/V1.0/show/first', title: 'first', path: 'switchFirstShow' },
  { name: 'switchLastShow', value: '/V1.0/show/last', title: 'last', path: 'switchLastShow' },
  { name: 'switchNextShow', value: '/V1.0/show/next', title: 'next', path: 'switchNextShow' },
  { name: 'switchPreviousShow', value: '/V1.0/show/previous', title: 'previous', path: 'switchPreviousShow' }
]

async function getStatemachineShowChange (val) {
  if (val.showListChanged) {
    await getShowList()

    const list = showList
    let selShow = showInfo.selShow
    if (list.length > 0) {
      const isHav = list.some(item => {
        return item.showId == showInfo.selShow
      })

      if (!isHav) {
        selShow = list[0].showId
        showInfo.selItem = list[0]
        showInfo.selShow = list[0].showId
        showInfo.title = list[0].name
        if (showInfo.selFuntionItem.name === 'switchSpecificShow') {
          setSettingShow()
        }
      }
    } else {
      selShow = ''
    }

    mlwTools.dropDown(false, 'showListOptionSel', showList, 'name', 'showId', selShow);
  }
}


// 获取show列表请求
async function getShowList() {
  try {
    const response = await request('/V1.0/show/getShowList');

    if (response.status === 0) {
      showList = response.showList
    }
  } catch (err) {
    console.error('Error fetching show list:', err);
    throw err;
  }
}

// 数据存储在按键
function setSettingShow () {
  const info = {
    showInfo: showInfo
  }
  setSettingInKey2(info)
}

async function getShowActionInfo (actionInfo) {
  await getShowList()

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('showInfo')) {
    settingInfo = settings.showInfo
  }

  // 查找需要的字段
  const findKey = ['selFunction','selFuntionItem', 'title', 'iconPath', 'selShow', 'selItem']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      showInfo[item] = settingInfo[item]
    } else {
      showInfo[item] = showInfo[item] || null
    }
  })

  if (controller === 'Keypad') {
    getShowFunctionDom()
  }
}
function getShowFunctionDom () {
  // 初始值
  if (showInfo.selFunction === null) {
    showInfo.selFunction = functionShowOption[0].value
    showInfo.selFuntionItem = functionShowOption[0]
    showInfo.title = functionShowOption[0].title
    showInfo.iconPath = functionShowOption[0].path
    setSettingShow()
  }


    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="showFunOptionSel"></select>
      </div>
      <div class="sdpi-item" id="switchSpecificShow" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.show.name} </div>
        <select class="sdpi-item-value select setvalueSelect" id="showListOptionSel"></select>
      </div>
    `;

    const FunOptionDom = document.getElementById('showFunOptionSel');
    FunOptionDom.addEventListener('change', sendShowFuncionPlugin);

    mlwTools.dropDown($PI.localization.show, 'showFunOptionSel', functionShowOption, 'name', 'value', showInfo.selFunction);

    mlwTools.dropDown(false, 'showListOptionSel', showList, 'name', 'showId', showInfo.selShow);

    mlwTools.controlFunctionDisplay(functionShowOption, showInfo.selFunction)

    document.getElementById('showListOptionSel').addEventListener('change', sendShowListPlugin);
    setShowListOptionDefaultItem(showList[0], 'selShow', 'selItem')
}

function setShowListOptionDefaultItem (item, key, itemKey) {
  if (showInfo[key] === null) {
    showInfo[key] = item.showId
    showInfo[itemKey] = item
    showInfo.title = mlwTools.findNextFunTitle(showInfo, showInfo.selFuntionItem, 'name')
    setSettingShow()
  }
}

function sendShowFuncionPlugin (event) {
  const value = event.target.value
  showInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  showInfo.selFuntionItem = functionShowOption[selectedIndex]

  showInfo.title =  showInfo.selFuntionItem.title
  showInfo.iconPath = showInfo.selFuntionItem.path

  showInfo.title = mlwTools.findNextFunTitle(showInfo, showInfo.selFuntionItem, 'name')

  mlwTools.controlFunctionDisplay(functionShowOption, showInfo.selFunction)

  setSettingShow()
}

function sendShowListPlugin (event) {
  const value = event.target.value
  showInfo.selShow = value
  const selectedIndex = event.target.options.selectedIndex
  showInfo.title = showList[selectedIndex].name
  showInfo.selItem = showList[selectedIndex]

  setSettingShow()
}
