var stopwatchInfo = {
    selFunction: null,
    selFunctionItem: {},
    title: "resetStopWatchTitle",
} // 按键中需要存在的字段

var stopwatchFunctionOption = [
    {name: 'resetStopWatch', title: "resetStopWatchTitle", value: '/V1.0/gfx/stopwatch/reset'},
    {name: 'startOrResumeStopWatch', title: "startOrResumeStopWatchTitle", value: '/V1.0/gfx/stopwatch/play'},
    {name: 'pauseStopWatch', title: "pauseStopWatchTitle", value: '/V1.0/gfx/stopwatch/pause'},
    {name: 'startOrPauseStopWatch', title: "startOrPauseStopWatchTitle", value: '/V1.0/gfx/stopwatch/playAction'}
]

function getStopwatchActionInfo(actionInfo) {
    // 存储在按键中的信息
    var settings = actionInfo.payload.settings
    if (settings.hasOwnProperty('baseURL')) {
        baseURL = settings.baseURL
    }

    var actCtxSetting = {}
    if (settings.hasOwnProperty('stopwatchInfo')) {
        actCtxSetting = settings.stopwatchInfo
    }

    // 查找需要的字段
    const actionKey = ['selFunction', 'selFunctionItem']
    // 字段是否存在,存在赋值,不存在为null
    actionKey.forEach(item => {
        if (actCtxSetting.hasOwnProperty(item)) {
            stopwatchInfo[item] = actCtxSetting[item]
        } else {
            stopwatchInfo[item] = stopwatchInfo[item] ? stopwatchInfo[item] : null;
        }
    })

    getStopwatchFunctionDom()
}

function setSettingStopwatch(value, key) {
    // 判断是否有默认值
    if (stopwatchInfo.selFunctionItem.hasOwnProperty('paramsKey')) {
        // 如果value有设置值
        value = value || stopwatchInfo.selFunctionItem.paramsKey[key]
        stopwatchInfo.selFunctionItem.paramsKey[key] = value
    }

    setSettingInKey2({
        stopwatchInfo: stopwatchInfo
    })
}

function getStopwatchFunctionDom() {
    // 初始值
    if (stopwatchInfo.selFunction === null) {
        stopwatchInfo.selFunction = stopwatchFunctionOption[0].value
        stopwatchInfo.selFunctionItem = stopwatchFunctionOption[0];
        setSettingStopwatch()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="stopwatchFunOptionSel"></select>
    </div>
  `;
    initToolTips();

    const FunOptionDom = document.getElementById('stopwatchFunOptionSel');
    FunOptionDom.addEventListener('change', stopwatchFunOptionSelChange);
    mlwTools.dropDown($PI.localization.stopwatch, 'stopwatchFunOptionSel', stopwatchFunctionOption, 'name', 'value', stopwatchInfo.selFunction);
}

function stopwatchFunOptionSelChange(event) {
    const value = event.target.value
    const selectedIndex = event.target.options.selectedIndex
    stopwatchInfo.selFunctionItem = stopwatchFunctionOption[selectedIndex]
    stopwatchInfo.selFunction = value;
    stopwatchInfo.title =  stopwatchInfo.selFunctionItem.title;

    setSettingStopwatch()
}

