var streamList = [] // 场景列表

var streamInfo = {
  selFunction: null,
  id: null,
  selName: null,
  selFuntionItem: {},
  title: 'startLiveStreaming',
  iconPath: 'startLiveStreaming',
  selStreamItem: {}
} // 按键中需要存在的字段


var functionStreamOption = [
  { name: 'startLiveStreaming', domId: 'serverStreamListDom', value: '/V1.0/stream/actionById', title: 'startLiveStreaming', paramsKey: { id: '', start: true }, path: 'startLiveStreaming' },
  { name: 'stopLiveStreaming', domId: 'serverStreamListDom', value: '/V1.0/stream/actionById', title: 'stopLiveStreaming', paramsKey: { id: '', start: false }, path: 'stopLiveStreaming' },
  { name: 'startStopLiveStreaming', domId: 'serverStreamListDom', value: '/V1.0/stream/actionById', title: 'startStopLiveStreaming', paramsKey: { id: '' }, path: 'startStopLiveStreaming' },
  { name: 'stopAllLiveStreaming', value: '/V1.0/stream/stopAll', title: 'stopAll', path: 'stopAllLiveStreaming' }
]

function choseOpStream() {
  let selStream = streamInfo.id
    if (streamList.length > 0) {
      const isHav = streamList.some(item => {
        return item.id == streamInfo.id
      })

      if (!isHav) {
        selStream = streamList[0].id
        streamInfo.selStreamItem = streamList[0]
        streamInfo.id = streamList[0].id
        streamInfo.title = streamList[0].name
        if (streamInfo.selStreamItem.name != 'stopAllLiveStreaming') {
          setSettingServer()
        }
      }
    } 
}
// 轮询通知中有场景列表变更的通知,每次变更要重新获取列表
async function getStatemachineStreamChange(data) {
  if (data.streamServersChanged || data.showListChanged) {

    await getStreamList()

    let selStream = streamInfo.id
    if (streamList.length > 0) {
      const isHav = streamList.some(item => {
        return item.id == streamInfo.id
      })

      if (!isHav) {
        selStream = streamList[0].id
        streamInfo.selStreamItem = streamList[0]
        streamInfo.id = streamList[0].id
        streamInfo.title = streamList[0].name
        if (streamInfo.selStreamItem.name != 'stopAllLiveStreaming') {
          setSettingServer()
        }
      }
    } else {
      selStream = ''
    }
    mlwTools.dropDown(false, 'serverListOptionSel', streamList, 'name', 'id', selStream)
  }
}

// 获取场景列表请求
async function getStreamList() {
  try {
    const response = await request('/V1.0/stream/getStreamServersList');

    if (response.status === 0) {
      streamList = response.serverList
    }
  } catch (err) {
    console.error('Error fetching stream list:', err);
    throw err;
  }
}

// 数据存储在按键
function setSettingServer () {
  const info = {
    streamInfo: streamInfo
  }
  setSettingInKey2(info)
}

async function getStreamActionInfo (actionInfo) {
  // await getStreamList()

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('streamInfo')) {
    settingInfo = settings.streamInfo
  }
  await getStreamList()

  // 查找需要的字段
  const findKey = ['selFunction', 'id', 'selFuntionItem', 'selName', 'title', 'iconPath', 'selStreamItem']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      streamInfo[item] = settingInfo[item]
    } else {
      streamInfo[item] = null
    }
  })

  getServerFunctionDom()
  choseOpStream()
}
function getServerFunctionDom () {
  // 初始值
  if (streamInfo.selFunction === null) {
    streamInfo.selFunction = functionStreamOption[0].name
    streamInfo.selFuntionItem = functionStreamOption[0]
    streamInfo.title = functionStreamOption[0].title
    streamInfo.selStreamItem = streamList[0]
    streamInfo.title = streamList[0].name
    streamInfo.iconPath = functionStreamOption[0].path
    setSettingServer()
  }


    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="serverFunOptionSel"></select>
      </div>
      <div class="sdpi-item" id="serverStreamListDom" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.stream.streamName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="serverListOptionSel"></select>
      </div>
    `;

    const FunOptionDom = document.getElementById('serverFunOptionSel');
    FunOptionDom.addEventListener('change', sendServerFuncionPlugin);

    mlwTools.dropDown($PI.localization.stream, 'serverFunOptionSel', functionStreamOption, 'name', 'name', streamInfo.selFunction);

    addSwitchServerOption()

    if (streamInfo.selFunction !== 'stopAllLiveStreaming') {
      document.getElementById('serverStreamListDom').style.display = 'inline-flex'
    } else {
      document.getElementById('serverStreamListDom').style.display = 'none'
    }
}

// 场景下拉列表,选择指定场景
function addSwitchServerOption () {
  const element = document.getElementById('serverListOptionSel');
  element.addEventListener('change', sendValueToServerPlugin);
  createdServerOption()
}
function createdServerOption() {
  if (streamList.length === 0) {
    setTimeout(() => {
      createdServerOption()
    }, 500)
    return
  }

  // 初始值
  if (streamInfo.id === null) {
    streamInfo.id = streamList[0].id
    streamInfo.selName = streamList[0].name
    streamInfo.selFuntionItem.paramsKey.id = streamList[0].id
    setSettingServer()
  }

  mlwTools.dropDown(false, 'serverListOptionSel', streamList, 'name', 'id', streamInfo.id)
}

function sendServerFuncionPlugin (event) {
  const value = event.target.value
  streamInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  streamInfo.selFuntionItem = functionStreamOption[selectedIndex]


  streamInfo.iconPath = streamInfo.selFuntionItem.path

  if (streamInfo.selFunction !== 'stopAllLiveStreaming') {
    document.getElementById('serverStreamListDom').style.display = 'inline-flex'
    streamInfo.id = mlwTools.isEmptyObject(streamInfo.selStreamItem) ? streamList[0].id : streamInfo.selStreamItem.id
    streamInfo.selFuntionItem.paramsKey.id = streamInfo.id

    streamInfo.title = mlwTools.isEmptyObject(streamInfo.selStreamItem) ? streamInfo.title : streamInfo.selStreamItem.name

  } else {
    document.getElementById('serverStreamListDom').style.display = 'none'
    streamInfo.title =  streamInfo.selFuntionItem.title
  }

  setSettingServer()

}

function sendValueToServerPlugin (event) {
  const value = event.target.value
  streamInfo.id = value
  const selectedIndex = event.target.options.selectedIndex
  streamInfo.selStreamItem = streamList[selectedIndex]
  streamInfo.title =  streamList[selectedIndex].name

  streamInfo.selName = streamList[selectedIndex].name
  streamInfo.selFuntionItem.paramsKey.id = value
  setSettingServer()
}
