var timerInfo = {
    selFunction: null,
    selFunctionItem: {},
    title: "resetTimeTitle",
} // 按键中需要存在的字段

var timerFunctionOption = [
    {name: 'resetTime', title: "resetTimeTitle", value: '/V1.0/gfx/countdown/reset'},
    {name: 'startOrResumeTimer', title: "startOrResumeTimerTitle", value: '/V1.0/gfx/countdown/play'},
    {name: 'pauseTimer', title: "pauseTimerTitle", value: '/V1.0/gfx/countdown/pause'},
    {name: 'startOrPauseTimer', title: "startOrPauseTimerTitle", value: '/V1.0/gfx/countdown/playAction'}
]

function getTimerActionInfo(actionInfo) {
    // 存储在按键中的信息
    var settings = actionInfo.payload.settings
    var actCtxSetting = {}
    if (settings.hasOwnProperty('baseURL')) {
        baseURL = settings.baseURL
    }

    if (settings.hasOwnProperty('timerInfo')) {
        actCtxSetting = settings.timerInfo
    }

    // 查找需要的字段
    const actionKey = ['selFunction', 'selFunctionItem', 'title'];
    // 字段是否存在,存在赋值,不存在为null
    actionKey.forEach(item => {
        if (actCtxSetting.hasOwnProperty(item)) {
            timerInfo[item] = actCtxSetting[item]
        } else {
            timerInfo[item] = timerInfo[item] ? timerInfo[item] : null;
        }
    })

    getTimerFunctionDom()
}

function setSettingTimer(value, key) {
    // 判断是否有默认值
    if (timerInfo.selFunctionItem.hasOwnProperty('paramsKey')) {
        // 如果value有设置值
        value = value || timerInfo.selFunctionItem.paramsKey[key]
        timerInfo.selFunctionItem.paramsKey[key] = value
    }

    setSettingInKey2({
        timerInfo: timerInfo
    })
}

function getTimerFunctionDom() {
    // 初始值
    if (timerInfo.selFunction === null) {
        timerInfo.selFunction = timerFunctionOption[0].value
        timerInfo.selFunctionItem = timerFunctionOption[0];
        setSettingTimer()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="timerFunOptionSel"></select>
    </div>
  `;
    initToolTips();

    const FunOptionDom = document.getElementById('timerFunOptionSel');
    FunOptionDom.addEventListener('change', timerFunOptionSelChange);
    mlwTools.dropDown($PI.localization.timer, 'timerFunOptionSel', timerFunctionOption, 'name', 'value', timerInfo.selFunction);
}

function timerFunOptionSelChange(event) {
    const value = event.target.value
    const selectedIndex = event.target.options.selectedIndex
    timerInfo.selFunctionItem = timerFunctionOption[selectedIndex]
    timerInfo.selFunction = value;
    timerInfo.title = timerInfo.selFunctionItem.title;

    setSettingTimer()
}

