var transitionInfo = {
  selFunction: null,
  transitionEffect: null,
  transitionDuration: 200,
  selDevSwitch: null,
  selStringer: null,
  selThreeD: null,
  ftbDuration: 1000,
  requestArr: ['selFuntionItem'],
  selFuntionItem: {},
  selDevItem: {},
  selStringerItem: {},
  selThreeDItem: {},
  setEffectItem: {},
  title: 'turnOnQuickSwitch',
  iconPath: 'turnOnQuickSwitch'
} // 按键中需要存在的字段

// 相关操作
// name: 相关 domId/中英文文案/软件硬件图标名称(没有path字段时)
// value: 请求接口  paramsKey: 请求所携带的参数  title: 软件硬件按键上的文字  path: 软件硬件图标名称
// isNext: 是否有下一级
// isRequest: 需要除了选择功能数组中的相关请求之外需要携带的多个请求，对应 transitionInfo 中相关请求内容的字段

var functionTransitionOption = [
  { name: 'turnOnQuickSwitch', value: '/V1.0/scene/setQuickSwitch?state=on', title: 'quick-switch', path: 'turnOnQuickSwitch' },
  { name: 'turnOffQuickSwitch', value: '/V1.0/scene/setQuickSwitch?state=off', title: 'quick-switch', path: 'turnOffQuickSwitch' },
  { name: 'turnOnOffQuickSwitch', value: '/V1.0/scene/setQuickSwitch', title: 'quick-switch', path: 'turnOnOffQuickSwitch' },
  { name: 'setTransitionEffect', value: '/V1.0/scene/setTransitionAnimation', isNext: 'setEffectItem', paramsKey: { name: 'cut' }, title: 'transitionDirectSwitch', path: 'setTransitionEffect' },
  { name: 'setTransitionDuration', value: '/V1.0/scene/setTransitionDuration', paramsKey: { duration: '200' }, title: '200ms', path: 'setTransitionDuration' },
  { name: 'setFtbTransitionEffect', value: '/V1.0/scene/setFTBDuration', paramsKey: { duration: '1000' }, title: '1000ms', path: 'setFtbTransitionEffect' }
]

// 设置场景特效
// 是否有二个请求
// isRequest: 需要除了选择功能数组中的相关请求之外需要携带的多个请求，对应 transitionInfo 中相关请求内容的字段
var transitionEffectList = [
  { name: 'transitionDirectSwitch', value: 'cut', type: 'direct', title: 'transitionDirectSwitch', path: 'transitionDirectSwitch' },
  { name: 'transitionGradienttSwitch', value: 'fade', type: 'gradient', title: 'transitionGradienttSwitch', path: 'transitionGradienttSwitch' },
  { name: 'transitionDipSwitch', value: 'dip', type: 'dip', title: 'transitionDipSwitch', path: 'transitionDipSwitch' },
  { name: 'transitionWipeSwitch', value: 'wipe', type: 'wipe', title: 'transitionWipeSwitch', path: 'transitionWipeSwitch' },
  { name: 'transitionDveSwitch', value: 'dve', type: 'dve', isRequest: 'selDevItem', isNext: 'selDevItem', title: 'dev-push-up', path: 'transitionDveSwitch' },
  { name: 'transitionStingerSwitch', value: 'stinger', type: 'stinger', isRequest: 'selStringerItem', isNext: 'selStringerItem', title: 'stinger_1', path: 'stinger_1' },
  { name: 'transitionThreeDSwitch', value: '3d', type: 'threeD', isRequest: 'selThreeDItem', isNext: 'selThreeDItem', title: 'threeD_flip', path: 'threeD_flip' }
]

var devOption = [
  { name: 'dev-push-up', value: '/V1.0/scene/selectDvePattern?pattern=0', title: 'dev-push-up', path: 'dev-push-up' },
  { name: 'dev-push-down', value: '/V1.0/scene/selectDvePattern?pattern=1', title: 'dev-push-down', path: 'dev-push-down' },
  { name: 'dev-push-left', value: '/V1.0/scene/selectDvePattern?pattern=2', title: 'dev-push-left', path: 'dev-push-left' },
  { name: 'dev-push-right', value: '/V1.0/scene/selectDvePattern?pattern=3', title: 'dev-push-right', path: 'dev-push-right' },
  { name: 'dev-push-upper-left', value: '/V1.0/scene/selectDvePattern?pattern=4', title: 'dev-push-upper-left', path: 'dev-push-upper-left' },
  { name: 'dev-push-upper-right', value: '/V1.0/scene/selectDvePattern?pattern=5', title: 'dev-push-upper-right', path: 'dev-push-upper-right' },
  { name: 'dev-push-down-left', value: '/V1.0/scene/selectDvePattern?pattern=6', title: 'dev-push-down-left', path: 'dev-push-down-left' },
  { name: 'dev-push-down-right', value: '/V1.0/scene/selectDvePattern?pattern=7', title: 'dev-push-down-right', path: 'dev-push-down-right' },
  { name: 'dev-squeeze-up', value: '/V1.0/scene/selectDvePattern?pattern=8', title: 'dev-squeeze-up', path: 'dev-squeeze-up' },
  { name: 'dev-squeeze-down', value: '/V1.0/scene/selectDvePattern?pattern=9', title: 'dev-squeeze-down', path: 'dev-squeeze-down' },
  { name: 'dev-squeeze-left', value: '/V1.0/scene/selectDvePattern?pattern=10', title: 'dev-squeeze-left', path: 'dev-squeeze-left' },
  { name: 'dev-squeeze-right', value: '/V1.0/scene/selectDvePattern?pattern=11', title: 'dev-squeeze-right', path: 'dev-squeeze-right' },
  { name: 'dev-squeeze-upper-left', value: '/V1.0/scene/selectDvePattern?pattern=12', title: 'dev-squeeze-upper-left', path: 'dev-squeeze-upper-left' },
  { name: 'dev-squeeze-upper-right', value: '/V1.0/scene/selectDvePattern?pattern=13', title: 'dev-squeeze-upper-right', path: 'dev-squeeze-upper-right' },
  { name: 'dev-squeeze-down-left', value: '/V1.0/scene/selectDvePattern?pattern=14', title: 'dev-squeeze-down-left', path: 'dev-squeeze-down-left' },
  { name: 'dev-squeeze-down-right', value: '/V1.0/scene/selectDvePattern?pattern=15', title: 'dev-squeeze-down-right', path: 'dev-squeeze-down-right' },
  { name: 'dev-squeeze-horizontal', value: '/V1.0/scene/selectDvePattern?pattern=16', title: 'dev-squeeze-horizontal', path: 'dev-squeeze-horizontal' },
  { name: 'dev-squeeze-vertical', value: '/V1.0/scene/selectDvePattern?pattern=17', title: 'dev-squeeze-vertical', path: 'dev-squeeze-vertical' },
  { name: 'dev-squeeze-center', value: '/V1.0/scene/selectDvePattern?pattern=18', title: 'dev-squeeze-center', path: 'dev-squeeze-center' }
]
var stringerOption = [
  { name: 'stinger_1', value: '/V1.0/scene/selectStingerFile?index=1', title: 'stinger_1', path: 'stinger_1' },
  { name: 'stinger_2', value: '/V1.0/scene/selectStingerFile?index=2', title: 'stinger_2', path: 'stinger_2' },
  { name: 'stinger_3', value: '/V1.0/scene/selectStingerFile?index=3', title: 'stinger_3', path: 'stinger_3' },
  { name: 'stinger_4', value: '/V1.0/scene/selectStingerFile?index=4', title: 'stinger_4', path: 'stinger_4' }
]
var threeDOption = [
  { name: 'threeD_flip', value: '/V1.0/scene/select3DPattern?pattern=0', title: 'threeD_flip', path: 'threeD_flip'  },
  { name: 'threeD_cube', value: '/V1.0/scene/select3DPattern?pattern=1', title: 'threeD_cube', path: 'threeD_cube'  },
  { name: 'threeD_frame', value: '/V1.0/scene/select3DPattern?pattern=2', title: 'threeD_frame', path: 'threeD_frame'  },
  { name: 'threeD_louver', value: '/V1.0/scene/select3DPattern?pattern=3', title: 'threeD_louver', path: 'threeD_louver'  },
  { name: 'threeD_open_door', value: '/V1.0/scene/select3DPattern?pattern=4', title: 'threeD_open_door', path: 'threeD_open_door'  },
  { name: 'threeD_strip', value: '/V1.0/scene/select3DPattern?pattern=5', title: 'threeD_strip', path: 'threeD_strip'  },
  { name: 'threeD_swap', value: '/V1.0/scene/select3DPattern?pattern=6', title: 'threeD_swap', path: 'threeD_swap'  },
  { name: 'threeD_mosaic', value: '/V1.0/scene/select3DPattern?pattern=7', title: 'threeD_mosaic', path: 'threeD_mosaic'  }
]


// 数据存储在按键
function setSettingTransition (value, key) {
  // 携带多个参数对应参数赋值
  if (transitionInfo.selFuntionItem.hasOwnProperty('paramsKey')) {
    value = value || transitionInfo.selFuntionItem.paramsKey[key]
    transitionInfo.selFuntionItem.paramsKey[key] = value
  }

  if (transitionInfo.selFunction !== '/V1.0/scene/setTransitionAnimation') {

    if (document.getElementById('transitionDveSwitch')) {
      document.getElementById('transitionDveSwitch').style.display = 'none'
    }
    if (document.getElementById('transitionStingerSwitch')) {
      document.getElementById('transitionStingerSwitch').style.display = 'none'
    }
    if (document.getElementById('transitionThreeDSwitch')) {
      document.getElementById('transitionThreeDSwitch').style.display = 'none'
    }
  }
  const info = {
    transitionInfo: transitionInfo
  }
  setSettingInKey2(info)
}

function getTransitionActionInfo (actionInfo) {
  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var transitionSetting = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('transitionInfo')) {
    transitionSetting = settings.transitionInfo
  }

  // 查找需要的字段
  const findKey = ['selFunction', 'transitionEffect', 'transitionDuration', 'ftbDuration', 'selFuntionItem', 'selDevSwitch',
  'selStringer', 'selThreeD', 'requestArr', 'selDevItem', 'selStringerItem', 'selThreeDItem', 'title', 'iconPath', 'setEffectItem']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (transitionSetting.hasOwnProperty(item)) {
      transitionInfo[item] = transitionSetting[item]
    } else {
      transitionInfo[item] = transitionInfo[item] ? transitionInfo[item] : null
    }
  })

  console.log('transitionInfo.selFunction', transitionInfo)
  if (transitionInfo.selFunction !== '/V1.0/scene/setTransitionAnimation') {

    if (document.getElementById('transitionDveSwitch')) {
      document.getElementById('transitionDveSwitch').style.display = 'none'
    }
    if (document.getElementById('transitionStingerSwitch')) {
      document.getElementById('transitionStingerSwitch').style.display = 'none'
    }
    if (document.getElementById('transitionThreeDSwitch')) {
      document.getElementById('transitionStingerSwitch').style.display = 'none'
    }
  }
  getTransitionFunctionDom()
}


function getTransitionFunctionDom () {

  // 初始值
  if (transitionInfo.selFunction === null) {
    transitionInfo.selFunction = functionTransitionOption[0].value
    transitionInfo.selFuntionItem = functionTransitionOption[0]
    transitionInfo.title = functionTransitionOption[0].title
    transitionInfo.iconPath = functionTransitionOption[0].path
    setSettingTransition()
  } else {
    // if (!mlwTools.isEmptyObject(transitionInfo.selFuntionItem)) {
    //   if (transitionInfo.selFuntionItem.hasOwnProperty('isRequest')) {
    //     const applyNextOptionItem = transitionInfo[transitionInfo.selFuntionItem.isRequest]
    //     console.log('555555', applyNextOptionItem)
    //     if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
    //       transitionInfo.title = applyNextOptionItem.title
    //     }
    //   }
    // }
  }

  // 创建功能下拉菜单
  document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="transitionFunOptionSel"></select>
    </div>
    <div class="sdpi-item" id="setTransitionEffect" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.transition.transitionEffect} </div>
      <select class="sdpi-item-value select setvalueSelect" id="set-Transition-Effect-item">
      </select>
    </div>
    <div type="range" class="sdpi-item" id="setTransitionDuration" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.transition.switchTransitionSpeed}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=200>200</span>
          <input class="floating-tooltip" data-suffix="ms" type="range" id="transition-duration-input" min="200" max="1000" step="50" value="${transitionInfo.transitionDuration}">
          <span class="clickable" value="1000">1000</span>
      </div>
    </div>
    <div type="range" class="sdpi-item" id="setFtbTransitionEffect" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.transition.SetFtbTransitionEffect}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=200>200</span>
          <input class="floating-tooltip" data-suffix="ms" type="range" id="transition-duration-ftb-input" min="200" max="2000" step="50" value="${transitionInfo.ftbDuration}">
          <span class="clickable" value="2000">2000</span>
      </div>
    </div>
    <div class="sdpi-item" id="transitionDveSwitch" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.transition.transitionDveSwitch} </div>
      <select class="sdpi-item-value select setvalueSelect" id="transitionDveSwitchSelect">
      </select>
    </div>
    <div class="sdpi-item" id="transitionStingerSwitch" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.transition.transitionStingerSwitch} </div>
      <select class="sdpi-item-value select setvalueSelect" id="transitionStingerSwitchSelect">
      </select>
    </div>
    <div class="sdpi-item" id="transitionThreeDSwitch" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.transition.transitionThreeDSwitch} </div>
      <select class="sdpi-item-value select setvalueSelect" id="transitionThreeDSwitchSelect">
      </select>
    </div>
  `;
  initToolTips();


  const FunOptionDom = document.getElementById('transitionFunOptionSel');
  FunOptionDom.addEventListener('change', sendFuncionTransitionPlugin);

  mlwTools.dropDown($PI.localization.transition, 'transitionFunOptionSel', functionTransitionOption, 'name', 'value', transitionInfo.selFunction);
  mlwTools.dropDown($PI.localization.transition, 'transitionDveSwitchSelect', devOption, 'name', 'value', transitionInfo.selDevSwitch);
  mlwTools.dropDown($PI.localization.transition, 'transitionStingerSwitchSelect', stringerOption, 'name', 'value', transitionInfo.selStringer);
  mlwTools.dropDown($PI.localization.transition, 'transitionThreeDSwitchSelect', threeDOption, 'name', 'value', transitionInfo.selThreeD);


  document.getElementById('transition-duration-ftb-input').addEventListener('input', transitionDurationFtbChanged);
  document.getElementById('transition-duration-input').addEventListener('input', transitionDurationChanged);


  // 判断选择的功能展示对应dom
  console.log('mlwTools', functionTransitionOption, transitionInfo.selFunction)
  mlwTools.controlFunctionDisplay(functionTransitionOption, transitionInfo.selFunction)

  const element = document.getElementById('setTransitionEffect');
  element.addEventListener('change', setTransitionEffectOption);

  document.getElementById('transitionDveSwitch').addEventListener('change', transitionDveSwitchChange);
  setOptionDefaultItem(devOption[0], 'selDevSwitch', 'selDevItem')

  document.getElementById('transitionStingerSwitch').addEventListener('change', transitionStingerSwitchChange);
  setOptionDefaultItem(stringerOption[0], 'selStringerItem',  'selStringerItem')

  document.getElementById('transitionThreeDSwitch').addEventListener('change', transitionThreeDSwitchChange);
  setOptionDefaultItem(threeDOption[0], 'selThreeD', 'selThreeDItem')


  addSwitchTeansitionEffectOption()
}

function setOptionDefaultItem (item, key, itemKey) {
  console.log('setOptionDefaultItem', item, key)
  if (transitionInfo[key] === null) {
    transitionInfo[key] = item.value
    if (item.hasOwnProperty('isRequest')) {
      transitionInfo.requestArr = ['selFuntionItem', item.isRequest]
    } else {
      transitionInfo.requestArr = ['selFuntionItem']
    }
    transitionInfo[itemKey] = item
    // transitionInfo.title = item.title
  }
}
function addSwitchTeansitionEffectOption () {
  // 初始值
  if (transitionInfo.transitionEffect === null) {
    transitionInfo.transitionEffect = transitionEffectList[0].value
    setSettingTransition(transitionEffectList[0].value)

    if (transitionEffectList[0].hasOwnProperty('isRequest')) {
      transitionInfo.requestArr = ['selFuntionItem', transitionInfo.transitionEffect]
    } else {
      transitionInfo.requestArr = ['selFuntionItem']
    }
    transitionInfo.title = transitionEffectList[0].title
    transitionInfo.iconPath = transitionEffectList[0].path
    transitionInfo.setEffectItem = transitionEffectList[0]
  }
  console.log('88888888', transitionEffectList, transitionInfo.transitionEffect, transitionInfo.selFunction)
  if (transitionInfo.selFunction === '/V1.0/scene/setTransitionAnimation') {
    mlwTools.controlFunctionDisplay(transitionEffectList, transitionInfo.transitionEffect)
  }

  mlwTools.dropDown($PI.localization.transition, 'set-Transition-Effect-item', transitionEffectList, 'name', 'value', transitionInfo.transitionEffect)
}

function sendFuncionTransitionPlugin (event) {
  const value = event.target.value
  const selectedIndex = event.target.options.selectedIndex
  transitionInfo.selFuntionItem = functionTransitionOption[selectedIndex]
  transitionInfo.selFunction = value
  transitionInfo.title =  transitionInfo.selFuntionItem.title
  transitionInfo.iconPath = transitionInfo.selFuntionItem.path

  if (transitionInfo.selFuntionItem.hasOwnProperty('isNext')) {
    let applyNextOptionItem = transitionInfo[transitionInfo.selFuntionItem.isNext]
    console.log('555555', applyNextOptionItem, transitionInfo[applyNextOptionItem.isNext])
    if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
      if (applyNextOptionItem.hasOwnProperty('isNext')) {
        applyNextOptionItem = transitionInfo[applyNextOptionItem.isNext]
        if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
          transitionInfo.title = applyNextOptionItem.title
          transitionInfo.iconPath = applyNextOptionItem.path

          console.log('666666', applyNextOptionItem.title)
        }
      } else {
        transitionInfo.title = applyNextOptionItem.title
        transitionInfo.iconPath = applyNextOptionItem.path
      }
    }
  }
  // 判断选择的功能展示对应dom
  mlwTools.controlFunctionDisplay(functionTransitionOption, transitionInfo.selFunction)

  transitionInfo.transitionEffect === null


  addSwitchTeansitionEffectOption()
  setSettingTransition()
}

function transitionDurationFtbChanged (event) {
  const value = event.target.value
  transitionInfo.ftbDuration = value
  transitionInfo.title = value + 'ms'

  setSettingTransition(value, 'duration')
}

function transitionDurationChanged (event) {
  const value = event.target.value
  transitionInfo.transitionDuration = value
  transitionInfo.title = value + 'ms'

  setSettingTransition(value, 'duration')
}

function setTransitionEffectOption (event) {
  const value = event.target.value
  transitionInfo.transitionEffect = value
  const selectedIndex = event.target.options.selectedIndex
  transitionInfo.title = transitionEffectList[selectedIndex].title
  transitionInfo.iconPath = transitionEffectList[selectedIndex].path

  if (transitionEffectList[selectedIndex].hasOwnProperty('isRequest')) {
    transitionInfo.requestArr = ['selFuntionItem', transitionEffectList[selectedIndex].isRequest]
    const applyNextOptionItem = transitionInfo[transitionEffectList[selectedIndex].isRequest]
    if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
      transitionInfo.title = applyNextOptionItem.title
      transitionInfo.iconPath = applyNextOptionItem.path
    }
  } else {
    transitionInfo.requestArr = ['selFuntionItem']
  }
  transitionInfo.setEffectItem = transitionEffectList[selectedIndex]

  mlwTools.controlFunctionDisplay(transitionEffectList, value)

  setSettingTransition(value, 'name')
}

function transitionDveSwitchChange (event) {
  const value = event.target.value
  transitionInfo.selDevSwitch = value
  const selectedIndex = event.target.options.selectedIndex
  transitionInfo.selDevItem = devOption[selectedIndex]
  transitionInfo.title = devOption[selectedIndex].title
  transitionInfo.iconPath = devOption[selectedIndex].path


  setSettingTransition()
}

function transitionStingerSwitchChange (event) {
  const value = event.target.value
  transitionInfo.selStringer = value
  const selectedIndex = event.target.options.selectedIndex
  transitionInfo.selStringerItem = stringerOption[selectedIndex]
  transitionInfo.title = stringerOption[selectedIndex].title
  transitionInfo.iconPath = stringerOption[selectedIndex].path

  setSettingTransition()
}

function transitionThreeDSwitchChange (event) {
  const value = event.target.value
  transitionInfo.selThreeD = value
  const selectedIndex = event.target.options.selectedIndex
  transitionInfo.selThreeDItem = threeDOption[selectedIndex]
  transitionInfo.title = threeDOption[selectedIndex].title
  transitionInfo.iconPath = threeDOption[selectedIndex].path

  setSettingTransition()
}
