var videoInfo = {
  selFunction: null,
  selFuntionItem: {},
  title: 'startVideo',
  iconPath: 'startVideo',
  selSeconds: "1",
  selSecondsName: "1s",
  selProgress: "0",
  selProgressName: "00:00:00",
  progressValue: '0%',
  progress: 0
} // 按键中需要存在的字段


var functionVideoOption = [
  { name: 'playVideo', value: '/V1.0/scene/playVideo', title: 'playVideoTitle', path: 'playVideo' },
  { name: 'pauseVideo', value: '/V1.0/scene/pauseVideo', title: 'pauseVideoTitle', path: 'pauseVideo' },
  { name: 'playPauseVideo', value: '/V1.0/scene/videoPlayAction', title: 'playPauseVideoTitle', path: 'playPauseVideo' },
  { name: 'rewindToStart', value: '/V1.0/scene/seekVideoToStart', title: 'rewindToStartTitle', path: 'rewindToStart' },
  { name: 'fastForwardToEnd', value: '/V1.0/scene/seekVideoToEnd', title: 'fastForwardToEndTitle', path: 'fastForwardToEnd' },
  { name: 'rewindBySeconds', value: '/V1.0/scene/seekVideoBackward', title: '', isNext: 'selSecondsName', path: 'rewindBySeconds' , paramsKey: { offset: "selSeconds"} },
  { name: 'fastForwardSeconds', value: '/V1.0/scene/seekVideoForward', title: '', isNext: 'selSecondsName', path: 'fastForwardSeconds' , paramsKey: { offset: "selSeconds"} },
  { name: 'jumpToSpecificTime', value: '/V1.0/scene/seekVideo', title: '', isNext: 'selProgressName', path: 'jumpToSpecificTime', paramsKey: { progress: "selProgress"} }
]

var videoDivIdArr = ["videoSecondsItem", "videoProgressItem"];
var videoDivRuleArr = {
  "rewindBySeconds": ['videoSecondsItem'],
  "fastForwardSeconds": ['videoSecondsItem'],
  "jumpToSpecificTime": ['videoProgressItem']
}


// 数据存储在按键
function setSettingVideo () {
  const info = {
    videoInfo: videoInfo
  }
  setSettingInKey2(info)
}

async function getVideoActionInfo (actionInfo) {

  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('videoInfo')) {
    settingInfo = settings.videoInfo
  }

  // 查找需要的字段
  const findKey = ['selFunction','selFuntionItem', 'title', 'iconPath', 'selSeconds', 'selSecondsName',  'selProgress', 'selProgressName', 'progressValue', 'progress']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      videoInfo[item] = settingInfo[item]
    } else {
      videoInfo[item] = String(videoInfo[item]) ? videoInfo[item] : null
    }
  })
  console.log('videoInfo', videoInfo);

  if (controller === 'Keypad') {
    getVideoFunctionDom()
  }
}


function getVideoFunctionDom () {
  // 初始值
  if (videoInfo.selFunction === null) {
    videoInfo.selFunction = functionVideoOption[0].name
    videoInfo.selFuntionItem = functionVideoOption[0]
    videoInfo.title = functionVideoOption[0].title
    videoInfo.iconPath = functionVideoOption[0].path
    setSettingVideo()
  }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
        <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
        <select class="sdpi-item-value select setvalueSelect" id="videoFunOptionSel"></select>
      </div>
      
      <div type="range"  class="sdpi-item" id="videoSecondsItem" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.video.labelSeconds} </div>
        <div class="sdpi-item-value">
          <span class="clickable" value=1>1</span>
          <input class="floating-tooltip" data-suffix="s" type="range" id="videoSecondsEle" min="1" max="10" step="1" value="${videoInfo.selSeconds}" >
          <span class="clickable" value="10">10</span>
        </div>
      </div>
      
      <div class="sdpi-item" id="videoProgressItem" style="display: none">
        <div class="sdpi-item-label"> ${$PI.localization.video.labelSeconds} </div>
        <div class="sdpi-item-value">
          <input type="text" class="jeinput" id="test05" placeholder="hh:mm:ss">
        </div>
      </div>
    `;
  initToolTips();
  // <span class="clickable" value=0>0</span>
  // <input class="floating-tooltip" data-suffix="s"  type="range" id="videoProgressEle" min="0" max="60" step="1" value="${videoInfo.selProgress}" />
  // <span class="clickable" value="60">60</span>
    const FunOptionDom = document.getElementById('videoFunOptionSel');
    FunOptionDom.addEventListener('change', sendVideoFuncionPlugin);
    const timeArr = videoInfo.selProgressName.split(':')
    var jds = jeDate("#test05",{
      isinitVal:true,
      initDate:[{hh:timeArr[0],mm:timeArr[1],ss:timeArr[2]},false],
      format: "hh:mm:ss",
      isToday: false,
      isClear: true, 
      language: {
        name  : "en",
        month : ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"],
        weeks : [ "SUN","MON","TUR","WED","THU","FRI","SAT" ],
        times : ["Hour","Minute","Second"],
        timetxt: ["Time","Start Time","End Time"],
        backtxt:"Back",
        clear : $PI.localization.video.cancel,
        today : "Now",
        yes   : $PI.localization.video.sure,
        close : "Close"
      },
      donefun:function(obj) {
        videoInfo.selProgress = mlwTools.formatTimeToSec(obj.val)
        videoInfo.selProgressName = obj.val
        videoInfo.title = obj.val
        setSettingVideo()
      }
    });


  document.getElementById('videoSecondsEle').addEventListener('input', videoSecondsEleChange);
  // document.getElementById('videoProgressEle').addEventListener('input', videoProgressEleChange);


  mlwTools.dropDown($PI.localization.video, 'videoFunOptionSel', functionVideoOption, 'name', 'value', videoInfo.selFunction);

  // 判断选择的功能展示对应dom
  mlwTools.divSwitchShowOrHideRule(videoDivIdArr, videoDivRuleArr, videoInfo.selFuntionItem.name)

}

function videoSecondsEleChange(event) {
  videoInfo.selSeconds = event.target.value;
  videoInfo.selSecondsName = videoInfo.selSeconds + 's';
  videoInfo.title = videoInfo.selSecondsName;
  setSettingVideo()
}

function videoProgressEleChange(event) {
  videoInfo.selProgress = event.target.value;
  videoInfo.selProgressName = videoInfo.selProgress + 's';
  videoInfo.title = videoInfo.selProgressName;
  setSettingVideo()
}

function sendVideoFuncionPlugin (event) {
  const value = event.target.value
  videoInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  videoInfo.selFuntionItem = functionVideoOption[selectedIndex];

  videoInfo.title =  videoInfo.selFuntionItem.title
  videoInfo.iconPath = videoInfo.selFuntionItem.path

  videoInfo.iconPath = mlwTools.findNextFunIconPath(videoInfo, videoInfo.selFuntionItem)

  videoInfo.title = mlwTools.findNextFunTitle(videoInfo, videoInfo.selFuntionItem)

  // 判断选择的功能展示对应dom
  mlwTools.divSwitchShowOrHideRule(videoDivIdArr, videoDivRuleArr, videoInfo.selFuntionItem.name)

  setSettingVideo()
}
