var volumeEncodeInfo = {
  selFunction: null,
  selFuntionItem: null,
  title: '',
  iconPath: 'volumeProgramOption-0',
  ProgramType: 3,
  PreviewType: 4,
  MonitorType: 1,
  MicType: 512,
  HDMI1Type: 1792,
  HDMI2Type: 2048,
  BluetoothType: 768,
  selStateVolumeDb: 0,
  selStateVolumeTitle: '0dB',
  selMonitorDevice: null,
  monitorDeviceItem: null,
  selUsbAudioType: null,
  selUsbAudioItem: null,
  selScope: null,
  selScopeItem: null,
  selStateAlways: null,
  selStateAlwaysItem: null,
  selStream: null,
  selStreamItem: null,
  selVideo: null,
  selVideoItem: null,
  selWebpage: null,
  selWebpageItem: null,
  selGfx: null,
  selGfxItem: null,
  mixState: null,
  mixStateItem: null,
  selSolo: null,
  selSoloItem: null,
  delayVolumeTime: 0,
  delayVolumeTimeTitle: '0ms',
  selInput: null,
  selInputItem: null,
  volumeDB: '0dB',
  volumeValue: 0
} // 按键中需要存在的字段


var functionVolumeEncodeOption = [
  { name: 'volumeProgramVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol', paramsKey: { type: 'ProgramType' }, title: 'PROGRAM', path: 'PROGRAMVolume' },
  { name: 'volumePreviewVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'PreviewType' }, title: 'PREVIEW', path: 'PREVIEWVolume' },
  { name: 'volumeMonitorVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'MonitorType' }, title: 'MONITOR', path: 'MONITORVolume' },
  { name: 'volumeMicVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'MicType' }, title: 'MIC', path: 'MICVolume' },
  { name: 'volumeBluetoothVolume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'BluetoothType' }, title: 'Bluetooth', path: 'BluetoothVolume' },
  { name: 'volumeUsbAudioVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selUsbAudioItem', pathParams: 'selAdjustVol',paramsKey: { type: 'selUsbAudioType' }, title: 'UsbAudio', path: 'USBVolume' },
  { name: 'volumeHDMI1Volume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'HDMI1Type' }, title: 'hdmi1', path: 'HDMIVolume' },
  { name: 'volumeHDMI2Volume', value: '/V1.0/volume/adjustVolume', pathParams: 'selAdjustVol',paramsKey: { type: 'HDMI2Type' }, title: 'hdmi2', path: 'HDMIVolume' },
  { name: 'volumeStreamVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selStreamItem',pathParams: 'selAdjustVol',paramsKey: { type: 'selStream' }, title: 'stream', path: 'StreamVolume' },
  { name: 'volumeVideoVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selVideoItem',pathParams: 'selAdjustVol',paramsKey: { type: 'selVideo' }, title: 'video', path: 'VideoVolume' },
  { name: 'volumeWebpageVolume', value: '/V1.0/volume/adjustVolume',isNext: 'selWebpageItem', pathParams: 'selAdjustVol', paramsKey: { type: 'selWebpage' }, title: 'webpage', path: 'WEBPAGEVolume' },
  { name: 'volumeGfxVolume', value: '/V1.0/volume/adjustVolume', isNext: 'selGfxItem',pathParams: 'selAdjustVol', paramsKey: { type: 'selGfx' }, title: 'GFX', path: 'GFXVolume' }
]

async function getStatemachineVolumeChange (val) {
  if (val.monitorAudioDeviceListChanged) {
    await getMonitorDeviceList()
    isAddMonitorDeviceEncodeOption()
  }

  
  if (val.shortcutFunctionParamsChanged) {
    await getUsbAudioDeviceList()
    // 设置usb audio list
    const usbAudioList = usbAudioVolumeList
    let selUsbAudio = volumeEncodeInfo.selUsbAudioType
    if (usbAudioList.length > 0) {
      const isHav = usbAudioList.some(item => {
        return item.type == volumeEncodeInfo.selUsbAudioType
      })

      if (!isHav) {
        selUsbAudio = usbAudioList[0].type
        volumeEncodeInfo.selUsbAudioItem = usbAudioList[0]
        volumeEncodeInfo.selUsbAudioType = usbAudioList[0].type
        volumeEncodeInfo.title = usbAudioList[0].name
        setSettingVolumeEncode()
      }
    } else {
      selUsbAudio = ''
    }
    mlwTools.dropDown(false, 'usbAudioVolumeEncodeSel', usbAudioVolumeList, 'name', 'type', selUsbAudio);

    await getStreamDeviceList()
    const streamList = streamVolumeList
    let selStream = volumeEncodeInfo.selStream
    if (streamList.length > 0) {
      const isHav = streamList.some(item => {
        return item.type == volumeEncodeInfo.selStream
      })

      if (!isHav) {
        selStream = streamList[0].type
        volumeEncodeInfo.selStreamItem = streamList[0]
        volumeEncodeInfo.selStream = streamList[0].type
        volumeEncodeInfo.title = streamList[0].name
        setSettingVolumeEncode()
      }
    } else {
      selStream = ''
    }
    mlwTools.dropDown(false, 'streamVolumeEncodeSel', streamVolumeList, 'name', 'type', selStream);


    await getVideoDeviceList()
    const VideoList = videoDeviceList
    let selVideo = volumeEncodeInfo.selVideo
    if (VideoList.length > 0) {
      const isHav = VideoList.some(item => {
        return item.type == volumeEncodeInfo.selVideo
      })

      if (!isHav) {
        selVideo = VideoList[0].type
        volumeEncodeInfo.selVideoItem = VideoList[0]
        volumeEncodeInfo.selVideo = VideoList[0].type
        volumeEncodeInfo.title = VideoList[0].name
        setSettingVolumeEncode()
      }
    } else {
      selVideo = ''
    }
    mlwTools.dropDown(false, 'videoVolumeEncodeSel', videoDeviceList, 'name', 'type', selVideo);


    await getWebpageDeviceList()
    const WebpageList = webpageDeviceList
    let selWebpage = volumeEncodeInfo.selWebpage
    if (WebpageList.length > 0) {
      const isHav = WebpageList.some(item => {
        return item.type == volumeEncodeInfo.selWebpage
      })

      if (!isHav) {
        selWebpage = WebpageList[0].type
        volumeEncodeInfo.selWebpageItem = WebpageList[0]
        volumeEncodeInfo.selWebpage = WebpageList[0].type
        volumeEncodeInfo.title = WebpageList[0].name
        setSettingVolumeEncode()
      }
    } else {
      selWebpage = ''
    }
    mlwTools.dropDown(false, 'webpageVolumeEncodeSel', webpageDeviceList, 'name', 'type', selWebpage);


    await getGfxDeviceList()
    const gfxList = gfxDeviceList
    let selGfx = volumeEncodeInfo.selGfx
    if (gfxList.length > 0) {
      const isHav = gfxList.some(item => {
        return item.type == volumeEncodeInfo.selGfx
      })

      if (!isHav) {
        selGfx = gfxList[0].type
        volumeEncodeInfo.selGfxItem = gfxList[0]
        volumeEncodeInfo.selGfx = gfxList[0].type
        volumeEncodeInfo.title = gfxList[0].name
        setSettingVolumeEncode()
      }
    } else {
      selGfx = ''
    }
    mlwTools.dropDown(false, 'gfxVolumeEncodeSel', gfxDeviceList, 'name', 'type', selGfx);

  }
}

// 数据存储在按键
function setSettingVolumeEncode () {
  const info = {
    volumeEncodeInfo: volumeEncodeInfo
  }

  console.log("setSettingVolumeEncode", setSettingVolumeEncode);

  setSettingInKey2(info)
}

async function getVolumeEncodeActionInfo (actionInfo) {
  await getMonitorDeviceList()
  await getUsbAudioDeviceList()
  await getVideoDeviceList()
  await getStreamDeviceList()
  await getWebpageDeviceList()
  await getGfxDeviceList()

  console.log('actionInfo', actionInfo)
  // 存储在按键中的信息
  var settings = actionInfo.payload.settings

  var settingInfo = {}
  if (settings.hasOwnProperty('baseURL')) {
    baseURL = settings.baseURL
  }

  if (settings.hasOwnProperty('volumeEncodeInfo')) {
    settingInfo = settings.volumeEncodeInfo
  }
  // 查找需要的字段
  const findKey = ['selFunction', 'selFuntionItem', 'title', 'iconPath', 'ProgramType', 'PreviewType', 'MonitorType', 'MicType',
  'HDMI1Type', 'HDMI2Type','BluetoothType', 'selStateVolumeDb', 'selMonitorDevice', 'monitorDeviceItem',
  'selUsbAudioType', 'selUsbAudioItem', 'selStream', 'selStreamItem',
  'selVideo', 'selVideoItem', 'selWebpage', 'selWebpageItem', 'selGfx', 'selGfxItem', 'selAdjustVol', 'selAdjustItem', 'volumeDB', 'volumeValue']
  // 字段是否存在,存在赋值,不存在为null
  findKey.forEach(item => {
    if (settingInfo.hasOwnProperty(item)) {
      volumeEncodeInfo[item] = settingInfo[item]
    } else {
      volumeEncodeInfo[item] = volumeEncodeInfo[item] === null ? null : volumeEncodeInfo[item]
    }
  })

  getVolumeEncodeInfoFunctionDom()
}

/* <div type="range" class="sdpi-item" id="setVolumeDBOptionID">
<div class="sdpi-item-label"> ${$PI.localization.volume.volumedB}</div>
<div class="sdpi-item-value">
<span class="clickable" value=-40>-40</span>
<input class="floating-tooltip" data-suffix="" type="range" id="adjustVolumeDbSlider" min="-40" max="10" step="1" value="${volumeEncodeInfo.selStateVolumeDb}">
<span class="clickable" value="10">10</span>
</div>
</div> */
function getVolumeEncodeInfoFunctionDom () {
  
  // 初始值
  if (volumeEncodeInfo.selFunction === null) {
    volumeEncodeInfo.selFunction = functionVolumeEncodeOption[0].name
    volumeEncodeInfo.selFuntionItem = functionVolumeEncodeOption[0]
    volumeEncodeInfo.title = functionVolumeEncodeOption[0].title
    // volumeEncodeInfo.iconPath = functionVolumeEncodeOption[0].path
    setSettingVolumeEncode()
  }


  // 创建功能下拉菜单
  document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="volumeEncodeFunOptionSel"></select>
    </div>
    <div class="sdpi-item" id="usbAudioVolumeEncodeId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.deviceName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="usbAudioVolumeEncodeSel"></select>
    </div>
    <div class="sdpi-item" id="streamVolumeEncodeId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.streamName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="streamVolumeEncodeSel"></select>
    </div>
    <div class="sdpi-item" id="webpageVolumeEncodeId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.webpageName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="webpageVolumeEncodeSel"></select>
    </div>
    <div class="sdpi-item" id="gfxVolumeEncodeId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.gfxName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="gfxVolumeEncodeSel"></select>
    </div>
    <div class="sdpi-item" id="videoVolumeEncodeId" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.videoClipName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="videoVolumeEncodeSel"></select>
    </div>
    <div class="sdpi-item" id="monitorListEncodeID" style="display: none">
      <div class="sdpi-item-label"> ${$PI.localization.volume.deviceName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="monitorEncodeDeviceSel"></select>
    </div>
  `;

  const FunOptionDom = document.getElementById('volumeEncodeFunOptionSel');
  mlwTools.dropDown($PI.localization.volume, 'volumeEncodeFunOptionSel', functionVolumeEncodeOption, 'name', 'name', volumeEncodeInfo.selFunction);
  FunOptionDom.addEventListener('change', sendVolumeEncodeFuncionPlugin);

  // 设置Stream Audio list
  mlwTools.dropDown(false, 'streamVolumeEncodeSel', streamVolumeList, 'name', 'type', volumeEncodeInfo.selStream);
  document.getElementById('streamVolumeEncodeSel').addEventListener('change', changeStreamVolumeEncodeDevice);
  setVolumeEncodeOptionDefaultItem(streamVolumeList[0], 'type', 'selStream', 'selStreamItem')

  // 设置Webpage Audio list
  mlwTools.dropDown(false, 'webpageVolumeEncodeSel', webpageDeviceList, 'name', 'type', volumeEncodeInfo.selWebpage);
  document.getElementById('webpageVolumeEncodeSel').addEventListener('change', changeWebpageVolumeEncodeDevice);
  setVolumeEncodeOptionDefaultItem(webpageDeviceList[0], 'type', 'selWebpage', 'selWebpageItem')

  // 设置gfx Audio list
  mlwTools.dropDown(false, 'gfxVolumeEncodeSel', gfxDeviceList, 'name', 'type', volumeEncodeInfo.selGfx);
  document.getElementById('gfxVolumeEncodeSel').addEventListener('change', changeGfxVolumeEncodeDevice);
  setVolumeEncodeOptionDefaultItem(gfxDeviceList[0], 'type', 'selGfx', 'selGfxItem')

  // 设置usb audio list
  mlwTools.dropDown(false, 'usbAudioVolumeEncodeSel', usbAudioVolumeList, 'name', 'type', volumeEncodeInfo.selUsbAudioType);
  document.getElementById('usbAudioVolumeEncodeSel').addEventListener('change', changeUsbAudioVolumeEncodeDevice);
  setVolumeEncodeOptionDefaultItem(usbAudioVolumeList[0], 'type', 'selUsbAudioType', 'selUsbAudioItem')

  // 设置video list
  mlwTools.dropDown(false, 'videoVolumeEncodeSel', videoDeviceList, 'name', 'type', volumeEncodeInfo.selVideo);
  document.getElementById('videoVolumeEncodeSel').addEventListener('change', changeVideoVolumeEncodeDevice);
  setVolumeEncodeOptionDefaultItem(videoDeviceList[0], 'type', 'selVideo', 'selVideoItem')


  // 所有判断下拉菜单是否展示的集合判断
  allJudgeSetVolumeEncodeFunctionArr()
  isHasNextIconEncodePath()
}

function isHasNextIconEncodePath () {
  // hasNextIcon 是否要判断不同的Icon
  // 注icon等于selFunction+volumeEncodeInfo[hasNextIcon]
  const selFuntionItem = volumeEncodeInfo.selFuntionItem
  const selFun = volumeEncodeInfo.selFunction
  let path = selFuntionItem.path
  console.log('pathParams++++++++++', selFuntionItem)

  if (selFuntionItem.hasOwnProperty('pathParams')) {
    console.log('pathParams', selFuntionItem, volumeEncodeInfo, selFuntionItem.path, volumeEncodeInfo.selStateMute)
    path = selFuntionItem.path + '-' + volumeEncodeInfo[selFuntionItem.pathParams]

  }

  if (selFun === 'volumeMonitorDevice') {
    path = 'monitor' + '-' + volumeEncodeInfo.monitorDeviceItem.iconName
  }

  volumeEncodeInfo.iconPath = path
}


// 判断是否加Monitor Device Option
function isAddMonitorDeviceEncodeOption () {

  mlwTools.dropDown(false, 'monitorEncodeDeviceSel', monitorDeviceList, 'name', 'monitorName', volumeEncodeInfo.selMonitorDevice);
  document.getElementById('monitorEncodeDeviceSel').addEventListener('change', changeVolMonitorEncodeSel);
  setVolumeEncodeOptionDefaultItem(monitorDeviceList[0], 'monitorName', 'selMonitorDevice', 'monitorDeviceItem')

  if (volumeEncodeInfo.selFunction === 'volumeMonitorDevice') {
    document.getElementById('monitorListEncodeID').style.display = 'inline-flex'
  } else {
    document.getElementById('monitorListEncodeID').style.display = 'none'
  }
}


// 设置默认值
function setVolumeEncodeOptionDefaultItem (item, itemKey, key, selKey) {
  console.log('setVolumeEncodeOptionDefaultItem', item)
  if (!item) return
  if (volumeEncodeInfo[key] === null) {
    volumeEncodeInfo[key] = item[itemKey]
    volumeEncodeInfo[selKey] = item
    setSettingVolumeEncode()
  }
}


// 选择功能
function sendVolumeEncodeFuncionPlugin (event) {
  const value = event.target.value
  volumeEncodeInfo.selFunction = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.selFuntionItem = functionVolumeEncodeOption[selectedIndex]

  // volumeEncodeInfo.iconPath = mlwTools.findNextFunIconPath(volumeEncodeInfo, volumeEncodeInfo.selFuntionItem)

  volumeEncodeInfo.title = mlwTools.findNextFunTitle(volumeEncodeInfo, volumeEncodeInfo.selFuntionItem, 'name')
  allJudgeSetVolumeEncodeFunctionArr()

  isHasNextIconEncodePath()

  setSettingVolumeEncode()
  
}

// 所有判断下拉菜单是否展示的集合判断
function allJudgeSetVolumeEncodeFunctionArr () {
  // 是否有Audio Volume功能的name集合
  isCurFunctionHasDomEncode(hasUsbAudioListArr, 'usbAudioVolumeEncodeId')
  // 是否有video Volume功能的name集合
  isCurFunctionHasDomEncode(hasVideoListArr, 'videoVolumeEncodeId')

  // 是否有设置stream的name集合
  isCurFunctionHasDomEncode(hasStreamListArr, 'streamVolumeEncodeId')
  // 是否有设置webpage的name集合
  isCurFunctionHasDomEncode(hasWebpageListArr, 'webpageVolumeEncodeId')
  // 是否有设置gfx的name集合
  isCurFunctionHasDomEncode(hasGfxListArr, 'gfxVolumeEncodeId')

  // 判断是否加Monitor Device
  isAddMonitorDeviceEncodeOption()
}


// 判断当前选择的function中是否有相关dom展示
function isCurFunctionHasDomEncode (arr, domName, hasNextIcon) {
  const funItem = volumeEncodeInfo.selFunction
  console.log('isCurFunctionHasDomEncode', funItem)
  const isInd = arr.indexOf(funItem)

  if (isInd >= 0) {
    document.getElementById(domName).style.display = 'inline-flex'


  } else {
    document.getElementById(domName).style.display = 'none'
  }
}

// 选择 Monitor 设备
function changeVolMonitorEncodeSel (event) {
  const value = event.target.value
  volumeEncodeInfo.selMonitorDevice = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.monitorDeviceItem = monitorDeviceList[selectedIndex]
  volumeEncodeInfo.title = monitorDeviceList[selectedIndex].name

  volumeEncodeInfo.iconPath = 'monitor' + '-' + volumeEncodeInfo.monitorDeviceItem.iconName
  setSettingVolumeEncode()
}

// 变更Usb AudioDevice
function changeUsbAudioVolumeEncodeDevice (event) {
  const value = event.target.value
  volumeEncodeInfo.selUsbAudioType = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.selUsbAudioItem = usbAudioVolumeList[selectedIndex]
  volumeEncodeInfo.title = usbAudioVolumeList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolumeEncode()
}


// 变更Video Device
function changeVideoVolumeEncodeDevice (event) {
  const value = event.target.value
  volumeEncodeInfo.selVideo = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.selVideoItem = videoDeviceList[selectedIndex]
  volumeEncodeInfo.title = videoDeviceList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolumeEncode()
}
// 变更stream Device
function changeStreamVolumeEncodeDevice (event) {
  const value = event.target.value
  volumeEncodeInfo.selStream = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.selStreamItem = streamVolumeList[selectedIndex]
  volumeEncodeInfo.title = streamVolumeList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolumeEncode()
}
// 变更webpage Device
function changeWebpageVolumeEncodeDevice (event) {
  const value = event.target.value
  volumeEncodeInfo.selWebpage = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.selWebpageItem = webpageDeviceList[selectedIndex]
  volumeEncodeInfo.title = webpageDeviceList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolumeEncode()
}

// 变更gfx Device
function changeGfxVolumeEncodeDevice (event) {
  const value = event.target.value
  volumeEncodeInfo.selGfx = value

  const selectedIndex = event.target.options.selectedIndex
  volumeEncodeInfo.selGfxItem = gfxDeviceList[selectedIndex]
  volumeEncodeInfo.title = gfxDeviceList[selectedIndex].name

  // 注icon等于selFunction+value
  setSettingVolumeEncode()
}

