
var monitorDeviceList = [] // monitor
var usbAudioVolumeList = [] // usbAudio
var streamVolumeList = [] // stream
var videoDeviceList = [] // Video
var webpageDeviceList = []  // webpage
var gfxDeviceList = [] // gfx
var mixerSoloDevice = [] // solo device
var inputDelayDevice = [] // input delay



// 是否有设置音量功能的name集合
var hasUsbAudioListArr = ['volumeUsbAudioOption', 'volumeUsbAudioVolume']

// 是否有设置video的name集合
var hasVideoListArr = ['volumeVideoActionScope', 'volumeVideoOption', 'volumeVideoVolume']

// 是否有设置stream的name集合
var hasStreamListArr = ['volumeStreamActionScope', 'volumeStreamGlobalOption', 'volumeStreamSceneOption', 'volumeStreamVolume']

// 是否有设置webpage的name集合
var hasWebpageListArr = ['volumeWebpageActionScope', 'volumeWebpageGlobalOption', 'volumeWebpageOption', 'volumeWebpageVolume']

// 是否有设置gfx的name集合
var hasGfxListArr = ['volumeGfxOption', 'volumeGfxVolume']



// 获取 Config 列表请求
async function getConfigDeviceList() {
  try {
    const response = await request('/V1.0/volume/getConfig');
    if (response.status === 0) {
    }
  } catch (err) {
    console.error('Error fetching Config Device list:', err);
    throw err;
  }
}

// 获取monitor列表请求
async function getMonitorDeviceList() {
  try {
    const response = await request('/V1.0/volume/getMonitorDevices');
    if (response.status === 0) {
      const list = response.monitorAudioDeivceList
      list.forEach(item => {
        item.deviceId = item.id
        item.monitorName = `${item.id}-${item.deviceType}-${item.cardNo}-${item.devNo}`

        if (item.deviceType == 0 && item.id == 0) {
          item.iconName = 'mic'
        } else if (item.deviceType == 0 && item.id == 1) {
          item.iconName = 'bluetooth'
        } else {
          item.iconName = 'usb'
        }
      })
      monitorDeviceList = [...list]
      console.log('monitorDeviceList', monitorDeviceList)
    }
  } catch (err) {
    console.error('Error fetching Monitor Audio list:', err);
    throw err;
  }
}


// 获取stream列表请求
async function getStreamDeviceList() {
  try {
    const response = await request('/V1.0/volume/getStreamVolumeMixers');
    if (response.status === 0) {
      const list = response.audioList

      streamVolumeList = [...list]
      console.log('streamVolumeList', streamVolumeList)
    }
  } catch (err) {
    console.error('Error fetching Stream Audio list:', err);
    throw err;
  }
}


// 获取usbAudio列表请求
async function getUsbAudioDeviceList() {
  try {
    const response = await request('/V1.0/volume/getUsbVolumeMixers');
    if (response.status === 0) {
      const list = response.audioList

      usbAudioVolumeList = [...list]
    }
  } catch (err) {
    console.error('Error fetching USB Audio list:', err);
    throw err;
  }
}

// 获取 video 列表请求
async function getVideoDeviceList() {
  try {
    const response = await request('/V1.0/volume/getVideoVolumeMixers');
    if (response.status === 0) {
      const list = response.audioList

      videoDeviceList = [...list]
      console.log('videoDeviceList', videoDeviceList)
    }
  } catch (err) {
    console.error('Error fetching Video list:', err);
    throw err;
  }
}

// 获取webpage列表请求
async function getWebpageDeviceList() {
  try {
    const response = await request('/V1.0/volume/getWebpageVolumeMixers');
    if (response.status === 0) {
      const list = response.audioList

      webpageDeviceList = [...list]
      console.log('webpageDeviceList', webpageDeviceList)
    }
  } catch (err) {
    console.error('Error fetching webpage Audio list:', err);
    throw err;
  }
}

// 获取gfx列表请求
async function getGfxDeviceList() {
  try {
    const response = await request('/V1.0/volume/getGfxVolumeMixers');
    if (response.status === 0) {
      const list = response.audioList

      gfxDeviceList = [...list]
      console.log('getGfxDeviceList', gfxDeviceList)
    }
  } catch (err) {
    console.error('Error fetching gfx Audio list:', err);
    throw err;
  }
}

