var webpageInfo = {
    selFunction: null,
    selFunctionItem: {},
    title: "",
} // 按键中需要存在的字段

var webpageFunctionOption = [
    // {name: 'webGoHome', value: ''},
    {name: 'webGoBack', value: '/V1.0/graphics/goBack', title: "webGoBackTitle"},
    {name: 'webGoForward', value: '/V1.0/graphics/goForward', title: "webGoForwardTitle"},
    {name: 'webZoomOut', value: '/V1.0/graphics/doScale', paramsKey: {scale: '1'}, title: "webZoomOutTitle"},
    {name: 'webZoomIn', value: '/V1.0/graphics/doScale', paramsKey: {scale: '1'}, title: "webZoomInTitle"},
    {name: 'webReset', value: '/V1.0/graphics/reset', title: "webResetTitle"},
    {name: 'webReload', value: '/V1.0/graphics/reload', title: "webReloadTitle"},
    {name: 'webPageTop', value: '/V1.0/graphics/homeAction', title: "webPageTopTitle"},
    {name: 'webPageBottom', value: '/V1.0/graphics/endAction', title: "webPageBottomTitle"},
    {name: 'webPageUp', value: '/V1.0/graphics/pageUpAction', title: "webPageUpTitle"},
    {name: 'webPageDown', value: '/V1.0/graphics/pageDownAction', title: "webPageDownTitle"},
    {name: 'webUp', value: '/V1.0/graphics/upAction', title: "webUpTitle"},
    {name: 'webLeft', value: '/V1.0/graphics/leftAction', title: "webLeftTitle"},
    {name: 'webDown', value: '/V1.0/graphics/downAction', title: "webDownTitle"},
    {name: 'webRight', value: '/V1.0/graphics/rightAction', title: "webRightTitle"}
]

function getWebpageActionInfo(actionInfo) {
    // 存储在按键中的信息
    var settings = actionInfo.payload.settings
    if (settings.hasOwnProperty('baseURL')) {
        baseURL = settings.baseURL
    }

    var actCtxSetting = {}
    if (settings.hasOwnProperty('webpageInfo')) {
        actCtxSetting = settings.webpageInfo
    }

    // 查找需要的字段
    const actionKey = ['selFunction', 'selFunctionItem', 'title']
    // 字段是否存在,存在赋值,不存在为null
    actionKey.forEach(item => {
        if (actCtxSetting.hasOwnProperty(item)) {
            webpageInfo[item] = actCtxSetting[item]
        } else {
            webpageInfo[item] = null
        }
    })

    getWebpageFunctionDom()
}

function setSettingWebpage(value, key) {
    // 判断是否有默认值
    if (webpageInfo.selFunctionItem.hasOwnProperty('paramsKey')) {
        // 如果value有设置值
        value = value || webpageInfo.selFunctionItem.paramsKey[key]
        webpageInfo.selFunctionItem.paramsKey[key] = value
    }

    setSettingInKey2({
        webpageInfo: webpageInfo
    })
}

function getWebpageFunctionDom() {
    // 初始值
    if (webpageInfo.selFunction === null) {
        webpageInfo.selFunction = webpageFunctionOption[0].value
        webpageInfo.selFunctionItem = webpageFunctionOption[0];
        webpageInfo.title = webpageInfo.selFunctionItem.title;
        setSettingWebpage()
    }

    // 创建功能下拉菜单
    document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.functionName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="webpageFunOptionSel"></select>
    </div>
  `;
    initToolTips();

    const FunOptionDom = document.getElementById('webpageFunOptionSel');
    FunOptionDom.addEventListener('change', webpageFunOptionSelChange);
    let select = document.getElementById("webpageFunOptionSel");
    select.innerHTML = '';
    let frag = document.createDocumentFragment();
    for (var i = 0; i < webpageFunctionOption.length; i++) {
        let item = webpageFunctionOption[i];
        let option = document.createElement("option");
        option.innerHTML = $PI.localization.webpage[item['name']];
        option.value = item["value"];
        if (webpageInfo.selFunction !== null && webpageInfo.selFunction === item["value"] && webpageInfo.selFunctionItem['name'] === item['name']) {
            option.selected = true
        }
        frag.appendChild(option); //将设置好的 option插入文档片段。
    }
    select.appendChild(frag);

    // 判断选择的功能展示对应dom
    console.log('mlwTools', webpageFunctionOption, webpageInfo.selFunction)
    mlwTools.controlFunctionDisplay(webpageFunctionOption, webpageInfo.selFunction)

}

function webpageFunOptionSelChange(event) {
    const value = event.target.value
    const selectedIndex = event.target.options.selectedIndex
    webpageInfo.selFunctionItem = webpageFunctionOption[selectedIndex]
    webpageInfo.selFunction = value;
    webpageInfo.title = webpageInfo.selFunctionItem.title;

    // 判断选择的功能展示对应dom
    console.log('mlwTools', webpageFunctionOption, webpageInfo.selFunction)
    mlwTools.controlFunctionDisplay(webpageFunctionOption, webpageInfo.selFunction)
    setSettingWebpage()
}

