/// <reference path="libs/js/action.js" />
/// <reference path="libs/js/stream-deck.js" />

/**
 * The first event fired when Stream Deck starts
 */

const clientId = Date.now()
var statemachineInfo = {}
var volumeConfigList = []
var ACTION = {}
var networkIsError = null
var pluGlobalSettings = null
getStatemachine()
getVolumeConfigRequest()

$SD.getGlobalSettings()
console.log('getGlobalSettings--sd', $SD)

$SD.onDidReceiveGlobalSettings((e) => {
  console.log('onDidReceiveGlobalSettings', e)
  const payload = e.payload
  const setting = payload.settings
  pluGlobalSettings = setting
  if (setting.hasOwnProperty('baseURL') && setting.baseURL) {
    baseURL = setting.baseURL
  }
  if (setting.hasOwnProperty('networkIsError')) {
    networkIsError = setting.networkIsError
  }
})

function getStatemachine() {
    if (baseURL) {
        request('/mwapi/statemachine', {
            body: {
                client: clientId
            }
        }).then(data => {
            isCompareNetworkError(true)
            if (data.status === 0) {
              statemachineInfo = data
            }
            this.delayGetStatemachine()
        }).catch(err => {
            isCompareNetworkError(false)
            this.delayGetStatemachine()
        });
    } else {
      isCompareNetworkError(false)
      this.delayGetStatemachine()
    }

}

function isCompareNetworkError (val) {
  if (val !== networkIsError && pluGlobalSettings) {
    networkIsError = val

    let payload = pluGlobalSettings
    payload.networkIsError = val
    $SD.setGlobalSettings(payload)
  }
}

function delayGetStatemachine() {
    setTimeout(() => {
        getStatemachine()
    }, 1000)
}

function delayVolumeConfigRequest() {
  setTimeout(() => {
    getVolumeConfigRequest()
  }, 1000)
}

function getVolumeConfigRequest() {
  if (baseURL) {
    request('/V1.0/volume/getConfig')
      .then(data => {
          if (data.status === 0) {
            volumeConfigList = data.audioList
          }
          this.delayVolumeConfigRequest()
      }).catch(err => {
          this.delayVolumeConfigRequest()
      });
  } else {
    this.delayVolumeConfigRequest()
  }

}