const audioMixerAction = new Action('com.magewell.magewell-director.audio-mixer');

audioMixerAction.onKeyUp((e) => {
  if (e.payload.settings.hasOwnProperty('volumeInfo')) {
    const volumeInfo = e.payload.settings.volumeInfo
    volumeActionRequestApi(volumeInfo, e)
  }
});

audioMixerAction.onWillAppear((e) => {
  const payload = e.payload
  const setting = payload.settings
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setVolumeKeyImageTitle(e)
})

function setVolumeKeyImageTitle (e) {
  if (e.payload.settings.hasOwnProperty('volumeInfo')) {
    let volumeInfo = e.payload.settings.volumeInfo
    console.log('setVolumeKeyImageTitle', volumeInfo)
    let title = ''
    volumeInfo = volumeInfo || {}

    if (volumeInfo.hasOwnProperty('title')) {
      title = String(volumeInfo.title)
      console.log('title', title == null, title == String(null), title)

      title = title == String(null) ? '' : title
    }


    if ($SD.localization.volume[title]) {
      $SD.setTitle(e.context, $SD.localization.volume[title])
    } else {
      $SD.setTitle(e.context, title)
    }

    const img = 'image/volume/' + volumeInfo.iconPath
    $SD.setImage(e.context, img);
  }
}


audioMixerAction.onDidReceiveSettings((e) => {
  setVolumeKeyImageTitle(e)
})
function volumeActionRequestApi (info, action) {
  const funItem = info.selFuntionItem
  let selInfo = info.selFuntionItem
  if (funItem.hasOwnProperty('isRequest')) {
    selInfo = info[funItem.isRequest]
  }
  let path = selInfo.value

  if (selInfo.hasOwnProperty('paramsKey')) {
    const paramsKey = selInfo.paramsKey
    let num = 1
    path = path + '?'

    for (let key in paramsKey) {
      let selValue = ''
      console.log('volumeActionRequestApi', info[paramsKey[key]])
      if (Object.prototype.toString.call(info[paramsKey[key]]) === '[object Object]') {
        // 是对象
        selValue = info[paramsKey[key]][key]
        console.log('volumeActionRequestApi99999', info[paramsKey[key]], info[paramsKey[key]][key])
      } else {
        selValue = info[paramsKey[key]]
      }

      path = num === 1 ? path + key + '=' + selValue : path + '&' + key + '=' + selValue
      num++
    }
  }

  request(path)
  .then(data => {})
  .catch(err => {
    $SD.showAlert(action.context)
  })
}
