
const playPauseBgmAction = new Action('com.magewell.magewell-director.bgm');
const MACTIONS = {};
var bgmInterval = null;
var isBgmProgressRotate = false

playPauseBgmAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("bgmInfo")) {
    const settingInfo = settings.bgmInfo
    bgmActionRequestApi(settingInfo, e)
  }
});

playPauseBgmAction.onWillAppear((e) => {
  const payload = e.payload
  const settings = e.payload.settings
  if (settings.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = settings.baseURL
    // $SD.sendToPropertyInspector(e.context, e.action, setting)
  }

  const payloadA = {
    ...payload
  }

  if (settings.hasOwnProperty("bgmInfo")) {
    settings.bgmInfo.progressValue = settings.bgmInfo.progressValue || '1%'
    settings.bgmInfo.progress = settings.bgmInfo.progress || 1
    payloadA.progressValue = settings.bgmInfo.progressValue
    payloadA.progress = settings.bgmInfo.progress
  } else {
    settings.bgmInfo = {
      progressValue: '1%',
      progress: 1
    }
  }

  payloadA.title = $SD.localization.bgm.bgmProgress


  $SD.setSettings(e.context, { ...settings });

  $SD.setFeedback(e.context, payloadA);

  setBgmKeyImageTitle(e)


  if (payload.controller === 'Encoder') {
    bgmInterval = setInterval(() => {
      // this.getStatemachineVideoDelay(e);
      if (isBgmProgressRotate) {
        isBgmProgressRotate = false
      } else {
        const sceneBgm = statemachineInfo.bgmStatus
        const showBgm = statemachineInfo.bgmOfShowStatus
        const bgmType = statemachineInfo.bgmType
        let stateProgress = 0

        if (bgmType == 0) {
          stateProgress = sceneBgm.progress * 100
        } else if (bgmType === 1) {
          stateProgress = showBgm.progress * 100
        } else {
          stateProgress = 0
        }

        stateProgress = parseInt(stateProgress)
        settings.bgmInfo.progressValue = stateProgress + '%'
        settings.bgmInfo.progress = stateProgress

        payloadA.progressValue = stateProgress + '%'
        payloadA.progress = stateProgress

        $SD.setSettings(e.context, { ...settings });
        $SD.setFeedback(e.context, payloadA);
      }
    }, 1000);
  }
})

playPauseBgmAction.onWillDisappear((e) => {
  clearInterval(bgmInterval)
  bgmInterval = null
})

function setBgmKeyImageTitle (e) {
  var settings = e.payload.settings
  if (settings.hasOwnProperty("bgmInfo")) {
    let contentInfo = settings.bgmInfo
    contentInfo = contentInfo || {}

    let title = ''
    if (contentInfo.hasOwnProperty('title')) {
      title = contentInfo.title
    }
    if ($SD.localization.bgm[title]) {
      $SD.setTitle(e.context, $SD.localization.bgm[title])
    } else {
      $SD.setTitle(e.context, title)
    }
    const img = 'image/bgm/' + contentInfo.iconPath
    $SD.setImage(e.context, img);
  }
}

playPauseBgmAction.onDidReceiveSettings((e) => {
  setBgmKeyImageTitle(e)
})
function bgmActionRequestApi (info, action) {
  const selInfo = info.selFuntionItem
  let path = selInfo.value

  if (selInfo.hasOwnProperty('paramsKey')) {
    const paramsKey = selInfo.paramsKey
    path = path + '?'

    for (let key in paramsKey) {
      path = path + key + '=' + info[paramsKey[key]]
    }
  }

  request(path)
  .then(data => {})
  .catch(err => {
    $SD.showAlert(action.context)
  })
}

playPauseBgmAction.onDialRotate((e) => {
  isBgmProgressRotate = true

  let payload = e.payload
  const settings = e.payload.settings
  const bgmInfo = e.payload.settings.bgmInfo

  let progress = bgmInfo.progress + payload.ticks

  if (progress <= 0) {
    progress = 1
  } else if (progress > 100) {
    progress = 100
  }
  const payloadA = {
    ...payload
  }

  payloadA.progressValue = progress + '%'
  payloadA.progress = progress

  bgmInfo.progressValue = progress + '%'
  bgmInfo.progress = progress

  $SD.setFeedback(e.context, payloadA);

  settings.bgmInfo = { ...bgmInfo }
  $SD.setSettings(e.context, {
    ...settings
  });

  seekBgmByProgressApi(progress, e)

})


function seekBgmByProgressApi(params, action) {
  request(`/V1.0/bgm/seekByProgress?progress=${params / 100}`)
    .then(data => {})
    .catch(err => {
      $SD.showAlert(action.context)
    })
}


class SampleIndicatorBgmAction {
  constructor (context, payload) {
      this.isEncoder = payload.controller === 'Encoder';
      this.context = context;
      this.interval = null;
      if(this.isEncoder) {
          this.width = 100; // default width of the panel is 100
          this.height = 50; // default height of the panel is 50
      } else {
          this.width = 144; // default width of the icon is 72
          this.height = 144; // default width of the icon is 72
      }
      this.iconSize = 32
      this.color = '#EFEFEF';
      this.init();
      this.update();
  }

  init() {
      // this.interval = setInterval(() => {
      //     this.update();
      // }, 1000);
  }

  manualRotate(ticks) {

      // $SD.setFeedback(this.context, {
      //     'value': this.manualValue,
      //     indicator: this.manualValue
      // });
  }

  update() {
      // const svg = this.createIcon();
      // const icon = `data:image/svg+xml;,${svg}`;
      if(this.isEncoder) {
          let title = '';
          let indicator = {};

          // const payload = {
          //     title: title,
          //     value: indicatorValue,
          //     indicator,
          //     icon
          // };
          // $SD.setFeedback(this.context, payload);
      }
      // $SD.setImage(this.context, icon);
  }

  createIcon() {
  };

};
