
const brightnessAction = new Action('com.magewell.magewell-director.brightness');

brightnessAction.onWillAppear((e) => {
  const payload = e.payload
  const settings = e.payload.settings

  ACTION[e.context] = {
    isDelayDispaly: false,
    stateInfoInterval: null,
    isAdjuestRotate: false,
    brightnessInfo: {}
  }

  if (settings.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = settings.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, settings)
  }

  const payloadA = {
    ...payload
  }

  if (settings.hasOwnProperty("brightnessInfo")) {
    settings.brightnessInfo.progressValue = settings.brightnessInfo.progressValue || '100%'
    settings.brightnessInfo.progress = settings.brightnessInfo.progress || 100

    payloadA.progressValue = settings.brightnessInfo.progressValue
    payloadA.progress = settings.brightnessInfo.progress
    payloadA.title = settings.brightnessInfo.title
  } else {
    settings.brightnessInfo = {
      progressValue: '100%',
      progress: 100
    }
  }

  ACTION[e.context].brightnessInfo = settings.brightnessInfo

  $SD.setSettings(e.context, { ...settings });
  $SD.setFeedback(e.context, payloadA);

  brightnessInfoDelaySettingFun(e)
})

function brightnessInfoDelaySettingFun (e) {
  const payload = {}
  const settings = e.payload.settings

  if (e.payload.controller === 'Encoder'&& (!ACTION[e.context].isDelayDispaly)) {
    ACTION[e.context].stateInfoInterval = setInterval(() => {
      // this.getStatemachineVideoDelay(e);
      if (ACTION[e.context].isAdjuestRotate) {
        ACTION[e.context].isAdjuestRotate = false
      } else {
        const brightness = Math.round(statemachineInfo.brightness * 100)

        const info = ACTION[e.context].brightnessInfo

        info.progressValue = brightness + '%'
        info.progress = brightness

        payload.progressValue = brightness + '%'
        payload.progress = brightness

        settings.brightnessInfo = { ...info }
        $SD.setSettings(e.context, {
          ...settings
        });
        $SD.setFeedback(e.context, payload);
      }
    }, 1000);
  }
}


brightnessAction.onWillDisappear((e) => {
  clearInterval(ACTION[e.context].stateInfoInterval)

  ACTION[e.context].stateInfoInterval = null
  ACTION[e.context].isDelayDispaly = true
  delete ACTION[e.context]
})

brightnessAction.onDidReceiveSettings((e) => {

  let settings = e.payload.settings
  if (settings.hasOwnProperty("brightnessInfo")) {
    const info = settings.brightnessInfo
    ACTION[e.context].brightnessInfo = settings.brightnessInfo
  }
})


brightnessAction.onDialRotate((e) => {
  ACTION[e.context].isAdjuestRotate = true

  let payload = e.payload
  const brightnessInfo = e.payload.settings.brightnessInfo
  const settings = e.payload.settings
  const ticks = payload.ticks
  
  let progress = brightnessInfo.progress

  if (progress <= 0) {
    if (ticks > 0) {
      progress = 10
    } else {
      progress = 0
    }
  } else if (progress <= 10) {
    if (ticks < 0) {
      progress = 0
    } else {
      progress = progress + ticks
    }
  } else (
    progress = progress + ticks
  )

  if (progress > 100) {
    progress = 100
  }
  const payloadA = {
    ...payload
  }

  payloadA.progressValue = progress + '%'
  payloadA.progress = progress

  brightnessInfo.progressValue = progress + '%'
  brightnessInfo.progress = progress

  $SD.setFeedback(e.context, payloadA);

  settings.brightnessInfo = { ...brightnessInfo }
  $SD.setSettings(e.context, {
    ...settings
  });

  setBrightnessApi(progress, e)

})


function setBrightnessApi(params, action) {
  request(`/V1.0/system/setBrightness?brightness=${params / 100}`)
    .then(data => {})
    .catch(err => {
      $SD.showAlert(action.context)
    })
}

