const gfxAction = new Action('com.magewell.magewell-director.gfx');


gfxAction.onKeyUp((e) => {
  const settings = e.payload.settings
  if (settings.hasOwnProperty("gfxInfo")) {
    const gfxInfo = settings.gfxInfo
    gfxRequestApi(gfxInfo, e)
  }
});

gfxAction.onWillAppear((e) => {
  const payload = e.payload
  const setting = payload.settings
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setGfxKeyImageTitle(e)
})

function setGfxKeyImageTitle (e) {
  const settings = e.payload.settings
  if (settings.hasOwnProperty("gfxInfo")) {
    const gfxInfo = settings.gfxInfo

    if (gfxInfo.selFuntionItem.name !== 'clearOverlay') {
      $SD.setTitle(e.context, gfxInfo.selGfxName)
    } else {
      const title = gfxInfo.selFuntionItem.title
      $SD.setTitle(e.context, $SD.localization.gfx[title])
    }

    let pathName = gfxInfo.selFuntionItem.name
    const img = 'image/gfx/' + pathName
    $SD.setImage(e.context, img);
  }
}

gfxAction.onDidReceiveSettings((e) => {
  setGfxKeyImageTitle(e)
})

function gfxRequestApi (gfxInfo, action) {
  let path = gfxInfo.selFunction
  if (path === '/V1.0/gfx/actionByUUID') {
    path = path + '?uuid=' + gfxInfo.selGfxUuid
  } else if (path === 'turnOn') {
    path = '/V1.0/gfx/actionByUUID?uuid=' + gfxInfo.selGfxUuid + '&on=true'
  } else if (path === 'turnOff') {
    path = '/V1.0/gfx/actionByUUID?uuid=' + gfxInfo.selGfxUuid + '&on=false'
  }
  request(path)
    .then(data => {})
    .catch(err => {
      $SD.showAlert(action.context)
    })
}
