const otherAction = new Action('com.magewell.magewell-director.other');

otherAction.onKeyUp((e) => {
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("otherInfo")) {
        const otherInfo = settings.otherInfo
        othersActionRequestApi(otherInfo, e)
    }
});

otherAction.onWillAppear((e) => {
    const settings = e.payload.settings
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    otherSetTitleAndImage(e);
})

function otherSetTitleAndImage(e)
{
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("otherInfo")) {
        const dataInfo = settings.otherInfo
        if (dataInfo.hasOwnProperty('selFunctionItem')) {
            let pathName = dataInfo.selFunctionItem.name;
            let imagePath = 'image/other/';
            if(pathName !== 'setUsbCDpOutput') {
                $SD.setImage(e.context, imagePath + pathName);
            }

            switch (pathName){
                case "setUsbCDpOutput":
                    $SD.setTitle(e.context, $SD.localization.other["usb_c_mode_label_title_"+dataInfo.usbCOutput]);
                    $SD.setImage(e.context, imagePath + pathName+"_"+dataInfo.usbCOutput);
                    break;
                case "reboot":
                case "powerOff":
                case "screenshot":
                    $SD.setTitle(e.context, $SD.localization.other[pathName]);
                    break;
                case "freeze":
                case "unfreeze":
                case "freezeOrUnfreeze":
                case "tunOnFtb":
                case "tunOffFtb":
                case "tunOnOrOffFtb":
                    $SD.setTitle(e.context, $SD.localization.other[pathName+"Title"]);
                    break;
                default:
                    $SD.setTitle(e.context, "");
            }
        }
    }
}

otherAction.onDidReceiveSettings((e) => {
    console.log('otherAction onDidReceiveSettings', e)
    otherSetTitleAndImage(e);
})

function othersActionRequestApi(transitionInfo, action) {
    let { selFunction, selFunctionItem } = transitionInfo;
    if (selFunctionItem.hasOwnProperty('paramsKey')) {
        const paramsKey = selFunctionItem.paramsKey
        let num = 1
        selFunction = selFunction + '?'
        for (let key in paramsKey) {
            selFunction = num === 1 ? selFunction + key + '=' + paramsKey[key] : selFunction + '&' + key + '=' + paramsKey[key]
            num++;
        }
    }
    request(selFunction).then(data => {}).catch(err => {
        $SD.showAlert(action.context)
    })
}
