const ptzFocusAction = new Action('com.magewell.magewell-director.ptz.focus');


ptzFocusAction.onWillAppear((e) => {
    const payload = e.payload
    const settings = e.payload.settings
    console.log('ptzFocusAction onWillAppear', e)
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    const payloadA = {
        ...payload
    }

    if (settings.hasOwnProperty("ptzFocusInfo")) {
        settings.ptzFocusInfo.progressValue = settings.ptzFocusInfo.progressValue || '0'
        settings.ptzFocusInfo.progress = settings.ptzFocusInfo.progress || 0
        payloadA.progressValue = settings.ptzFocusInfo.progressValue
        payloadA.progress = settings.ptzFocusInfo.progress
    } else {
        settings.ptzFocusInfo = {
            progressValue: '0',
            progress: 0
        }
    }

    payloadA.title = $SD.localization.ptz.ptzFocusEncoderTitle; // 'PTZ Focus'

    $SD.setSettings(e.context, {
        ...settings
    });

    $SD.setFeedback(e.context, payloadA);
})

ptzFocusAction.onDialRotate((e) => {
    let payload = e.payload
    const info = e.payload.settings.ptzFocusInfo
    const settings = e.payload.settings

    let progress = info.progress + (payload.ticks) * 10

    if (progress <= 0) {
        progress = 0
    } else if (progress > 100) {
        progress = 100
    }
    const payloadA = {
        ...payload
    }

    payloadA.progressValue = progress
    payloadA.progress = progress

    info.progressValue = progress
    info.progress = progress

    $SD.setFeedback(e.context, payloadA);
    settings.ptzFocusInfo = { ...ptzFocusInfo }
    $SD.setSettings(e.context, {
        ...settings
    });

    seekPtzFocusByProgressApi(progress, e)
})

function seekPtzFocusByProgressApi(params, action) {
    console.log(`/V1.0/ptz/focusExact?focusValue=${params / 100}`)
    request(`/V1.0/ptz/focusExact?focusValue=${params / 100}`)
        .then(data => {})
        .catch(err => {
            $SD.showAlert(action.context)
        })
}
