const ptzZoomAction = new Action('com.magewell.magewell-director.ptz.zoom');


ptzZoomAction.onWillAppear((e) => {
    const payload = e.payload
    const settings = e.payload.settings
    console.log('ptzZoomAction onWillAppear', e)
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    const payloadA = {
        ...payload
    }

    if (settings.hasOwnProperty("ptzZoomInfo")) {
        settings.ptzZoomInfo.progressValue = settings.ptzZoomInfo.progressValue || '0%';
        settings.ptzZoomInfo.progress = settings.ptzZoomInfo.progress || 0;
        payloadA.progressValue = settings.ptzZoomInfo.progressValue
        payloadA.progress = settings.ptzZoomInfo.progress
    } else {
        settings.ptzZoomInfo = {
            progressValue: '0%',
            progress: 0
        }
    }

    payloadA.title =  $SD.localization.ptz.ptzZoomEncoderTitle; // 'PTZ Zoom'

    $SD.setSettings(e.context, {
        ...settings
    });

    $SD.setFeedback(e.context, payloadA);
})

ptzZoomAction.onDialRotate((e) => {
    let payload = e.payload
    const info = e.payload.settings.ptzZoomInfo
    const settings = e.payload.settings

    let progress = info.progress + (payload.ticks) * 2

    if (progress <= 0) {
        progress = 0
    } else if (progress > 100) {
        progress = 100
    }
    const payloadA = {
        ...payload
    }

    payloadA.progressValue = progress + '%'
    payloadA.progress = progress

    info.progressValue = progress + '%'
    info.progress = progress

    $SD.setFeedback(e.context, payloadA);
    settings.ptzZoomInfo = info
    
    $SD.setSettings(e.context, {
        ...settings
    });

    seekPtzZoomByProgressApi(progress, e)
})

function seekPtzZoomByProgressApi(params, action) {
    console.log(`/V1.0/ptz/zoomExact?zoomValue=${params / 100}`)
    request(`/V1.0/ptz/zoomExact?zoomValue=${params / 100}`)
        .then(data => {})
        .catch(err => {
            $SD.showAlert(action.context)
        })
}
