const startStopRecordingAction = new Action('com.magewell.magewell-director.record');

startStopRecordingAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("recordInfo")) {
    const settingInfo = settings.recordInfo
    serverRecordRequestApi(settingInfo, e)
  }
});

startStopRecordingAction.onWillAppear((e) => {
  const setting = e.payload.settings
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setRecordKeyImageTitle(e)
})

function setRecordKeyImageTitle (e) {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("recordInfo")) {
    let contentInfo = settings.recordInfo
    contentInfo = contentInfo || {}

    let title = ''
    if (contentInfo.hasOwnProperty('title')) {
      title = contentInfo.title
    }
    if ($SD.localization.record[title]) {
      $SD.setTitle(e.context, $SD.localization.record[title])
    } else {
      $SD.setTitle(e.context, title)
    }
    const img = 'image/record/' + contentInfo.iconPath
    $SD.setImage(e.context, img);
  }
}

startStopRecordingAction.onDidReceiveSettings((e) => {
  setRecordKeyImageTitle(e)
})
function serverRecordRequestApi (info, action) {
  const selInfo = info.selFuntionItem
  let path = selInfo.value

  request(path)
  .then(data => {})
  .catch(err => {
    $SD.showAlert(action.context)
  })
}
