const replayAction = new Action('com.magewell.magewell-director.replay');
var replayInterval = null;
var isReplayProgressRotate = false

replayAction.onKeyUp((e) => {
    const settings = e.payload.settings
    console.log('replayAction onKeyUp', e)
    if (settings.hasOwnProperty("replayInfo")) {
        const { eventList, replayInfo } = settings;
        const info = replayInfo;

        if(info.selFunctionItem.paramsKey) {
            // 开始判断是什么操作并开始设置参数
            const { name, paramsKey  } = info.selFunctionItem;
            switch (name) {
                case "replayOfBuffer":
                    paramsKey['lensIndex'] = info.selReplayLens;
                    break;
                case "replaySecondsAgo":
                    paramsKey['seconds'] = info.selReplaySecondsAgo;
                    paramsKey['lensIndex'] = info.selReplayLens;
                    break;
                case "replayLastEvent":
                    paramsKey['lensIndex'] = info.selReplayLens;
                    break;
                case "replaySelEvent":
                    paramsKey['replayRecordId'] = info.selReplayRecordId;
                    paramsKey['lensIndex'] = info.selReplayLens;
                    break;
                case "replayToSpecificPosition":
                    paramsKey['progress'] = parseInt(info.selSpecificPosition) * 1000;
                    break;
                case "replayAddEvent":
                    paramsKey['duration'] = info.selReplaySecondsAgo;
                    break;
                case "replaySetReplaySpeed":
                    paramsKey['speed'] = info.selReplaySpeed;
                    break;
                case "replaySwitchCamera":
                    paramsKey['lensIndex'] = info.selCameraLens;
                    break;
                case "replayFastForward":
                case "replayFastBackward":
                    paramsKey['offset'] = parseInt(info.selReplayOptSecond)*1000;
                    break;
            }

            info.selFunctionItem.paramsKey = paramsKey;
        }

        replayActionRequestApi(info, e)
    }
});

function replaySetImageAndTitle(e) {
    let replayInfo = e.payload.settings.replayInfo
    console.log('scoreboardInfo', replayInfo);
    let title = ''
    replayInfo = replayInfo || {}
    if (replayInfo.hasOwnProperty('title')) {
        title = String(replayInfo.title)
    }

    if ($SD.localization.replay[title]) {
        $SD.setTitle(e.context, $SD.localization.replay[title])
    } else {
        $SD.setTitle(e.context, title)
    }

    const img = 'image/replay/' + replayInfo.iconPath
    $SD.setImage(e.context, img);
}

replayAction.onWillAppear((e) => {
    const payload = e.payload
    const settings = e.payload.settings
    console.log('replayAction onWillAppear', e)
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    const payloadA = {
        ...payload
      }

      if (settings.hasOwnProperty("replayInfo")) {
        settings.replayInfo.progressValue = settings.replayInfo.progressValue || '0%'
        settings.replayInfo.progress = settings.replayInfo.progress || 0
        payloadA.progressValue = settings.replayInfo.progressValue
        payloadA.progress = settings.replayInfo.progress
      } else {
        settings.replayInfo = {
          progressValue: '0%',
          progress: 0
        }
      }

      payloadA.title = $SD.localization.replay.replayProgress

      $SD.setSettings(e.context, {
        ...settings
      });

      $SD.setFeedback(e.context, payloadA);

    replaySetImageAndTitle(e);


  if (payload.controller === 'Encoder') {
    replayInterval = setInterval(() => {
      // this.getStatemachineVideoDelay(e);
      if (isReplayProgressRotate) {
        isReplayProgressRotate = false
      } else {
        console.log('e', payload, statemachineInfo)

        const stateProgress = parseInt(statemachineInfo.instantReplayStatus.progress * 100)
        settings.replayInfo.progressValue = stateProgress + '%'
        settings.replayInfo.progress = stateProgress

        payloadA.progressValue = stateProgress + '%'
        payloadA.progress = stateProgress

        $SD.setSettings(e.context, {
          ...settings
        });
        $SD.setFeedback(e.context, payloadA);
      }
    }, 1000);
  }
})

replayAction.onWillDisappear((e) => {
    clearInterval(replayInterval)
    replayInterval = null
})

replayAction.onDidReceiveSettings((e) => {
    console.log('replayAction onDidReceiveSettings', e)
    replaySetImageAndTitle(e);

})
function replayActionRequestApi (dataInfo, action) {
    let path = dataInfo.selFunction;
    const selFunctionItem = dataInfo.selFunctionItem;
    if (selFunctionItem.hasOwnProperty('paramsKey')) {
        const paramsKey = selFunctionItem.paramsKey;
        let num = 1;
        path = path + '?'

        for (let key in paramsKey) {
            path = num === 1 ? path + key + '=' + paramsKey[key] : path + '&' + key + '=' + paramsKey[key];
            num++
        }
    }

    console.log('replayAction api', path);
    request(path).then(data => {}).catch(err => {
        $SD.showAlert(action.context)
    });
}

replayAction.onDialRotate((e) => {
    isReplayProgressRotate = true

    let payload = e.payload
    const info = e.payload.settings.replayInfo
    const settings = e.payload.settings

    let progress = info.progress + payload.ticks

    if (progress <= 0) {
      progress = 1
    } else if (progress > 100) {
      progress = 100
    }
    const payloadA = {
      ...payload
    }

    payloadA.progressValue = progress + '%'
    payloadA.progress = progress

    info.progressValue = progress + '%'
    info.progress = progress

    $SD.setFeedback(e.context, payloadA);

    settings.replayInfo = { ...info }
    $SD.setSettings(e.context, {
      ...settings
    });

    seekReplayByProgressApi(progress, e)

  })


  function seekReplayByProgressApi(params, action) {
    request(`/V1.0/replay/seekByProgress?progress=${params / 100}`)
      .then(data => {})
      .catch(err => {
        $SD.showAlert(action.context)
      })
  }
