const sceneAction = new Action('com.magewell.magewell-director.scene');

sceneAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("sceneInfo")) {
    const sceneInfo = settings.sceneInfo
    sceneRequestApi(sceneInfo, e)
  }
});

sceneAction.onWillAppear((e) => {
  const payload = e.payload
  const setting = payload.settings
  console.log('onWillAppear', setting)
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setSceneKeyImageTitle(e)
})


function setSceneKeyImageTitle (e) {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("sceneInfo")) {
    const sceneInfo = settings.sceneInfo

    if (sceneInfo.hasOwnProperty('selFuntionItem')) {
      if (sceneInfo.selFuntionItem.name === 'switchSpecificScene') {
        $SD.setTitle(e.context, sceneInfo.selSceneName)
      } else {
        const title = sceneInfo.selFuntionItem.title
        $SD.setTitle(e.context, $SD.localization.scene[title])
      }

      let pathName = sceneInfo.selFuntionItem.name
      const img = 'image/scene/' + pathName
      $SD.setImage(e.context, img);
    }
  }
}

sceneAction.onDidReceiveSettings((e) => {
  setSceneKeyImageTitle(e)
})
function sceneRequestApi (sceneInfo, action) {
  let path = sceneInfo.selFunction
  if (path === '/V1.0/scene/switchByUUID') {
    path = path + '?uuid=' + sceneInfo.selSceneUuid
  }
  console.log("scene api", path);
  request(path)
    .then(data => {})
    .catch(err => {
      $SD.showAlert(action.context)
    })
}
