const scoreboardAction = new Action('com.magewell.magewell-director.scoreboard');


scoreboardAction.onKeyUp((e) => {
  if (e.payload.settings.hasOwnProperty('scoreboardInfo')) {
    const scoreboardInfo = e.payload.settings.scoreboardInfo
    scoreboardActionRequestApi(scoreboardInfo, e)
  }
});

scoreboardAction.onWillAppear((e) => {
  const payload = e.payload
  const setting = payload.settings
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setScoreboardKeyImageTitle(e)
})

function setScoreboardKeyImageTitle (e) {
  if (e.payload.settings.hasOwnProperty('scoreboardInfo')) {

    let scoreboardInfo = e.payload.settings.scoreboardInfo
    let title = ''
    scoreboardInfo = scoreboardInfo || {}
    if (scoreboardInfo.hasOwnProperty('title')) {
      title = String(scoreboardInfo.title)
    }

    if ($SD.localization.scoreboard[title]) {
      $SD.setTitle(e.context, $SD.localization.scoreboard[title])
    } else {
      $SD.setTitle(e.context, title)
    }

    const img = 'image/scoreboard/' + scoreboardInfo.iconPath
    $SD.setImage(e.context, img);
  }
}


scoreboardAction.onDidReceiveSettings((e) => {
  setScoreboardKeyImageTitle(e)
})
function scoreboardActionRequestApi (info, action) {
  const funItem = info.selFuntionItem
  let selInfo = info.selFuntionItem
  if (funItem.hasOwnProperty('isRequest')) {
    selInfo = info[funItem.isRequest]
  }
  let path = selInfo.value

  if (selInfo.hasOwnProperty('paramsKey')) {
    const paramsKey = selInfo.paramsKey
    let num = 1
    path = path + '?'

    for (let key in paramsKey) {
      path = num === 1 ? path + key + '=' + info[paramsKey[key]] : path + '&' + key + '=' + info[paramsKey[key]]
      num++
    }
  }
  console.log('api ', path);

  request(path)
  .then(data => {})
  .catch(err => {
    $SD.showAlert(action.context)
  })
}
