const shortcutsAction = new Action('com.magewell.magewell-director.shortcuts');

shortcutsAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("shortcutsInfo")) {
    const shortcutsInfo = settings.shortcutsInfo
    shortcutRequestApi(shortcutsInfo, e)
  }
});

shortcutsAction.onWillAppear((e) => {
  const payload = e.payload
  const setting = payload.settings
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setShortcutKeyImageTitle(e)
})


function setShortcutKeyImageTitle (e) {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("shortcutsInfo")) {
    const shortcutsInfo = settings.shortcutsInfo
    let title = shortcutsInfo.title
    
    if ($SD.localization.shortcut[title]) {
      $SD.setTitle(e.context, $SD.localization.volume[title])
    } else {
      $SD.setTitle(e.context, title)
    }
  }
}

shortcutsAction.onDidReceiveSettings((e) => {
  setShortcutKeyImageTitle(e)
})

function shortcutRequestApi (info, action) {
  let path = `/V1.0/shortcuts/action?id=${info.selShortcut}`

  request(path)
    .then(data => {})
    .catch(err => {
      $SD.showAlert(action.context)
    })
}
