
const directorShowAction = new Action('com.magewell.magewell-director.show');

directorShowAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("showInfo")) {
    const settingInfo = settings.showInfo
    showActionRequestApi(settingInfo, e)
  }
});

directorShowAction.onWillAppear((e) => {
  const payload = e.payload
  const settings = e.payload.settings
  if (settings.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = settings.baseURL
    // $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setShowKeyImageTitle(e)
})



function setShowKeyImageTitle (e) {
  var settings = e.payload.settings
  if (settings.hasOwnProperty("showInfo")) {
    let contentInfo = settings.showInfo
    contentInfo = contentInfo || {}

    let title = ''
    if (contentInfo.hasOwnProperty('title')) {
      title = contentInfo.title
    }
    if ($SD.localization.show[title]) {
      $SD.setTitle(e.context, $SD.localization.show[title])
    } else {
      $SD.setTitle(e.context, title)
    }
    const img = 'image/show/' + contentInfo.iconPath
    $SD.setImage(e.context, img);
  }
}

directorShowAction.onDidReceiveSettings((e) => {
  setShowKeyImageTitle(e)
})
function showActionRequestApi (info, action) {
  const selInfo = info.selFuntionItem
  let path = selInfo.value

  if (selInfo.hasOwnProperty('paramsKey')) {
    const paramsKey = selInfo.paramsKey
    path = path + '?'

    for (let key in paramsKey) {
      path = path + key + '=' + info[paramsKey[key]]
      console.log('path', key, info, paramsKey[key])
    }
  }

  request(path)
  .then(data => {})
  .catch(err => {
    $SD.showAlert(action.context)
  })
}
