const stopwatchAction = new Action('com.magewell.magewell-director.stopwatch');
stopwatchAction.onKeyUp((e) => {
    console.log('stopwatch onKeyUp', e)
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("stopwatchInfo")) {
        const stopwatchInfo = settings.stopwatchInfo
        mlwTools.pluginRequestApi(stopwatchInfo, e)
    }
});

function stopwatchSetTitleAndImage(e){
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("stopwatchInfo")) {
        const dataInfo = settings.stopwatchInfo
        if (dataInfo.hasOwnProperty('selFunctionItem')) {
            let pathName = dataInfo.selFunctionItem.name
            const img = 'image/stopwatch/' + pathName
            $SD.setImage(e.context, img);
        }

        let title = ''
        if (dataInfo.hasOwnProperty('title')) {
            title = String(dataInfo.title)
        }

        $SD.setTitle(e.context, $SD.localization.stopwatch[title])
    }
}

stopwatchAction.onWillAppear((e) => {
    const settings = e.payload.settings
    console.log('stopwatch onWillAppear', e)
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    stopwatchSetTitleAndImage(e);
})

stopwatchAction.onDidReceiveSettings((e) => {
    console.log('stopwatch onDidReceiveSettings', e)
    stopwatchSetTitleAndImage(e);
})
