const streamAction = new Action('com.magewell.magewell-director.stream');

streamAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("streamInfo")) {
    const settingInfo = settings.streamInfo
    streamActionRequestApi(settingInfo, e)
  }
});

streamAction.onWillAppear((e) => {
  const payload = e.payload
  const setting = payload.settings
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setStreamKeyImageTitle(e)
})

function setStreamKeyImageTitle (e) {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("streamInfo")) {
    let contentInfo = settings.streamInfo
    contentInfo = contentInfo || {}

    let title = ''
    if (contentInfo.hasOwnProperty('title')) {
      title = contentInfo.title
    }
    if (title) {
      if ($SD.localization.stream[title]) {
        $SD.setTitle(e.context, $SD.localization.stream[title])
      } else {
        $SD.setTitle(e.context, title)
      }
    }
    // const typeArr = {
    //   1: 'youtube',
    //   2: 'twitch',
    //   3: 'facebook',
    //   4: 'rtmp',
    //   5: 'srt',
    //   6: 'ndi'
    // }
    let img = 'image/stream/' + contentInfo.iconPath

    if (contentInfo.selFunction === 'startLiveStreaming' || contentInfo.selFunction === 'stopLiveStreaming') {
      img = 'image/stream/' + contentInfo.selFunction + '-' + contentInfo.selStreamItem.type
    }
    $SD.setImage(e.context, img);
  }
}

streamAction.onDidReceiveSettings((e) => {
  setStreamKeyImageTitle(e)
})
function streamActionRequestApi (info, action) {
  const selInfo = info.selFuntionItem
  let path = selInfo.value

  if (selInfo.hasOwnProperty('paramsKey')) {
    const paramsKey = selInfo.paramsKey
    let num = 1
    path = path + '?'

    for (let key in paramsKey) {
      path = num === 1 ? path + key + '=' + paramsKey[key] : path + '&' + key + '=' + paramsKey[key]
      num++
    }
  }

  request(path)
  .then(data => {})
  .catch(err => {
    $SD.showAlert(action.context)
  })
}
