const timerAction = new Action('com.magewell.magewell-director.timer');
timerAction.onKeyUp((e) => {
    console.log('timerAction onKeyUp', e)
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("timerInfo")) {
        const timerInfo = settings.timerInfo
        mlwTools.pluginRequestApi(timerInfo, e);
    }
});

timerAction.onWillAppear((e) => {
    console.log('timerAction onWillAppear', e)
    const settings = e.payload.settings
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }
    timerSetTitleAndImage(e);
})

function timerSetTitleAndImage(e){
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("timerInfo")) {
        const dataInfo = settings.timerInfo
        if (dataInfo.hasOwnProperty('selFunctionItem')) {
            let pathName = dataInfo.selFunctionItem.name
            const img = 'image/timer/' + pathName
            $SD.setImage(e.context, img);
        }

        let title = ''
        if (dataInfo.hasOwnProperty('title')) {
            title = String(dataInfo.title)
        }

        $SD.setTitle(e.context, $SD.localization.timer[title])
    }
}

timerAction.onDidReceiveSettings((e) => {
    console.log('timerAction onDidReceiveSettings', e)
    timerSetTitleAndImage(e);
})
