const transitionAction = new Action('com.magewell.magewell-director.transition');


transitionAction.onKeyUp((e) => {
  console.log('onKeyUp', e)
  console.log('sceneAction', $SD, $SD.localization)
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("transitionInfo")) {
    const transitionInfo = settings.transitionInfo
    transitionActionRequestApi(transitionInfo, e)
  }
});

transitionAction.onWillAppear((e) => {
  const setting = e.payload.settings
  console.log('onWillAppear', e)
  if (setting.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = setting.baseURL
    $SD.sendToPropertyInspector(e.context, e.action, setting)
  }
  setTransitionKeyImageTitle(e)
})

function setTransitionKeyImageTitle (e) {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("transitionInfo")) {
    let transitionInfo = settings.transitionInfo
    let title = ''
    transitionInfo = transitionInfo || {}
    if (transitionInfo.hasOwnProperty('title')) {
      title = transitionInfo.title
    }
    if (title) {
      if ($SD.localization.transition[title]) {
        $SD.setTitle(e.context, $SD.localization.transition[title])
      } else {
        $SD.setTitle(e.context, title)
      }
    }
    console.log('title', transitionInfo.iconPath)

    // let pathName = transitionInfo.selFuntionItem.name
    const img = 'image/transition/' + transitionInfo.iconPath
    $SD.setImage(e.context, img);
  }
}


transitionAction.onDidReceiveSettings((e) => {
  console.log('onDidReceiveSettings', e)
  setTransitionKeyImageTitle(e)
})
function transitionActionRequestApi (transitionInfo, action) {
  const requestArr = transitionInfo.requestArr
  requestArr.forEach(item => {
    if (transitionInfo.hasOwnProperty(item)) {
      const selInfo = transitionInfo[item]
      console.log('transitionActionRequestApi', requestArr, selInfo, item)
      let path = selInfo.value

      if (selInfo.hasOwnProperty('paramsKey')) {
        const paramsKey = selInfo.paramsKey
        let num = 1
        path = path + '?'

        for (let key in paramsKey) {
          path = num === 1 ? path + key + '=' + paramsKey[key] : path + '&' + key + '=' + paramsKey[key]
          num++
        }
      }

      request(path)
      .then(data => {})
      .catch(err => {
        $SD.showAlert(action.context)
      })
    }
  });
}
