const startStopVideoAction = new Action('com.magewell.magewell-director.video');
var videoInterval = null;
var isVideoProgressRotate = false

startStopVideoAction.onKeyUp((e) => {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("videoInfo")) {
    const settingInfo = settings.videoInfo
    videoActionRequestApi(settingInfo, e)
  }
});

startStopVideoAction.onWillAppear((e) => {
  const payload = e.payload
  const settings = payload.settings
  if (settings.hasOwnProperty('baseURL') && !baseURL) {
    baseURL = settings.baseURL
    // $SD.sendToPropertyInspector(e.context, e.action, setting)
  }

  const payloadA = {
    ...payload
  }

  if (settings.hasOwnProperty("videoInfo")) {
    settings.videoInfo.progressValue = settings.videoInfo.progressValue || '0%'
    settings.videoInfo.progress = settings.videoInfo.progress || 0
    payloadA.progressValue = settings.videoInfo.progressValue
    payloadA.progress = settings.videoInfo.progress
  } else {
    settings.videoInfo = {
      progressValue: '0%',
      progress: 0
    }
  }

  payloadA.title = $SD.localization.video.videoProgress

  $SD.setSettings(e.context, {
    ...settings
  });

  $SD.setFeedback(e.context, payloadA);

  setVideoKeyImageTitle(e)

  if (payload.controller === 'Encoder') {
    videoInterval = setInterval(() => {
      // this.getStatemachineVideoDelay(e);
      if (isVideoProgressRotate) {
        isVideoProgressRotate = false
      } else {
        console.log('videoInterval', payload, statemachineInfo)
      
        const stateProgress = parseInt(statemachineInfo.programVideoPlayStatus.progress)
        settings.videoInfo.progressValue = stateProgress + '%'
        settings.videoInfo.progress = stateProgress

        payloadA.progressValue = stateProgress + '%'
        payloadA.progress = stateProgress

        $SD.setSettings(e.context, {
          ...settings
        });
        $SD.setFeedback(e.context, payloadA);
      }
    }, 1000);
  }
})

startStopVideoAction.onWillDisappear((e) => {
  console.log('onWillDisappear')
  clearInterval(videoInterval)
  videoInterval = null
})

// function getStatemachineVideoDelay (e) {
//   console.log('e', statemachineInfo)
// }

function setVideoKeyImageTitle (e) {
  const settings = e.payload.settings;
  if (settings.hasOwnProperty("videoInfo")) {
    let contentInfo = settings.videoInfo
    contentInfo = contentInfo || {}

    let title = ''
    if (contentInfo.hasOwnProperty('title')) {
      title = contentInfo.title
    }
    if ($SD.localization.video[title]) {
      $SD.setTitle(e.context, $SD.localization.video[title])
    } else {
      $SD.setTitle(e.context, title)
    }
    const img = 'image/video/' + contentInfo.iconPath
    $SD.setImage(e.context, img);
  }
}

startStopVideoAction.onDidReceiveSettings((e) => {
  setVideoKeyImageTitle(e)
})


function videoActionRequestApi (info, action) {
  const selInfo = info.selFuntionItem
  let path = selInfo.value

  if (selInfo.hasOwnProperty('paramsKey')) {
    const paramsKey = selInfo.paramsKey
    let num = 1
    path = path + '?'

    for (let key in paramsKey) {
      let selValue = ''
      if (Object.prototype.toString.call(info[paramsKey[key]]) === '[object Object]') {
        // 是对象
        selValue = info[paramsKey[key]][key]
        console.log('volumeActionRequestApi99999', info[paramsKey[key]], info[paramsKey[key]][key])
      } else {
        selValue = info[paramsKey[key]]
      }

      switch (selInfo.name) {
        case "rewindBySeconds":
        case "jumpToSpecificTime":
        case "fastForwardSeconds":
          selValue = parseInt(selValue) * 1000;
          break;
      }

      path = num === 1 ? path + key + '=' + selValue : path + '&' + key + '=' + selValue
      num++
    }
  }
  request(path).then(data => {}).catch(err => {
    $SD.showAlert(action.context)
  })
}

startStopVideoAction.onDialRotate((e) => {
  isVideoProgressRotate = true
  let payload = e.payload
  const info = e.payload.settings.videoInfo
  const settings = e.payload.settings;

  let progress = info.progress + e.payload.ticks

  if (progress <= 0) {
    progress = 0
  } else if (progress > 100) {
    progress = 100
  }

  const payloadA = {
    ...payload
  }

  payloadA.progressValue = progress + '%'
  payloadA.progress = progress

  info.progressValue = progress + '%'
  info.progress = progress

  $SD.setFeedback(e.context, payloadA);
  settings.videoInfo = { ...info }
  $SD.setSettings(e.context, {
    ...settings
  });

  seekVideoByProgressApi(progress, e)

})


function seekVideoByProgressApi(params, action) {
  request(`/V1.0/scene/seekVideoByProgress?progress=${params / 100}`)
    .then(data => {})
    .catch(err => {
      $SD.showAlert(action.context)
    })
}
