const volumeEncodeAction = new Action('com.magewell.magewell-director.volume');

volumeEncodeAction.onWillAppear((e) => {
    let payload = e.payload
    let settings = e.payload.settings

    ACTION[e.context] = {
      isDelayDispaly: false,
      volumeEncodeInterval: null,
      isAdjuestVolumeRotate: false,
      volumeEncodeInfo: {}
    }

    if (settings.hasOwnProperty('baseURL') && !baseURL) {
      baseURL = settings.baseURL
      $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    const payloadA = {
        ...payload
    }

    payloadA.title = $SD.localization.volume.Volume

    if (settings.hasOwnProperty("volumeEncodeInfo")) {
      settings.volumeEncodeInfo.volumeDB = settings.volumeEncodeInfo.volumeDB || '0dB'
      settings.volumeEncodeInfo.volumeValue = settings.volumeEncodeInfo.volumeValue || 0
      payloadA.volumeDB = settings.volumeEncodeInfo.volumeDB
      payloadA.volumeValue = settings.volumeEncodeInfo.volumeValue
      payloadA.title = settings.volumeEncodeInfo.title
      
      ACTION[e.context].volumeEncodeInfo = settings.volumeEncodeInfo
      $SD.setSettings(e.context, {
        ...settings
      });
    }

    $SD.setFeedback(e.context, payloadA);

    volumeDelaySettingFun(e)
})

function volumeDelaySettingFun (e) {
  const payload = {}
  let settings = e.payload.settings
  if (e.payload.controller == 'Encoder' && (!ACTION[e.context].isDelayDispaly)) {
    ACTION[e.context].volumeEncodeInterval = setInterval(() => {

      if (ACTION[e.context].isAdjuestVolumeRotate) {
        ACTION[e.context].isAdjuestVolumeRotate = false
      } else {
        if (ACTION[e.context].volumeEncodeInfo.hasOwnProperty("selFuntionItem")) {
          const info = ACTION[e.context].volumeEncodeInfo
          const selInfo = info.selFuntionItem
          const paramsKey = selInfo.paramsKey
          const type = info[paramsKey.type]

          const volumeList = volumeConfigList

          payload.volumeDB = 0 + 'dB'
          payload.volumeValue = 0
 
          info.volumeDB = 0 + 'dB'
          info.volumeValue = 0

          if (volumeList.length > 0) {
            volumeList.forEach(item => {
              if (item.audioInfo.type == type) {
                payload.volumeDB = item.audioInfo.volume + 'dB'
                payload.volumeValue = item.audioInfo.volume

                info.volumeDB = item.audioInfo.volume + 'dB'
                info.volumeValue = item.audioInfo.volume
              }
            })
            
            if (info.hasOwnProperty('title')) {
              let title = String(info.title)
              title = title == String(null) ? 'Volume' : title
              payload.title = $SD.localization.volume[title] ? $SD.localization.volume[title] : title
            }
            $SD.setSettings(e.context, {
              baseURL: baseURL,
              networkIsError: settings?.networkIsError??null,
              volumeEncodeInfo: info
            });

            $SD.setFeedback(e.context, payload);
          }
        }
      }
    }, 1000);
  }
}


volumeEncodeAction.onWillDisappear((e) => {
  clearInterval(ACTION[e.context].volumeEncodeInterval)
  ACTION[e.context].volumeEncodeInterval = null
  ACTION[e.context].isDelayDispaly = true
  delete ACTION[e.context]
})


volumeEncodeAction.onDidReceiveSettings((e) => {
  let payload = e.payload
  let settings = e.payload.settings
  if (settings.hasOwnProperty("volumeEncodeInfo")) {
    const info = settings.volumeEncodeInfo
    ACTION[e.context].volumeEncodeInfo = settings.volumeEncodeInfo


    if (info.hasOwnProperty('title')) {
      title = String(info.title)
  
      title = title == String(null) ? '' : title
    }
    const payloadA = {
      ...payload
  }
  
    if ($SD.localization.volume[title]) {
      title = $SD.localization.volume[title]
    }
    payloadA.title = title

    $SD.setFeedback(e.context, payloadA);
  }
})

volumeEncodeAction.onDialRotate((e) => {
    ACTION[e.context].isAdjuestVolumeRotate = true

    let payload = e.payload
    const info = e.payload.settings.volumeEncodeInfo
    let settings = e.payload.settings

    let volumeValue = info.volumeValue + payload.ticks

    if (volumeValue <= -40) {
      volumeValue = -40
    } else if (volumeValue > 10) {
      volumeValue = 10
    }
    const payloadA = {
        ...payload
    }

    if (info.hasOwnProperty('title')) {
      title = String(info.title)

      title = title == String(null) ? '' : title
    }


    if ($SD.localization.volume[title]) {
      title = $SD.localization.volume[title]
    }

    payloadA.volumeDB = volumeValue + 'dB'
    payloadA.volumeValue = volumeValue
    payloadA.title = title

    info.volumeDB = volumeValue + 'dB'
    info.volumeValue = volumeValue

    $SD.setFeedback(e.context, payloadA);
    settings.volumeEncodeInfo = info
    $SD.setSettings(e.context, {
        ...settings
    });

    setVolumeApi(volumeValue, e)
})

function setVolumeApi(params, e) {
    const info = e.payload.settings.volumeEncodeInfo
    const selInfo = info.selFuntionItem
    const paramsKey = selInfo.paramsKey
    const type = info[paramsKey.type]

    request(`/V1.0/volume/setVolume?type=${type}&volume=${params}`)
      .then(data => {})
      .catch(err => {
          $SD.showAlert(e.context)
      })
}
