const webpageAction = new Action('com.magewell.magewell-director.webpage');

webpageAction.onKeyUp((e) => {
    console.log('webpage onKeyUp', e)
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("webpageInfo")) {
        const webpageInfo = settings.webpageInfo
        const { selFunction, selFunctionItem } = webpageInfo;
        // 如果是 Zoom in / Zoom out 则需要重新设置值并操作
        if(selFunction === '/V1.0/graphics/doScale' ) {
            const { name } = selFunctionItem;
            let scale = 1;
            // 去拿轮训里面的值去操作.
            if(statemachineInfo.hasOwnProperty("htmlControlStatus") && statemachineInfo.htmlControlStatus.scale) {
                scale = parseFloat(statemachineInfo.htmlControlStatus.scale);
                scale = scale * 100;
                // 范围为 0.3 - 5.0  => 30 - 500
                if(name === "webZoomOut") {
                    scale = scale - 10;
                } else {
                    scale = scale + 10;
                }

                if(scale <= 30) {
                    scale = 30;
                } else if(scale >= 500) {
                    scale = 500;
                }

                scale = (scale / 100).toFixed(2);
            }

            webpageInfo.selFunctionItem.paramsKey.scale = scale;
        }

        webpageActionRequestApi(webpageInfo, e)
    }
});

webpageAction.onWillAppear((e) => {
    const settings = e.payload.settings;
    console.log('webpage onWillAppear', e)
    if (settings.hasOwnProperty('baseURL') && !baseURL) {
        baseURL = settings.baseURL
        $SD.sendToPropertyInspector(e.context, e.action, settings)
    }

    webpageSetTitleAndImage(e);
})

function webpageSetTitleAndImage(e)
{
    const settings = e.payload.settings;
    if (settings.hasOwnProperty("webpageInfo")) {
        const dataInfo = settings.webpageInfo
        if (dataInfo.hasOwnProperty('selFunctionItem')) {
            let pathName = dataInfo.selFunctionItem.name
            const img = 'image/webpage/' + pathName
            $SD.setImage(e.context, img);
        }

        let title = ''
        if (dataInfo.hasOwnProperty('title')) {
            title = String(dataInfo.title)
        }

        if ($SD.localization.webpage[title]) {
            $SD.setTitle(e.context, $SD.localization.webpage[title])
        } else {
            $SD.setTitle(e.context, title)
        }
    }
}

webpageAction.onDidReceiveSettings((e) => {
    console.log('webpage onDidReceiveSettings', e)
    webpageSetTitleAndImage(e);
})
function webpageActionRequestApi (transitionInfo, action) {
    let path = transitionInfo.selFunction;
    const selFunctionItem = transitionInfo.selFunctionItem;
    if (selFunctionItem.hasOwnProperty('paramsKey')) {
        const paramsKey = selFunctionItem.paramsKey;
        let num = 1;
        path = path + '?'

        for (let key in paramsKey) {
            path = num === 1 ? path + key + '=' + paramsKey[key] : path + '&' + key + '=' + paramsKey[key];
            num++
        }
    }

    console.log('webpage api', path);
    request(path).then(data => {}).catch(err => {
        $SD.showAlert(action.context)
    });
}
