const mlwTools = {
    // 封装 dropDown
    dropDown: function(PI, id, optList, labelKey, valueKey, selValue = null){
        let select = document.getElementById(id);
        select.innerHTML = '';
        select.appendChild(mlwTools.dropDownOption(PI, optList, labelKey, valueKey, selValue));
    },

    // 封装 dropDown 下拉选项
    dropDownOption: function(PI, optList, labelKey, valueKey, selValue = null){
        let frag = document.createDocumentFragment();
        for (var i = 0; i < optList.length; i++) {
            let item = optList[i];
            let option = document.createElement("option");

            // 下拉列表是否需要配置文案
            option.innerHTML = PI ? PI[item[labelKey]] : item[labelKey];
            option.value = item[valueKey];
            if (selValue !== null && selValue == item[valueKey]) {
                option.selected = true
            }
            frag.appendChild(option); //将设置好的 option插入文档片段。
        }
        return frag;
    },

    // 设置相关功能对应Dom的显影
    // 参数：list 列表   sel 选择的参数
    controlFunctionDisplay: function (list, sel) {
        list.forEach(item => {
            console.log('111', list, sel, document.getElementById(item.name))
            if (item.value === sel) {
                if (document.getElementById(item.name)) {
                    document.getElementById(item.name).style.display = 'inline-flex'
                }
            } else {
                if (document.getElementById(item.name)) {
                    document.getElementById(item.name).style.display = 'none'
                }
            }
        })
    },

    // 判断是否请求需要携带参数
    // functionItem: 选择的option对象   value功能参数   key:变更对象名称
    isRequestNeedParams: function (functionItem, value, key, requestParams) {
        let res = null
        if (functionItem.hasOwnProperty('paramsKey') && value) {

            res = {
                [functionItem.paramsKey]: value
            }
        }
        return res
    },
    /**
     * 判断是否为空对象
     *
     * @param {*} obj 要判断的对象
     * @returns 当对象为{}时返回true，否则返回false
     */
    isEmptyObject: function (obj) {
        for (const key in obj) {
        return false
        }
        return true
    },
    // 设置相关功能对应多个Dom的显影
    // 参数：list 列表   sel 选择的参数
    domArrFunctionDisplay: function (list, listKey, sel) {
        list.forEach(item => {
            if (item.hasOwnProperty('domId')) {
                const domArr = item.domId
                if (item[listKey] === sel) {
                    domArr.forEach(dom => {
                        if (document.getElementById(dom)) {
                            document.getElementById(dom).style.display = 'inline-flex'
                        }
                    })
                } else {
                    domArr.forEach(dom => {
                        if (document.getElementById(dom)) {
                            document.getElementById(dom).style.display = 'none'
                        }
                    })
                }
            }
        })
    },

    /**
     * 时间转为秒
     * @param time 时间(00:00:00)
     * @returns {string} 时间戳（单位：秒）
     */
    formatTimeToSec: function (time) {
        var s = '';

        var hour = time.split(':')[0];
        var min = time.split(':')[1];
        var sec = time.split(':')[2];

        s = Number(hour*3600) + Number(min*60) + Number(sec);

        return s;
    },
    // 判断是否有下一级，有下一级去找下一级文字
    findNextFunTitle: function (info, selFuntionItem, titleKey = 'title') {
        let title = selFuntionItem.title
        if (selFuntionItem.hasOwnProperty('isNext')) {
            let applyNextOptionItem = info[selFuntionItem.isNext]
            if (Object.prototype.toString.call(applyNextOptionItem) === '[object Object]') {
              // 如果是对象则是下拉选择框

              if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
                title = applyNextOptionItem[titleKey]
              }
            } else {
              // 不是对象，直接获取
              title = String(applyNextOptionItem) ? applyNextOptionItem : title
            }
        }
        return title
    },
    // 判断是否有下一级，有下一级去找下一级文字
    findNextFunIconPath: function (info, selFuntionItem) {
        let path = selFuntionItem.path
        if (selFuntionItem.hasOwnProperty('pathNext')) {
            let applyNextOptionItem = info[selFuntionItem.pathNext]
            console.log('findNextFunIconPath', applyNextOptionItem, selFuntionItem, info)
            if (Object.prototype.toString.call(applyNextOptionItem) === '[object Object]') {
                // 如果是对象则是下拉选择框
                if (!mlwTools.isEmptyObject(applyNextOptionItem)) {
                    path = applyNextOptionItem.path
                }
            }
        }
        return path
    },
    // 插件请求 api 方式, 自动封装参数以及 url
    pluginRequestApi(dataInfo, action, callback = null){
        let { selFunction, selFunctionItem } = dataInfo;
        if (selFunctionItem.hasOwnProperty('paramsKey')) {
            const paramsKey = selFunctionItem.paramsKey;
            let tempArr = [];
            for (let key in paramsKey) {
                tempArr.push(key+'='+paramsKey[key]);
            }
            selFunction = selFunction + "?" +  tempArr.join('&');
        }

        console.log('RequestApi', selFunction);
        request(selFunction).then(data => {
        }).catch(err => {
            $SD.showAlert(action.context)
        });
    },
    // 封装显示隐藏规则
    divSwitchShowOrHideRule: function (allDivIdArr, divRuleArr, optionValueKey) {
        if(allDivIdArr.length && Object.keys(divRuleArr).length) {
            let checkDivArr = divRuleArr[optionValueKey] ?? [];
            console.log(allDivIdArr)
            console.log(divRuleArr)
            console.log(checkDivArr)
            if(checkDivArr.length) {
                // 显示
                checkDivArr.forEach(item => {
                    document.getElementById(item).style.display = 'inline-flex'
                })
                // 隐藏
                allDivIdArr.forEach(item => {
                    if(!checkDivArr.includes(item)) {
                        document.getElementById(item).style.display = 'none'
                    }
                })
            } else {
                // 隐藏
                allDivIdArr.forEach(item => {
                    document.getElementById(item).style.display = 'none'
                })
            }
        }
    }
}
